"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AiOpenaiHook = void 0;
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var openai_1 = require("openai");
var operators_1 = require("rxjs/operators");
var AiOpenaiHook = /** @class */ (function (_super) {
    __extends(AiOpenaiHook, _super);
    function AiOpenaiHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AiOpenaiHook.prototype.createCompletion = function (inputArtifact) {
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var configuration = new openai_1.Configuration({
                apiKey: settings.openai.apiKey
            });
            var openai = new openai_1.OpenAIApi(configuration);
            return (0, rxjs_1.from)(openai.createCompletion({
                model: inputArtifact.object.model ? inputArtifact.object.model : 'text-davinci-002',
                prompt: inputArtifact.object.prompt,
                temperature: inputArtifact.object.temperature,
                max_tokens: inputArtifact.object.maxTokens ? inputArtifact.object.maxTokens : 6
            }))
                .pipe((0, operators_1.map)(function (response) {
                var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
                outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                outputArtifact.object = response.data;
                return outputArtifact;
            }));
        }));
    };
    AiOpenaiHook.prototype.createChatCompletion = function (inputArtifact) {
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var configuration = new openai_1.Configuration({
                apiKey: settings.openai.apiKey
            });
            var openai = new openai_1.OpenAIApi(configuration);
            return (0, rxjs_1.from)(openai.createChatCompletion({
                model: inputArtifact.object.model ? inputArtifact.object.model : 'text-davinci-003',
                messages: inputArtifact.object.messages,
                temperature: inputArtifact.object.temperature,
                presence_penalty: inputArtifact.object.presence_penalty,
                top_p: inputArtifact.object.top_p,
                max_tokens: inputArtifact.object.maxTokens ? inputArtifact.object.maxTokens : 6
            }))
                .pipe((0, operators_1.map)(function (response) {
                var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
                outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                outputArtifact.object = response.data;
                return outputArtifact;
            }));
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('8496025f-3200-4d1e-8ab5-335243a134fb')
    ], AiOpenaiHook.prototype, "createCompletion", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('ac6b677c-ef03-40f6-b064-e00bf7f2e91f')
    ], AiOpenaiHook.prototype, "createChatCompletion", null);
    AiOpenaiHook = __decorate([
        (0, nick_process_commons_1.HookClass)('ai.openai')
    ], AiOpenaiHook);
    return AiOpenaiHook;
}(nick_process_commons_1.BaseHook));
exports.AiOpenaiHook = AiOpenaiHook;
//# sourceMappingURL=ai.openai.hook.js.map