"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrayHook = void 0;
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var ArrayHook = /** @class */ (function () {
    function ArrayHook() {
    }
    ArrayHook.prototype.concat = function (input) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ARRAY;
        outputArtifact.object = [];
        input.object.data.map(function (item) {
            outputArtifact.object = outputArtifact.object.concat(item);
        });
        return (0, rxjs_1.of)(outputArtifact);
    };
    ArrayHook.prototype.map = function (input) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        if (!input.object.data || !(input.object.data instanceof Array))
            input.object.data = [];
        outputArtifact.object = input.object.data.map(function (obj) {
            return input.object.config.valueAField.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, obj);
        });
        return (0, rxjs_1.of)(outputArtifact);
    };
    ArrayHook.prototype.removeDuplicates = function (input) {
        var _a, _b;
        if (((_a = input.object.config) === null || _a === void 0 ? void 0 : _a.returnObjects) == true) {
            var uniqueValues_1 = new Set();
            var uniqueObjects_1 = [];
            input.object.data.forEach(function (obj) {
                var _a;
                var fieldValue = ((_a = input.object.config) === null || _a === void 0 ? void 0 : _a.field) ?
                    input.object.config.field.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, obj)
                    : obj;
                if (!uniqueValues_1.has(fieldValue)) {
                    uniqueValues_1.add(fieldValue);
                    uniqueObjects_1.push(obj);
                }
            });
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = uniqueObjects_1;
            return (0, rxjs_1.of)(outputArtifact);
        }
        else {
            var value = input.object.data;
            if (((_b = input.object.config) === null || _b === void 0 ? void 0 : _b.field) && (input.object.data instanceof Array))
                value = input.object.data
                    .map(function (_value) {
                    var _a;
                    return (_a = input.object.config) === null || _a === void 0 ? void 0 : _a.field.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, _value);
                });
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = __spreadArray([], __read(new Set(value)), false);
            return (0, rxjs_1.of)(outputArtifact);
        }
    };
    ArrayHook.prototype.filterIncludes = function (input) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        var valueAField = input.object.config.valueAField;
        var result = [];
        for (var i = 0; i < input.object.data.length; i++) {
            for (var j = 0; j < input.object.config.filterArray.length; j++) {
                if (valueAField) {
                    if (input.object.config.filterArray[j][valueAField] == input.object.data[i][valueAField]) {
                        result.push(input.object.data[i]);
                        break;
                    }
                }
                else {
                    if (input.object.config.filterArray[j] == input.object.data[i]) {
                        result.push(input.object.data[i]);
                        break;
                    }
                }
            }
        }
        outputArtifact.object = result;
        return (0, rxjs_1.of)(outputArtifact);
    };
    ArrayHook.prototype.filter = function (input) {
        var inputArtifact = new nick_process_commons_1.NickProcessArtfact();
        var valueA = input.object.config.valueA;
        var valueB = input.object.config.valueB;
        inputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        inputArtifact.object = input.object.data.filter(function (item) {
            if (input.object.config.valueAField)
                valueA = input.object.config.valueAField.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, item);
            if (input.object.config.valueBField)
                valueB = input.object.config.valueBField.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, item);
            return nick_data_commons_1.NickCalculate.applyCondition(valueA, valueB, input.object.config.conditionKind);
        });
        return (0, rxjs_1.of)(inputArtifact);
    };
    ArrayHook.prototype.createFromTemplate = function (inputArtifact) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = {};
        var size = inputArtifact.object.data.size;
        var template = inputArtifact.object.data.template;
        var templateReplace = inputArtifact.object.data.templateReplace;
        var data = [];
        var _loop_1 = function (i) {
            var item = Object.assign({}, template);
            // when flow foreach hook support index, this block of code can be called separately
            if (templateReplace && templateReplace.length > 0) {
                var _loop_2 = function (templateIndex) {
                    var replaceItem = templateReplace[templateIndex];
                    var replaceItemValue = replaceItem.config.template;
                    if (typeof replaceItemValue == 'string') {
                        Object.keys(replaceItem.data).forEach(function (key) {
                            var keyWithBrackets = '{{' + key + '}}';
                            if (key == '__currentIndex') {
                                replaceItemValue = replaceItemValue.replace(keyWithBrackets, i + 1);
                            }
                            else if (key == '__totalIndex') {
                                replaceItemValue = replaceItemValue.replace(keyWithBrackets, size);
                            }
                            else {
                                replaceItemValue = replaceItemValue.replace(keyWithBrackets, replaceItem.data[key]);
                            }
                        });
                        item[replaceItem.key] = replaceItemValue;
                    }
                };
                for (var templateIndex = 0; templateIndex < templateReplace.length; templateIndex++) {
                    _loop_2(templateIndex);
                }
            }
            data.push(item);
        };
        for (var i = 0; i < size; i++) {
            _loop_1(i);
        }
        outputArtifact.object.data = data;
        return (0, rxjs_1.of)(outputArtifact);
    };
    ArrayHook.prototype.push = function (inputArtifact) {
        if (!inputArtifact.object.data.array)
            inputArtifact.object.data.array = [];
        inputArtifact.object.data.array.push(inputArtifact.object.data.item);
        return (0, rxjs_1.of)(inputArtifact);
    };
    ArrayHook.prototype.splice = function (inputArtifact) {
        inputArtifact.object.data = inputArtifact.object.data.splice(inputArtifact.object.config.start, inputArtifact.object.config.end);
        return (0, rxjs_1.of)(inputArtifact);
    };
    ArrayHook.prototype.sortArrayObjects = function (inputArtifact) {
        var input = inputArtifact.object.data;
        var config = inputArtifact.object.config.fields;
        var type = inputArtifact.object.config.type ? inputArtifact.object.config.type : 'any';
        var _orderByComparator = function (a, b, type) {
            if (a === null || typeof a === 'undefined')
                a = 0;
            if (b === null || typeof b === 'undefined')
                b = 0;
            if (type == 'date') {
                a = a != 0 ? new Date(a).getTime() : new Date(8640000000000000).getTime();
                b = b != 0 ? new Date(b).getTime() : new Date(8640000000000000).getTime();
            }
            if ((isNaN(parseFloat(a)) || !isFinite(a)) || (isNaN(parseFloat(b)) || !isFinite(b))) {
                // Isn't a number so lowercase the string to properly compare
                if (a.toLowerCase() < b.toLowerCase())
                    return -1;
                if (a.toLowerCase() > b.toLowerCase())
                    return 1;
            }
            else {
                // Parse strings as numbers to compare properly
                if (parseFloat(a) < parseFloat(b))
                    return -1;
                if (parseFloat(a) > parseFloat(b))
                    return 1;
            }
            return 0; // equal each other
        };
        if (!input)
            return input;
        var value = __spreadArray([], __read(input), false);
        if (!Array.isArray(value))
            return value;
        if (!Array.isArray(config) || (Array.isArray(config) && config.length === 1)) {
            var propertyToCheck = !Array.isArray(config) ? config : config[0];
            var desc_1 = propertyToCheck.substr(0, 1) === '-';
            var field_1 = propertyToCheck.substr(1);
            if (propertyToCheck || propertyToCheck === '-' || propertyToCheck === '+') {
                value.sort(function (a, b) {
                    var reduceA = field_1.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, a);
                    var reduceB = field_1.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, b);
                    // input.object.config.valueAField.split('.').reduce((o: any, i: any) => (o ? o[i] : o), obj);
                    return !desc_1 ? inputArtifact.object.data = _orderByComparator(reduceA, reduceB, type) : inputArtifact.object.data = _orderByComparator(reduceA, reduceB, type);
                }).reverse();
                inputArtifact.object.data = !desc_1 ? value.sort() : value.sort().reverse();
                return (0, rxjs_1.of)(inputArtifact);
            }
            else {
                var property = propertyToCheck.substr(0, 1) === '+' || propertyToCheck.substr(0, 1) === '-'
                    ? propertyToCheck.substr(1) : propertyToCheck;
                value.sort(function (a, b) {
                    var reduceA = field_1.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, a);
                    var reduceB = field_1.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, b);
                    // input.object.config.valueAField.split('.').reduce((o: any, i: any) => (o ? o[i] : o), obj);
                    return !desc_1 ? inputArtifact.object.data = _orderByComparator(reduceA, reduceB, type) : inputArtifact.object.data = _orderByComparator(reduceA, reduceB, type);
                }).reverse();
                inputArtifact.object.data = !desc_1 ? value.sort() : value.sort().reverse();
                return (0, rxjs_1.of)(inputArtifact);
            }
        }
        else {
            inputArtifact.object.data = value.sort(function (a, b) {
                // tslint:disable-next-line:prefer-for-of
                for (var i = 0; i < config.length; i++) {
                    var desc = config[i].substr(0, 1) === '-';
                    var property = config[i].substr(0, 1) === '+' || config[i].substr(0, 1) === '-'
                        ? config[i].substr(1)
                        : config[i];
                    var reduceA = property.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, a);
                    var reduceB = property.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, b);
                    var comparison = !desc
                        ? _orderByComparator(reduceA, reduceB, type)
                        : -_orderByComparator(reduceA, reduceB, type);
                    // Don't return 0 yet in case of needing to sort by next property
                    if (comparison !== 0)
                        return comparison;
                }
                return 0;
            });
            return (0, rxjs_1.of)(inputArtifact);
        }
    };
    ArrayHook.prototype.arrayApply = function (inputArtifact) {
        var _a;
        var data = inputArtifact.object.data;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        if (data instanceof Array) {
            // @ts-ignore
            outputArtifact.object = (_a = Array.prototype[inputArtifact.object.config.name]).apply.apply(_a, __spreadArray([], __read(data), false));
        }
        else {
            // @ts-ignore
            outputArtifact.object = Array.prototype[inputArtifact.object.config.name].apply(data);
        }
        return (0, rxjs_1.of)(outputArtifact);
    };
    ArrayHook.prototype.getAtPosition = function (inputArtifact) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = inputArtifact.object.data[inputArtifact.object.index];
        return (0, rxjs_1.of)(outputArtifact);
    };
    ArrayHook.prototype.spreadArray = function (inputArtifact) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = {};
        var flattenDeep = function (arr1) {
            return arr1.reduce(function (acc, val) { return Array.isArray(val) ? acc.concat(flattenDeep(val)) : acc.concat(val); }, []);
        };
        outputArtifact.object.data = flattenDeep(inputArtifact.object.data);
        return (0, rxjs_1.of)(outputArtifact);
    };
    ArrayHook.prototype.hashMap = function (inputArtifact) {
        var _a, _b;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = new Map();
        var field = (_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.field.split('.');
        (_b = inputArtifact.object.data) === null || _b === void 0 ? void 0 : _b.forEach(function (value) {
            var keyField = field.reduce(function (o, i) { return (o ? o[i] : o); }, value);
            outputArtifact.object.set(keyField, value);
        });
        return (0, rxjs_1.of)(outputArtifact);
    };
    ArrayHook.prototype.hashMapApply = function (input) {
        var _a;
        var data = input.object.data;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        // @ts-ignore
        if (data instanceof Array) {
            // @ts-ignore
            outputArtifact.object = (_a = input.object.map)[input.object.config.name].apply(_a, __spreadArray([], __read(data), false));
        }
        else {
            // @ts-ignore
            outputArtifact.object = input.object.map[input.object.config.name](data);
        }
        return (0, rxjs_1.of)(outputArtifact);
    };
    ArrayHook.prototype.arrayFromMap = function (input) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = Array.from(input.object.map.values());
        return (0, rxjs_1.of)(outputArtifact);
    };
    ArrayHook.prototype.concatEqualObjects = function (input) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        var array = input.object.data;
        var finalObject = __assign({}, array[0]); // copy the first object
        // Start from the second object in the array
        for (var i = 1; i < array.length; i++) {
            var obj = array[i];
            // Iterate over the keys of the object
            for (var key in obj) {
                // Check if a property with the same key already exists in finalObject
                if (finalObject.hasOwnProperty(key)) {
                    // If it exists, concatenate the value
                    for (var j = 0; j < obj[key].length; j++) {
                        finalObject[key].push(obj[key][j]);
                    }
                }
                else {
                    // If it doesn't exist, create a new property and add it to finalObject
                    finalObject[key] = obj[key];
                }
            }
        }
        outputArtifact.object = finalObject;
        return (0, rxjs_1.of)(outputArtifact);
    };
    ArrayHook.prototype.updateAttrObject = function (inputArtifact) {
        // Cria uma cópia de `data` para preservar a integridade do objeto original
        var data = Object.assign({}, inputArtifact.object.data);
        var editAttributes = inputArtifact.object.edit; // editar Atributos
        var newAttributes = inputArtifact.object.new; // adicionar Atributos
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        // Verifica se `data` é um objeto válido
        if (data && typeof data === 'object' && !Array.isArray(data)) {
            // Atualiza os valores existentes com base em `edit`
            if (editAttributes && typeof editAttributes === 'object') {
                Object.keys(editAttributes).forEach(function (chave) {
                    if (data.hasOwnProperty(chave)) {
                        data[chave] = editAttributes[chave];
                    }
                });
            }
            // Adiciona novos atributos com base em `new`
            if (newAttributes && typeof newAttributes === 'object') {
                Object.keys(newAttributes).forEach(function (chave) {
                    if (!data.hasOwnProperty(chave)) {
                        data[chave] = newAttributes[chave];
                    }
                });
            }
            // Atribui o objeto atualizado ao `outputArtifact`
            outputArtifact.object = data;
        }
        else {
            // Caso `data` não seja válido, retorna o input sem alterações
            outputArtifact.object = inputArtifact.object.data;
        }
        return (0, rxjs_1.of)(outputArtifact);
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('761d2bb0-2e19-48fb-8b88-c4b8d3995fd9')
    ], ArrayHook.prototype, "concat", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('d1044107-ef2a-4fd1-8e95-05f037201aa4')
    ], ArrayHook.prototype, "map", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('a3a80a71-3559-42b4-94dd-e4da0bc09ec6')
    ], ArrayHook.prototype, "removeDuplicates", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('94e55c04-578d-404c-9e66-a069713550be')
    ], ArrayHook.prototype, "filterIncludes", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('eab8089b-818c-43ab-b895-72184f999b90')
    ], ArrayHook.prototype, "filter", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('2c7c4b23-0f5a-44dd-ac06-c4a87c67aed3')
    ], ArrayHook.prototype, "createFromTemplate", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('9e2b565a-7b21-42c1-84bc-c705c42a60ee')
    ], ArrayHook.prototype, "push", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('aa2efbb4-2a7c-4976-aaee-b928b2142463')
    ], ArrayHook.prototype, "splice", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('6e557fcc-5e6d-4578-96f0-632a56eb1cab')
    ], ArrayHook.prototype, "sortArrayObjects", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('f767eac4-e5bc-478e-a913-f83047990df3')
    ], ArrayHook.prototype, "arrayApply", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('9c768082-d461-4ec4-8278-7884c865ddcd')
    ], ArrayHook.prototype, "getAtPosition", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('209fe875-5666-4be8-a478-6b0776f84d0c')
    ], ArrayHook.prototype, "spreadArray", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('6bdd56c8-5e3e-457f-874f-7d722c8dfde0')
    ], ArrayHook.prototype, "hashMap", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('bf6ad501-6f2e-4280-81ac-a3146f01e2dc')
    ], ArrayHook.prototype, "hashMapApply", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('a016ad34-e7b9-4f51-93d8-de6dfb0d1760')
    ], ArrayHook.prototype, "arrayFromMap", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('38937bbc-3578-4ca2-bb00-c384f9a23e77')
    ], ArrayHook.prototype, "concatEqualObjects", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('38f6ed98-9757-406a-83aa-b75d12cebd38')
    ], ArrayHook.prototype, "updateAttrObject", null);
    ArrayHook = __decorate([
        (0, nick_process_commons_1.HookClass)('entity')
    ], ArrayHook);
    return ArrayHook;
}());
exports.ArrayHook = ArrayHook;
//# sourceMappingURL=array.hook.js.map