"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var bcrypt_1 = __importDefault(require("bcrypt"));
var jsonwebtoken_1 = __importDefault(require("jsonwebtoken"));
var http_hook_1 = require("../http/http.hook");
var AuthHook = /** @class */ (function (_super) {
    __extends(AuthHook, _super);
    function AuthHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AuthHook.prototype.register = function (inputArtifact) {
        return this.service('AuthService')
            .pipe((0, operators_1.concatMap)(function (service) {
            var user = {
                username: inputArtifact.object.username,
                name: inputArtifact.object.name,
                email: inputArtifact.object.email,
                password: inputArtifact.object.password,
                phone: inputArtifact.object.phone
            };
            return service.register(user, inputArtifact.object.ruleGroup);
        })).pipe((0, operators_1.map)(function (any) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = any;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.registerUserWithSystem = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            var user = {
                username: inputArtifact.object.username,
                name: inputArtifact.object.name,
                email: inputArtifact.object.email,
                password: inputArtifact.object.password,
                phone: inputArtifact.object.phone
            };
            return service.registerUser(user, inputArtifact.object.ruleGroup, inputArtifact.object.systemId);
        })).pipe((0, operators_1.map)(function (any) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = any;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.currentUser = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () { return _this.context.user; }))
            .pipe((0, operators_1.map)(function (user) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = user;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.isAuthenticate = function (inputArtifact) {
        return this.context.user.pipe((0, operators_1.map)(function (user) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = user;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.changePassword = function (inputArtifact) {
        return this.service('AuthService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.changePassword(inputArtifact.object.data);
        }))
            .pipe((0, operators_1.map)(function (user) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = user;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.deleteUserSystemXref = function (inputArtifact) {
        return this.service('AuthService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.deleteUserSystemXref(inputArtifact.object.userId);
        }))
            .pipe((0, operators_1.map)(function (user) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = user;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.activateUserSystemXref = function (inputArtifact) {
        return this.service('AuthService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.activateUserSystemXref(inputArtifact.object.userId);
        }))
            .pipe((0, operators_1.map)(function (user) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = user;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.changeRuleGroup = function (inputArtifact) {
        return this.service('UserService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.changeRuleGroup(inputArtifact.object.userId, inputArtifact.object.ruleGroupId);
        })).pipe((0, operators_1.map)(function (any) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = any;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.authenticate = function (inputArtifact) {
        return this.service('AuthService')
            .pipe((0, operators_1.concatMap)(function (service) {
            var _a;
            var authData = inputArtifact.object;
            if (inputArtifact.object.config)
                authData = inputArtifact.object.data;
            return service.authenticate(authData, (_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.generateToken);
        })).pipe((0, operators_1.map)(function (any) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = any;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.authenticateBySystemId = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            var _a;
            var authData = inputArtifact.object;
            if (inputArtifact.object.config)
                authData = inputArtifact.object.data;
            return service.authenticateUser(authData, (_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.generateToken, authData.systemId);
        })).pipe((0, operators_1.map)(function (any) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = any;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.createJWT = function (inputArtifact) {
        if (!inputArtifact.object.options)
            inputArtifact.object.options = { expiresIn: inputArtifact.object.expireTime };
        return (0, rxjs_1.of)(jsonwebtoken_1.default.sign(inputArtifact.object.payload, inputArtifact.object.secret, inputArtifact.object.options))
            .pipe((0, operators_1.map)(function (token) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = token;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.verifyJWT = function (inputArtifact) {
        return (0, rxjs_1.of)(jsonwebtoken_1.default.verify(inputArtifact.object.token, inputArtifact.object.secret, inputArtifact.object.options))
            .pipe((0, operators_1.map)(function (jwtPayload) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = jwtPayload;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.decodeJWT = function (inputArtifact) {
        return (0, rxjs_1.of)(jsonwebtoken_1.default.decode(inputArtifact.object.token, inputArtifact.object.options))
            .pipe((0, operators_1.map)(function (jwtPayload) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = jwtPayload;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.hashPassword = function (inputArtifact) {
        var _a;
        return (0, rxjs_1.from)(bcrypt_1.default.hash(inputArtifact.object.password, (_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.saltRounds))
            .pipe((0, operators_1.map)(function (hash) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.object = { password: hash };
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return outputArtifact;
        }));
    };
    AuthHook.prototype.matchPassword = function (inputArtifact) {
        return (0, rxjs_1.from)(bcrypt_1.default.compare(inputArtifact.object.password, inputArtifact.object.passwordHash))
            .pipe((0, operators_1.map)(function (match) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.object = { match: match };
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return outputArtifact;
        }));
    };
    AuthHook.prototype.requestOTP = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.requestOTP(inputArtifact.object.userId, inputArtifact.object.expire);
        }))
            .pipe((0, operators_1.map)(function (otp) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = otp;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.authenticateByOTP = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.authenticateByOTP(inputArtifact.object.userId, inputArtifact.object.otp);
        }))
            .pipe((0, operators_1.map)(function (otp) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = otp;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.countUsers = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.countUsers(inputArtifact.object.systemId);
        }))
            .pipe((0, operators_1.map)(function (otp) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = otp;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.getUserListBySystem = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.getUserListBySystem(inputArtifact.object.systemId, inputArtifact.object.page, inputArtifact.object.pageSize, inputArtifact.object.smartSearch, inputArtifact.object.filters, inputArtifact.object.sortCreatedAsc);
        }))
            .pipe((0, operators_1.map)(function (data) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = data;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.registerParentUser = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            var parentUser = {
                userId: inputArtifact.object.userId,
                parentUserId: inputArtifact.object.parentUserId
            };
            return service.registerParentUser(parentUser, inputArtifact.object.systemId);
        })).pipe((0, operators_1.map)(function (any) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = any;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.registerGroupUser = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            var user = {
                username: inputArtifact.object.username,
                name: inputArtifact.object.name,
                email: inputArtifact.object.email,
                password: inputArtifact.object.password,
                picture: inputArtifact.object.picture,
                phone: inputArtifact.object.phone
            };
            return service.registerGroupUser(user, inputArtifact.object.ruleGroup, inputArtifact.object.systemId);
        })).pipe((0, operators_1.map)(function (any) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = any;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.getGroupUser = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.getGroupUser(inputArtifact.object.userId, inputArtifact.object.systemId);
        })).pipe((0, operators_1.map)(function (any) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = any;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.validateRole = function (inputArtifact) {
        var role = inputArtifact.object.role;
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.validateRole(inputArtifact.object.role);
        }));
    };
    AuthHook.prototype.getUsersByRole = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.getUsersByRole(inputArtifact.object.role, inputArtifact.object.systemId);
        }));
    };
    AuthHook.prototype.removeRoleFromUser = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.removeRoleFromUser(inputArtifact.object.userId, inputArtifact.object.roleId, inputArtifact.object.systemId);
        }));
    };
    AuthHook.prototype.addRoleToUser = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.addRoleToUser(inputArtifact.object.userId, inputArtifact.object.roleId, inputArtifact.object.systemId);
        }));
    };
    AuthHook.prototype.checkUserGroup = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.checkUserGroup(inputArtifact.object.systemId, inputArtifact.object.userGroup);
        }));
    };
    AuthHook.prototype.createMD5Hash = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.createMD5Hash(inputArtifact.object.userId);
        }));
    };
    AuthHook.prototype.disableParentUser = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.disableParentUser(inputArtifact.object.systemId, inputArtifact.object.userId, inputArtifact.object.parentUserId);
        })).pipe((0, operators_1.map)(function (any) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = any;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.getUsersByUserGroup = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.getUsersByUserGroup(inputArtifact.object.userGroupId, inputArtifact.object.systemId, inputArtifact.object.page, inputArtifact.object.pageSize);
        })).pipe((0, operators_1.map)(function (any) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = any;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.getRolesBySystem = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.getRolesBySystem(inputArtifact.object.systemId, inputArtifact.object.page, inputArtifact.object.pageSize);
        })).pipe((0, operators_1.map)(function (any) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = any;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.getRole = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.getRole(inputArtifact.object.userId, inputArtifact.object.systemId);
        })).pipe((0, operators_1.map)(function (any) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = any;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.currentUserBySystem = function (inputArtifact) {
        var _this = this;
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.getUserDetailByToken(_this.context.token.split(' ')[1], inputArtifact.object.systemId);
        })).pipe((0, operators_1.map)(function (any) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = any;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.lockUser = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.lockUser(inputArtifact.object.locked, inputArtifact.object.userId, inputArtifact.object.systemId);
        })).pipe((0, operators_1.map)(function (any) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = any;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.unlockUser = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.unlockUser(inputArtifact.object.userId, inputArtifact.object.systemId);
        })).pipe((0, operators_1.map)(function (any) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = any;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.getUserSystem = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.getUserSystem(inputArtifact.object.systemId);
        })).pipe((0, operators_1.map)(function (any) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = any;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    AuthHook.prototype.generateTokenToSystemUser = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://api.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://api.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/b89d7183-cbe5-404f-b0d0-5a500b18c394"),
                        params: {},
                        headers: {
                            'nick-system': '774bfaa5-fab2-4528-80f1-293afb8eb71d',
                            'authorization': _this.context.token
                        },
                        body: inputArtifact.object,
                        statusError: [404, 401]
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('0ecd88d0-c7ed-4143-8b65-bdfde168e696')
    ], AuthHook.prototype, "register", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('f77d6f51-4512-4b2b-ba0d-9865b7136d95')
    ], AuthHook.prototype, "registerUserWithSystem", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('1cdf25af-af0e-48c4-b75c-1ba9f392bf11')
    ], AuthHook.prototype, "currentUser", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('ee9d59fa-06ec-4c54-8618-460972c5de35')
    ], AuthHook.prototype, "isAuthenticate", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('3b67e154-148d-44fc-b54f-853898360724')
    ], AuthHook.prototype, "changePassword", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('42a98a04-4fb0-4664-8115-19fb345fe54d')
    ], AuthHook.prototype, "deleteUserSystemXref", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('89fc7399-76e3-42c2-b328-d3b2247c0906')
    ], AuthHook.prototype, "activateUserSystemXref", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('448e67c1-c1b7-4cfb-af7c-226c4f9718ac')
    ], AuthHook.prototype, "changeRuleGroup", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('9845b850-ce51-41e3-9071-f9397ae65192')
    ], AuthHook.prototype, "authenticate", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('0d964fe9-9a75-4b10-86d0-9e358c8badfa')
    ], AuthHook.prototype, "authenticateBySystemId", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('3b66ee2a-2a1f-4d16-89a2-645d5a0de4bf')
    ], AuthHook.prototype, "createJWT", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('05ff8278-66e8-4d99-a6c8-fbb5ae529b1f')
    ], AuthHook.prototype, "verifyJWT", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('1fc763d2-2597-49a8-93bb-6f49b8e9a396')
    ], AuthHook.prototype, "decodeJWT", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('fd930116-954b-413c-8522-bbc3be3af7d7')
    ], AuthHook.prototype, "hashPassword", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('0394faad-d6a8-4146-883d-bed524d15afd')
    ], AuthHook.prototype, "matchPassword", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('87f696d4-d6aa-4272-923d-eaf265b0d884')
    ], AuthHook.prototype, "requestOTP", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('1e3af2dc-1c1e-4781-8292-8700647bed9a')
    ], AuthHook.prototype, "authenticateByOTP", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('f1226e9b-36ff-45bb-9ef0-8e4ab01e0015')
    ], AuthHook.prototype, "countUsers", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('fe22127d-35ec-44f3-be34-348398d65a23')
    ], AuthHook.prototype, "getUserListBySystem", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('8e17d805-aeac-4f7c-95a0-912b1b02e8f1')
    ], AuthHook.prototype, "registerParentUser", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('2eff1fa2-3960-400b-89e8-0e535d144bf5')
    ], AuthHook.prototype, "registerGroupUser", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('e5e6fb53-e159-4945-a907-6b253788752d')
    ], AuthHook.prototype, "getGroupUser", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('d8616750-910c-4a36-bc06-0a7cf384a10d')
    ], AuthHook.prototype, "validateRole", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('fc6b1077-9bed-48b2-9957-823bb466c2d8')
    ], AuthHook.prototype, "getUsersByRole", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('30fed985-75ee-4f37-9e26-cf5c68099865')
    ], AuthHook.prototype, "removeRoleFromUser", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('05211b69-f26d-4f3c-8555-16ee103b20be')
    ], AuthHook.prototype, "addRoleToUser", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('87fc28fb-d21f-4e68-9dc9-f73b3bc1b7f0')
    ], AuthHook.prototype, "checkUserGroup", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('ff3a8cd7-44d7-42a4-af89-75f4074902c4')
    ], AuthHook.prototype, "createMD5Hash", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('f70ee3e5-2064-4402-bb41-3542c9a194a3')
    ], AuthHook.prototype, "disableParentUser", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('4090e320-b0ba-4ed6-8d10-0717b76b2923')
    ], AuthHook.prototype, "getUsersByUserGroup", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('196d7d1c-206b-480f-a5e1-102ed37f5a10')
    ], AuthHook.prototype, "getRolesBySystem", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('b72f3b83-ce14-41d1-a4c8-f719e8c1eeaf')
    ], AuthHook.prototype, "getRole", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('4211ffad-af50-46d9-aa5c-4a8f1ff7897d')
    ], AuthHook.prototype, "currentUserBySystem", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('aafec36c-d0fd-4c9c-9212-2893ad1a6403')
    ], AuthHook.prototype, "lockUser", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('ced78c48-82d3-4bec-b97f-72c0de5c9e4c')
    ], AuthHook.prototype, "unlockUser", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('2c4e91b3-8913-49a2-9a78-e2b7306430d6')
    ], AuthHook.prototype, "getUserSystem", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('b89d7183-cbe5-404f-b0d0-5a500b18c394')
    ], AuthHook.prototype, "generateTokenToSystemUser", null);
    AuthHook = __decorate([
        (0, nick_process_commons_1.HookClass)('auth')
    ], AuthHook);
    return AuthHook;
}(nick_process_commons_1.BaseHook));
exports.AuthHook = AuthHook;
//# sourceMappingURL=auth.hook.js.map