"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AwsRekognitionHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var AWS = __importStar(require("aws-sdk"));
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var AwsRekognitionHook = /** @class */ (function (_super) {
    __extends(AwsRekognitionHook, _super);
    function AwsRekognitionHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AwsRekognitionHook.prototype.rekognition = function (inputArtifact) {
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var rkn = new AWS.Rekognition({
                params: { Bucket: settings.aws.bucketName },
                region: 'us-east-1',
                credentials: { accessKeyId: settings.aws.accessKeyId, secretAccessKey: settings.aws.secretAccessKey }
            });
            return new rxjs_1.Observable(function (observer) {
                var bucketName;
                if (inputArtifact.object.config && inputArtifact.object.config.bucket)
                    bucketName = inputArtifact.object.config.bucket;
                var params = {
                    SourceImage: {
                        S3Object: {
                            Bucket: "".concat(bucketName ? bucketName : settings.aws.bucketName),
                            Name: inputArtifact.object.data.source.key
                        }
                    },
                    TargetImage: {
                        S3Object: {
                            Bucket: "".concat(bucketName ? bucketName : settings.aws.bucketName),
                            Name: inputArtifact.object.data.target.key
                        }
                    },
                    SimilarityThreshold: 70
                };
                rkn.compareFaces(params, function (err, response) {
                    if (err) {
                        observer.error(err);
                    }
                    else {
                        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
                        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                        outputArtifact.object = response;
                        observer.next(outputArtifact);
                    }
                    observer.complete();
                });
            });
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('6433d7a3-8c80-4563-bb03-fe804df22b78')
    ], AwsRekognitionHook.prototype, "rekognition", null);
    AwsRekognitionHook = __decorate([
        (0, nick_process_commons_1.HookClass)('aws.rekognition')
    ], AwsRekognitionHook);
    return AwsRekognitionHook;
}(nick_process_commons_1.BaseHook));
exports.AwsRekognitionHook = AwsRekognitionHook;
//# sourceMappingURL=aws.rekognition.hook.js.map