"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AwsS3Hook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var s3_1 = __importDefault(require("aws-sdk/clients/s3"));
var node_fs_1 = require("node:fs");
var mime_types_1 = __importDefault(require("mime-types"));
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var uuid_1 = require("uuid");
var AwsS3Hook = /** @class */ (function (_super) {
    __extends(AwsS3Hook, _super);
    function AwsS3Hook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AwsS3Hook.prototype.upload = function (inputArtifact) {
        var _this = this;
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var s3bucket = _this.buildS3Bucket(settings);
            return _this.system
                .pipe((0, operators_1.concatMap)(function (system) {
                var today = new Date();
                var itemId = (0, uuid_1.v4)();
                if (inputArtifact.object.id)
                    itemId = inputArtifact.object.id;
                var bucketName;
                var bucket = "/system/".concat(system.id, "/").concat(today.getFullYear(), "/").concat(today.getMonth(), "/").concat(today.getDate());
                var extension = mime_types_1.default.extension(inputArtifact.object.contentType);
                if (extension === false && inputArtifact.object.contentType == 'application/x-zip-compressed')
                    extension = 'zip';
                var key = "".concat(itemId, ".").concat(extension);
                if (inputArtifact.object.config && inputArtifact.object.config.bucket)
                    bucketName = inputArtifact.object.config.bucket;
                if (inputArtifact.object.config && inputArtifact.object.config.key)
                    key = inputArtifact.object.config.key;
                var alreadyBuffer = inputArtifact.object.buffer instanceof Buffer
                    || inputArtifact.object.buffer instanceof node_fs_1.ReadStream;
                var params = {
                    Bucket: "".concat(bucketName ? bucketName : settings.aws.bucketName).concat(bucketName ? '' : '/' + settings.aws.bucketPrefix).concat(bucketName ? '' : bucket),
                    ContentType: inputArtifact.object.contentType,
                    Key: key,
                    Body: alreadyBuffer ? inputArtifact.object.buffer : Buffer.from(inputArtifact.object.buffer, 'binary')
                };
                if (inputArtifact.object.config && inputArtifact.object.config.publicRead)
                    params.ACL = 'public-read';
                return new rxjs_1.Observable(function (observer) {
                    try {
                        s3bucket.upload(params, function (err, data) {
                            if (err) {
                                observer.error(err);
                            }
                            else {
                                var output = new nick_process_commons_1.NickProcessArtfact();
                                output.kind = nick_data_commons_1.ArtfactKind.ANY;
                                output.object = {
                                    data: {
                                        id: itemId,
                                        fileName: params.Key,
                                        key: data.Key
                                    }
                                };
                                if (inputArtifact.object.config && inputArtifact.object.config.publicRead)
                                    output.object.data.publicFile = data.Location;
                                observer.next(output);
                            }
                            observer.complete();
                        });
                    }
                    catch (e) {
                        console.log(e);
                    }
                });
            }));
        }));
    };
    AwsS3Hook.prototype.delete = function (inputArtifact) {
        var _this = this;
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var _a, _b;
            var s3bucket = _this.buildS3Bucket(settings);
            var key = ((_a = inputArtifact.object) === null || _a === void 0 ? void 0 : _a.key)
                ? inputArtifact.object.config.key.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, inputArtifact.object)
                : inputArtifact.object;
            var ignoreEnv = (_b = inputArtifact.object.config) === null || _b === void 0 ? void 0 : _b.ignoreEnv;
            if (!ignoreEnv && key.indexOf("develop/") == -1 && key.indexOf("production/") == -1)
                key = "".concat(settings.aws.bucketPrefix, "/").concat(key);
            var options = {
                Bucket: inputArtifact.object.config && inputArtifact.object.config.bucket
                    ? inputArtifact.object.config.bucket
                    : settings.aws.bucketName,
                Delete: {
                    Objects: [
                        {
                            Key: key
                        }
                    ]
                }
            };
            return (0, rxjs_1.from)(s3bucket.deleteObjects(options).promise())
                .pipe((0, operators_1.concatMap)(function (data) {
                var output = new nick_process_commons_1.NickProcessArtfact();
                output.kind = nick_data_commons_1.ArtfactKind.DOWNLOAD;
                output.object = data;
                return (0, rxjs_1.of)(output);
            }));
        }));
    };
    AwsS3Hook.prototype.getUploadInfo = function (inputArtifact) {
        var _this = this;
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            return _this.system
                .pipe((0, operators_1.map)(function (system) {
                var today = new Date();
                var itemId = (0, uuid_1.v4)();
                var bucketName;
                var bucket = "/system/".concat(system.id, "/").concat(today.getFullYear(), "/").concat(today.getMonth(), "/").concat(today.getDate());
                var extension = mime_types_1.default.extension(inputArtifact.object.contentType);
                if (extension === false && inputArtifact.object.contentType == 'application/x-zip-compressed')
                    extension = 'zip';
                var key = "".concat(itemId, ".").concat(extension);
                if (inputArtifact.object.config && inputArtifact.object.config.bucket)
                    bucketName = inputArtifact.object.config.bucket;
                if (inputArtifact.object.config && inputArtifact.object.config.key)
                    key = inputArtifact.object.config.key;
                var alreadyBuffer = inputArtifact.object.buffer instanceof Buffer
                    || inputArtifact.object.buffer instanceof node_fs_1.ReadStream;
                var params = {
                    Bucket: "".concat(bucketName ? bucketName : settings.aws.bucketName).concat(bucketName ? '' : '/' + settings.aws.bucketPrefix).concat(bucketName ? '' : bucket),
                    ContentType: inputArtifact.object.contentType,
                    Key: key
                };
                if (inputArtifact.object.config && inputArtifact.object.config.publicRead)
                    params.ACL = 'public-read';
                var output = new nick_process_commons_1.NickProcessArtfact();
                output.kind = nick_data_commons_1.ArtfactKind.ANY;
                output.object = {
                    params: params,
                    credentials: {
                        params: { Bucket: settings.aws.bucketName },
                        apiVersion: '2006-03-01',
                        region: 'us-east-1',
                        credentials: { accessKeyId: settings.aws.accessKeyId, secretAccessKey: settings.aws.secretAccessKey }
                    }
                };
                return output;
            }));
        }));
    };
    AwsS3Hook.prototype.download = function (inputArtifact) {
        var _this = this;
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var s3bucket = _this.buildS3Bucket(settings);
            var options = {
                Bucket: inputArtifact.object.config && inputArtifact.object.config.bucket
                    ? inputArtifact.object.config.bucket
                    : settings.aws.bucketName,
                Key: inputArtifact.object.config && inputArtifact.object.config.key
                    ? inputArtifact.object.config.key.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, inputArtifact.object)
                    : inputArtifact.object.data.key
            };
            var output = new nick_process_commons_1.NickProcessArtfact();
            output.kind = nick_data_commons_1.ArtfactKind.DOWNLOAD;
            output.object = s3bucket.getObject(options).createReadStream();
            return (0, rxjs_1.of)(output);
        }));
    };
    AwsS3Hook.prototype.downloadToBuffer = function (inputArtifact) {
        var _this = this;
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var s3bucket = _this.buildS3Bucket(settings);
            var options = {
                Bucket: inputArtifact.object.config && inputArtifact.object.config.bucket
                    ? inputArtifact.object.config.bucket
                    : settings.aws.bucketName,
                Key: inputArtifact.object.config && inputArtifact.object.config.key
                    ? inputArtifact.object.config.key.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, inputArtifact.object)
                    : inputArtifact.object.data.key
            };
            return (0, rxjs_1.from)(s3bucket.getObject(options).promise())
                .pipe((0, operators_1.concatMap)(function (data) {
                var _a;
                var output = new nick_process_commons_1.NickProcessArtfact();
                output.kind = nick_data_commons_1.ArtfactKind.DOWNLOAD;
                output.object = data.Body;
                switch ((_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.output) {
                    case 'string':
                        output.object = data.Body.toString();
                        break;
                    case 'base64':
                        output.object = data.Body.toString('base64');
                        break;
                    case 'file': {
                        if (inputArtifact.object.config.fileName)
                            _this.context.response.attachment(inputArtifact.object.config.fileName);
                        _this.context.response.type(data.ContentType);
                        output.kind = nick_data_commons_1.ArtfactKind.ANY;
                        output.object = new nick_process_commons_1.NickProcessArtfact();
                        output.object.kind = 10;
                        output.object.object = data.Body;
                        break;
                    }
                }
                return (0, rxjs_1.of)(output);
            }));
        }));
    };
    AwsS3Hook.prototype.downloadBase64 = function (inputArtifact) {
        var _this = this;
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var s3bucket = _this.buildS3Bucket(settings);
            var options = {
                Bucket: inputArtifact.object.config && inputArtifact.object.config.bucket
                    ? inputArtifact.object.config.bucket
                    : settings.aws.bucketName,
                Key: inputArtifact.object.config && inputArtifact.object.config.key
                    ? inputArtifact.object.config.key.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, inputArtifact.object)
                    : inputArtifact.object.data.key
            };
            var ignoreEnv = inputArtifact.object.config && inputArtifact.object.config.ignoreEnv;
            if (!ignoreEnv && options.Key.indexOf("develop/") == -1 && options.Key.indexOf("production/") == -1)
                options.Key = "".concat(settings.aws.bucketPrefix, "/").concat(options.Key);
            return (0, rxjs_1.from)(s3bucket.getObject(options).promise())
                .pipe((0, operators_1.concatMap)(function (data) {
                var output = new nick_process_commons_1.NickProcessArtfact();
                output.kind = nick_data_commons_1.ArtfactKind.DOWNLOAD;
                output.key = options.Key;
                output.object = data.Body.toString('base64');
                return (0, rxjs_1.of)(output);
            }));
        }));
    };
    AwsS3Hook.prototype.downloadJson = function (inputArtifact) {
        var _this = this;
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var s3bucket = _this.buildS3Bucket(settings);
            var options = {
                Bucket: inputArtifact.object.config && inputArtifact.object.config.bucket
                    ? inputArtifact.object.config.bucket
                    : settings.aws.bucketName,
                Key: inputArtifact.object.config && inputArtifact.object.config.key
                    ? inputArtifact.object.config.key.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, inputArtifact.object)
                    : inputArtifact.object.data.key
            };
            var ignoreEnv = inputArtifact.object.config && inputArtifact.object.config.ignoreEnv;
            if (!ignoreEnv && options.Key.indexOf("develop/") == -1 && options.Key.indexOf("production/") == -1)
                options.Key = "".concat(settings.aws.bucketPrefix, "/").concat(options.Key);
            return (0, rxjs_1.from)(s3bucket.getObject(options).promise())
                .pipe((0, operators_1.concatMap)(function (data) {
                var output = new nick_process_commons_1.NickProcessArtfact();
                output.kind = nick_data_commons_1.ArtfactKind.DOWNLOAD;
                output.key = options.Key;
                output.object = JSON.parse(data.Body);
                return (0, rxjs_1.of)(output);
            }));
        }));
    };
    AwsS3Hook.prototype.link = function (inputArtifact) {
        var _this = this;
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var s3bucket = _this.buildS3Bucket(settings);
            var options = {
                Bucket: settings.aws.bucketName,
                Key: inputArtifact.object.key,
                Expires: 950400
            };
            return (0, rxjs_1.of)(s3bucket.getSignedUrl('getObject', options))
                .pipe((0, operators_1.concatMap)(function (url) {
                var output = new nick_process_commons_1.NickProcessArtfact();
                output.kind = nick_data_commons_1.ArtfactKind.ANY;
                output.object = url;
                return (0, rxjs_1.of)(output);
            }));
        }));
    };
    AwsS3Hook.prototype.buildS3Bucket = function (settings) {
        return new s3_1.default({
            params: { Bucket: settings.aws.bucketName },
            apiVersion: '2006-03-01',
            region: 'us-east-1',
            credentials: { accessKeyId: settings.aws.accessKeyId, secretAccessKey: settings.aws.secretAccessKey }
        });
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('2ac9a89e-3c6a-4b51-8eb3-3a09ea4793f2')
    ], AwsS3Hook.prototype, "upload", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('53997a50-b6e2-4a74-b4f2-25f167ea9526')
    ], AwsS3Hook.prototype, "delete", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('c74e4e92-7273-4a83-82ce-3dc25907435d')
    ], AwsS3Hook.prototype, "getUploadInfo", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('e824dc3c-0b01-4e1a-a754-69ae0025ca55')
    ], AwsS3Hook.prototype, "download", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('5baf3595-1514-4890-9f8f-4ff267bee4c6')
    ], AwsS3Hook.prototype, "downloadToBuffer", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('8fa98cd4-d743-4931-8df9-2ca961df3e9a')
    ], AwsS3Hook.prototype, "downloadBase64", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('35fb1c27-5848-46e2-bc42-8b7792235866')
    ], AwsS3Hook.prototype, "downloadJson", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('90fe5318-0773-418f-9233-044c9cb2913d')
    ], AwsS3Hook.prototype, "link", null);
    AwsS3Hook = __decorate([
        (0, nick_process_commons_1.HookClass)('aws.s3')
    ], AwsS3Hook);
    return AwsS3Hook;
}(nick_process_commons_1.BaseHook));
exports.AwsS3Hook = AwsS3Hook;
//# sourceMappingURL=aws.s3.hook.js.map