"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AwsSnsHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var aws = __importStar(require("aws-sdk"));
var nodemailer_1 = require("nodemailer");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var AwsSnsHook = /** @class */ (function (_super) {
    __extends(AwsSnsHook, _super);
    function AwsSnsHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AwsSnsHook.prototype.sendSms = function (inputArtifact) {
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var sns = new aws.SNS({
                region: 'us-east-1',
                apiVersion: '2010-03-31',
                credentials: { accessKeyId: settings.aws.accessKeyId, secretAccessKey: settings.aws.secretAccessKey }
            });
            return new rxjs_1.Observable(function (observer) {
                sns.setSMSAttributes({
                    attributes: {
                        DefaultSMSType: 'Transactional',
                        UsageReportS3Bucket: 'nick-sns-daily-usage',
                        DefaultSenderID: 'nick-fw'
                    }
                });
                var params = {
                    PhoneNumber: inputArtifact.object.data.to,
                    Message: inputArtifact.object.data.body,
                    MessageStructure: 'string'
                };
                sns.publish(params, function (err, data) {
                    if (err) {
                        var uploadArtifact = new nick_process_commons_1.NickProcessArtfact();
                        uploadArtifact.kind = nick_data_commons_1.ArtfactKind.ERROR;
                        uploadArtifact.object = err;
                        observer.error(uploadArtifact);
                    }
                    else {
                        var uploadArtifact = new nick_process_commons_1.NickProcessArtfact();
                        uploadArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                        uploadArtifact.object = data;
                        observer.next(uploadArtifact);
                    }
                    observer.complete();
                });
            });
        }));
    };
    AwsSnsHook.prototype.sendEmail = function (inputArtifact) {
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var ses = new aws.SES({
                region: 'us-east-1',
                apiVersion: '2010-12-01',
                credentials: { accessKeyId: settings.aws.accessKeyId, secretAccessKey: settings.aws.secretAccessKey }
            });
            return new rxjs_1.Observable(function (observer) {
                var mailOptions = {
                    from: inputArtifact.object.data.from,
                    subject: inputArtifact.object.data.subject,
                    html: inputArtifact.object.data.body,
                    to: inputArtifact.object.data.to
                };
                if (inputArtifact.object.data.attachments) {
                    mailOptions.attachments = inputArtifact.object.data.attachments;
                }
                var transporter = (0, nodemailer_1.createTransport)({
                    SES: ses
                });
                transporter.sendMail(mailOptions, function (err, data) {
                    if (err) {
                        observer.error(err);
                    }
                    else {
                        var uploadArtifact = new nick_process_commons_1.NickProcessArtfact();
                        uploadArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                        uploadArtifact.object = data;
                        observer.next(uploadArtifact);
                    }
                    observer.complete();
                });
            });
        }));
    };
    AwsSnsHook.prototype.registerDevice = function (inputArtifact) {
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var sns = new aws.SNS({
                region: 'us-east-1',
                apiVersion: '2010-03-31',
                credentials: { accessKeyId: settings.aws.accessKeyId, secretAccessKey: settings.aws.secretAccessKey }
            });
            if (!inputArtifact.object.config.arn)
                inputArtifact.object.config.arn = 'arn:aws:sns:us-east-1:003198923998:app/GCM/nick-app';
            return new rxjs_1.Observable(function (observer) {
                var params = {
                    PlatformApplicationArn: inputArtifact.object.config.arn,
                    Token: inputArtifact.object.data.token,
                    Attributes: {}
                };
                sns.createPlatformEndpoint(params, function (err, data) {
                    if (err) {
                        observer.error(err);
                    }
                    else {
                        var uploadArtifact = new nick_process_commons_1.NickProcessArtfact();
                        uploadArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                        uploadArtifact.object = data;
                        observer.next(uploadArtifact);
                    }
                    observer.complete();
                });
            });
        }));
    };
    AwsSnsHook.prototype.sendPush = function (inputArtifact) {
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var sns = new aws.SNS({
                region: 'us-east-1',
                apiVersion: '2010-03-31',
                credentials: { accessKeyId: settings.aws.accessKeyId, secretAccessKey: settings.aws.secretAccessKey }
            });
            return new rxjs_1.Observable(function (observer) {
                var jsonMessage = {
                    // tslint:disable-next-line
                    'GCM': '{ "notification": { "title": "' + inputArtifact.object.data.title + '", "body": "' + inputArtifact.object.data.message + '" } }'
                };
                var params = {
                    Message: JSON.stringify(jsonMessage),
                    MessageStructure: 'json',
                    TargetArn: inputArtifact.object.data.token
                };
                sns.publish(params, function (err, data) {
                    if (err) {
                        observer.error(err);
                    }
                    else {
                        var uploadArtifact = new nick_process_commons_1.NickProcessArtfact();
                        uploadArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                        uploadArtifact.object = data;
                        observer.next(uploadArtifact);
                    }
                    observer.complete();
                });
            });
        }));
    };
    AwsSnsHook.prototype.registerTopic = function (inputArtifact) {
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var sns = new aws.SNS({
                region: 'us-east-1',
                apiVersion: '2010-03-31',
                credentials: { accessKeyId: settings.aws.accessKeyId, secretAccessKey: settings.aws.secretAccessKey }
            });
            var envPrefix = settings.environment == nick_data_commons_1.EnvironmentKind.DEV ? 'develop' : 'production';
            var topicName = "nick-".concat(envPrefix, "-").concat(inputArtifact.object.config.name, "-sns");
            return new rxjs_1.Observable(function (observer) {
                sns.createTopic({ Name: topicName }, function (err, data) {
                    if (err) {
                        observer.error(err);
                    }
                    else {
                        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
                        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                        outputArtifact.object = data;
                        observer.next(outputArtifact);
                    }
                    observer.complete();
                });
            });
        }));
    };
    AwsSnsHook.prototype.subscribeTopic = function (inputArtifact) {
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var sns = new aws.SNS({
                region: 'us-east-1',
                apiVersion: '2010-03-31',
                credentials: { accessKeyId: settings.aws.accessKeyId, secretAccessKey: settings.aws.secretAccessKey }
            });
            var params = {
                TopicArn: inputArtifact.object.config.arn,
                Protocol: inputArtifact.object.config.protocol,
                Endpoint: inputArtifact.object.config.endpoint
            };
            return new rxjs_1.Observable(function (observer) {
                sns.subscribe(params, function (err, data) {
                    if (err) {
                        observer.error(err);
                    }
                    else {
                        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
                        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                        outputArtifact.object = data;
                        observer.next(outputArtifact);
                    }
                    observer.complete();
                });
            });
        }));
    };
    AwsSnsHook.prototype.confirmTopicSubscription = function (inputArtifact) {
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var sns = new aws.SNS({
                region: 'us-east-1',
                apiVersion: '2010-03-31',
                credentials: { accessKeyId: settings.aws.accessKeyId, secretAccessKey: settings.aws.secretAccessKey }
            });
            var params = {
                TopicArn: inputArtifact.object.config.arn,
                Token: inputArtifact.object.config.token,
                AuthenticateOnUnsubscribe: 'true'
            };
            return new rxjs_1.Observable(function (observer) {
                sns.confirmSubscription(params, function (err, data) {
                    if (err) {
                        observer.error(err);
                    }
                    else {
                        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
                        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                        outputArtifact.object = data;
                        observer.next(outputArtifact);
                    }
                    observer.complete();
                });
            });
        }));
    };
    AwsSnsHook.prototype.publishTopicNotification = function (inputArtifact) {
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var sns = new aws.SNS({
                region: 'us-east-1',
                apiVersion: '2010-03-31',
                credentials: { accessKeyId: settings.aws.accessKeyId, secretAccessKey: settings.aws.secretAccessKey }
            });
            var params = {
                Message: inputArtifact.object.data,
                TopicArn: inputArtifact.object.config.arn
            };
            return new rxjs_1.Observable(function (observer) {
                sns.publish(params, function (err, data) {
                    if (err) {
                        observer.error(err);
                    }
                    else {
                        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
                        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                        outputArtifact.object = data;
                        observer.next(outputArtifact);
                    }
                    observer.complete();
                });
            });
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('ca9e10f9-9d90-410d-abee-46170f58fbed')
    ], AwsSnsHook.prototype, "sendSms", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('f7c89c5e-2583-4fa2-9bed-9663a5bc4e69')
    ], AwsSnsHook.prototype, "sendEmail", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('6c8f2fd8-1d6c-4bcd-bb65-634395b9f02b')
    ], AwsSnsHook.prototype, "registerDevice", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('85f41db6-b425-4f8d-ba3a-10c3b0f27984')
    ], AwsSnsHook.prototype, "sendPush", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('d1e1ccac-2e89-441b-9e5e-eb96f1679dbc')
    ], AwsSnsHook.prototype, "registerTopic", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('5b7f7dfb-333a-4e69-96fe-2d2cbd3ce2f5')
    ], AwsSnsHook.prototype, "subscribeTopic", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('35ff2926-7b0d-48bc-830b-f187731f8398')
    ], AwsSnsHook.prototype, "confirmTopicSubscription", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('be817b4f-051e-4329-8e18-ac62d97798b5')
    ], AwsSnsHook.prototype, "publishTopicNotification", null);
    AwsSnsHook = __decorate([
        (0, nick_process_commons_1.HookClass)('aws.sns')
    ], AwsSnsHook);
    return AwsSnsHook;
}(nick_process_commons_1.BaseHook));
exports.AwsSnsHook = AwsSnsHook;
//# sourceMappingURL=aws.sns.hook.js.map