"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AwsSqsHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var aws = __importStar(require("aws-sdk"));
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var AwsSqsHook = /** @class */ (function (_super) {
    __extends(AwsSqsHook, _super);
    function AwsSqsHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AwsSqsHook.prototype.createQueue = function (inputArtifact) {
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var sqs = new aws.SQS({
                region: 'us-east-1',
                apiVersion: '2012-11-05',
                credentials: { accessKeyId: settings.aws.accessKeyId, secretAccessKey: settings.aws.secretAccessKey }
            });
            var envPrefix = settings.environment == nick_data_commons_1.EnvironmentKind.DEV ? 'develop' : 'production';
            var params = {
                QueueName: "nick-".concat(envPrefix, "-").concat(inputArtifact.object.config.name, "-sqs"),
                Attributes: {
                    'VisibilityTimeout': '3600',
                    'MessageRetentionPeriod': '86400'
                }
            };
            return new rxjs_1.Observable(function (observer) {
                sqs.createQueue(params, function (err, data) {
                    if (err) {
                        observer.error(err);
                    }
                    else {
                        var uploadArtifact = new nick_process_commons_1.NickProcessArtfact();
                        uploadArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                        uploadArtifact.object = data;
                        observer.next(uploadArtifact);
                    }
                    observer.complete();
                });
            });
        }));
    };
    AwsSqsHook.prototype.receiveMessage = function (inputArtifact) {
        var result$ = new rxjs_1.Subject();
        this.settings
            .pipe((0, operators_1.map)(function (settings) {
            var sqs = new aws.SQS({
                region: 'us-east-1',
                apiVersion: '2012-11-05',
                credentials: { accessKeyId: settings.aws.accessKeyId, secretAccessKey: settings.aws.secretAccessKey }
            });
            var params = {
                AttributeNames: [
                    'nick-system',
                    'nick-authorization',
                    'nick-controller',
                    'nick-method'
                ],
                MaxNumberOfMessages: inputArtifact.object.config.messageCount,
                MessageAttributeNames: [
                    'All'
                ],
                QueueUrl: inputArtifact.object.config.queueUrl,
                VisibilityTimeout: 3600,
                WaitTimeSeconds: 0
            };
            sqs.receiveMessage(params, function (err, data) {
                if (err) {
                    //
                }
                else {
                    var uploadArtifact = new nick_process_commons_1.NickProcessArtfact();
                    uploadArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                    uploadArtifact.object = data;
                    result$.next(uploadArtifact);
                }
            });
        })).subscribe();
        return result$;
    };
    AwsSqsHook.prototype.deleteMessage = function (inputArtifact) {
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var sqs = new aws.SQS({
                region: 'us-east-1',
                apiVersion: '2012-11-05',
                credentials: { accessKeyId: settings.aws.accessKeyId, secretAccessKey: settings.aws.secretAccessKey }
            });
            var params = {
                QueueUrl: inputArtifact.object.config.queueUrl,
                ReceiptHandle: inputArtifact.object.config.receiptHandle
            };
            return new rxjs_1.Observable(function (observer) {
                sqs.deleteMessage(params, function (err, data) {
                    if (err) {
                        observer.error(err);
                    }
                    else {
                        var uploadArtifact = new nick_process_commons_1.NickProcessArtfact();
                        uploadArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                        uploadArtifact.object = data;
                        observer.next(uploadArtifact);
                    }
                    observer.complete();
                });
            });
        }));
    };
    AwsSqsHook.prototype.sendMessage = function (inputArtifact) {
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var sqs = new aws.SQS({
                region: 'us-east-1',
                apiVersion: '2012-11-05',
                credentials: { accessKeyId: settings.aws.accessKeyId, secretAccessKey: settings.aws.secretAccessKey }
            });
            var params = {
                MessageAttributes: {
                    'nick-system': {
                        DataType: 'String',
                        StringValue: inputArtifact.object.config.attributes.systemId
                    },
                    'nick-authorization': {
                        DataType: 'String',
                        StringValue: inputArtifact.object.config.attributes.authorization
                    },
                    'nick-controller': {
                        DataType: 'String',
                        StringValue: inputArtifact.object.config.attributes.controller
                    },
                    'nick-method': {
                        DataType: 'String',
                        StringValue: inputArtifact.object.config.attributes.method
                    }
                },
                MessageBody: inputArtifact.object.data,
                QueueUrl: inputArtifact.object.config.queueUrl
            };
            return new rxjs_1.Observable(function (observer) {
                sqs.sendMessage(params, function (err, data) {
                    if (err) {
                        observer.error(err);
                    }
                    else {
                        var uploadArtifact = new nick_process_commons_1.NickProcessArtfact();
                        uploadArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                        uploadArtifact.object = data;
                        observer.next(uploadArtifact);
                    }
                    observer.complete();
                });
            });
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('bb8bb775-aba6-46fe-8c62-0b6a1d0580ce')
    ], AwsSqsHook.prototype, "createQueue", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('542b0393-899b-4062-8114-1257d33791d9')
    ], AwsSqsHook.prototype, "receiveMessage", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('cc561628-2358-4b90-80d2-9d2888310442')
    ], AwsSqsHook.prototype, "deleteMessage", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('7bb19a0a-93b8-41a0-b151-648054ac98ce')
    ], AwsSqsHook.prototype, "sendMessage", null);
    AwsSqsHook = __decorate([
        (0, nick_process_commons_1.HookClass)('aws.sqs')
    ], AwsSqsHook);
    return AwsSqsHook;
}(nick_process_commons_1.BaseHook));
exports.AwsSqsHook = AwsSqsHook;
//# sourceMappingURL=aws.sqs.hook.js.map