"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BankHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var fs = __importStar(require("fs"));
var moment_1 = __importDefault(require("moment"));
var rxjs_1 = require("rxjs");
var beneficiario_1 = require("./slip/lib/beneficiario");
var gerador_de_boleto_1 = require("./slip/lib/boleto/gerador-de-boleto");
var gerador_de_digito_padrao_1 = require("./slip/lib/boleto/gerador-de-digito-padrao");
var boletoUtils_1 = require("./slip/lib/boletoUtils");
var datas_1 = require("./slip/lib/datas");
var endereco_1 = require("./slip/lib/endereco");
var formatacoesUtils_1 = require("./slip/lib/formatacoesUtils");
var pagador_1 = require("./slip/lib/pagador");
var writeable_buffer_1 = require("./slip/lib/writeable.buffer");
var temp_remessa_1_1 = require("./yaml/temp_remessa_1");
var yaml_generate_1 = require("./yaml/yaml.generate");
var operators_1 = require("rxjs/operators");
var BankHook = /** @class */ (function (_super) {
    __extends(BankHook, _super);
    function BankHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BankHook.prototype.slip = function (inputArtifact) {
        if (inputArtifact.object.data.bankCode == 237)
            return this.boletoBradesco(inputArtifact);
        var createBoleto = function () {
            var pagador = createPagador();
            var beneficiario = createBeneficiario();
            var instrucoes = createInstrucoes();
            return boletoUtils_1.Boleto.novoBoleto()
                .comDatas(datas_1.Datas.novasDatas()
                .comVencimento(inputArtifact.object.data.dueAt)
                .comProcessamento(inputArtifact.object.data.generateAt)
                .comDocumento(inputArtifact.object.data.generateAt))
                .comBeneficiario(beneficiario)
                .comPagador(pagador)
                .comBanco(new boletoUtils_1.bancos.Santander())
                .comValorBoleto(parseFloat(inputArtifact.object.data.ammount)) // Apenas duas casas decimais
                .comNumeroDoDocumento(1001)
                .comEspecieDocumento('DM') // Duplicata de Venda Mercantil
                .comLocaisDePagamento(['Em qualquer banco até o vencimento'])
                .comInstrucoes(instrucoes);
        };
        var createPagador = function () {
            var enderecoPagador = endereco_1.Endereco.novoEndereco();
            enderecoPagador.primeiraLinha = "".concat(inputArtifact.object.data.ownerAddress1);
            enderecoPagador.segundaLinha = "".concat(inputArtifact.object.data.ownerAddress2);
            return pagador_1.Pagador.novoPagador()
                .comNome("".concat(inputArtifact.object.data.ownerName))
                .comRegistroNacional("".concat(inputArtifact.object.data.ownerDocument))
                .comEndereco(enderecoPagador);
        };
        var createBeneficiario = function () {
            var enderecoBeneficiario = endereco_1.Endereco.novoEndereco()
                .comLogradouro('RUA RIACHUELO, 75')
                .comBairro('CENTRO')
                .comCidade('RIO DE JANEIRO')
                .comUf('RJ')
                .comCep('20230-010');
            return beneficiario_1.Beneficiario.novoBeneficiario()
                .comNome('CONSELHO NACIONAL DO BRASIL DA S.S.V.P')
                .comRegistroNacional('34127563000167')
                .comCarteira('101')
                .comAgencia('3201')
                .comCodigoBeneficiario('2507390')
                .comDigitoCodigoBeneficiario('8')
                .comNossoNumero(inputArtifact.object.data.ourNumber.toString().padStart(11, '0')) // 11 -digitos // "00000005752"
                .comDigitoNossoNumero(gerador_de_digito_padrao_1.GeradorDeDigitoPadrao.mod11(inputArtifact.object.data.ourNumber.toString(), {
                de: [0, 1, 10, 11],
                para: 0
            }))
                .comEndereco(enderecoBeneficiario);
        };
        var createInstrucoes = function () {
            var instrucoes = [];
            instrucoes.push("".concat(inputArtifact.object.data.paymentInstruction));
            return instrucoes;
        };
        var boleto = createBoleto();
        var writeStream = new writeable_buffer_1.WritableBufferStream();
        return new rxjs_1.Observable(function (observer) {
            try {
                new gerador_de_boleto_1.GeradorDeBoleto(boleto).gerarPDF({
                    creditos: '',
                    stream: writeStream
                }, function (err, pdf) {
                    if (err)
                        return console.error(err);
                    writeStream.on('finish', function (dev) {
                        var uploadArtifact = new nick_process_commons_1.NickProcessArtfact();
                        uploadArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                        uploadArtifact.object = {
                            buffer: writeStream.toBuffer(),
                            contentType: 'application/pdf'
                        };
                        observer.next(uploadArtifact);
                        observer.complete();
                    });
                });
            }
            catch (e) {
                observer.error(e);
                observer.complete();
            }
        });
    };
    BankHook.prototype.shipment = function (inputArtifact) {
        // generate lot of services
        // const details: any[] = inputArtifact.object.data;
        var details = temp_remessa_1_1.dados;
        var lots = [];
        var lotSequence = 0;
        for (var i = 0; i < details.length; i++) {
            var detail = details[i];
            if (!detail.field9 || !detail.field9.length)
                continue;
            var lot = {};
            ++lotSequence;
            lot.header_lote = {
                lote_servico: lotSequence,
                tipo_inscricao: '2',
                num_inscricao_empresa: '34127563000167',
                cod_trasmissao: '320100002507390',
                nome_empresa: 'CONSELHO NACIONAL DO BRASIL DA SOCIEDADE DE SAO VICENTE DE PAULO',
                mensagem_1: '',
                mensagem_2: '',
                numero_remessa: '7',
                data_gravacao: '27072019'
            };
            lot.detail_p = {
                lote_servico: lotSequence,
                num_sequencial: '1',
                cod_movimento: '01',
                agencia_destinataria: '3201',
                agencia_destinataria_digito: '',
                numero_conta_corrente: '13000215',
                digito_verif_conta_corrente: '8',
                conta_cob_destinataria: '13000215',
                conta_cob_destinataria_digito: '8',
                indentificacao_titulo_banco: "".concat(detail.field18).concat(gerador_de_digito_padrao_1.GeradorDeDigitoPadrao.mod11(detail.field18, {
                    de: [0, 1, 10, 11],
                    para: 0
                })),
                tipo_cobranca: '5',
                forma_cadastramento: '1',
                tipo_documento: '1',
                num_documento: "".concat(detail.field18),
                data_vencimento: '20082019',
                valor_nominal: '1000',
                especie_titulo: '02',
                identificacao_titulo: 'N',
                data_emissao: '27072019',
                codigo_juros: '3',
                codigo_desconto: '0',
                indentificacao_titulo_empresa: "".concat(detail.field18),
                codigo_protesto: '0',
                codigo_baixa: '3'
            };
            lot.detail_q = {
                lote_servico: lotSequence,
                num_sequencial: '2',
                cod_movimento: '01',
                tipo_inscricao: '2',
                num_inscricao: formatacoesUtils_1.FormatacoesUtils.removerMascara(detail.field9),
                nome_pagador: "".concat(detail.field21),
                endereco_pagador: "".concat(detail.field22, ", ").concat(detail.field23, ", ").concat(detail.field24),
                bairro_pagador: detail.field11,
                cep_pagador: detail.field10.substr(0, detail.field10.length - 3),
                cep_pagador_sufixo: detail.field10.substr(detail.field10.length - 3, detail.field10.length),
                cidade_pagador: detail.field11,
                uf_pagador: detail.field12
            };
            lot.detail_r = {
                lote_servico: lotSequence,
                num_sequencial: '3',
                cod_movimento: '01',
                codigo_desconto_2: '0',
                data_desconto_2: '',
                valor_percentual_desconto_2: '',
                codigo_desconto_3: '0',
                data_desconto_3: '',
                valor_percentual_desconto_3: '',
                codigo_multa: '1',
                data_multa: '',
                valor_multa: '',
                mensagem_3: '',
                mensagem_4: ''
            };
            lot.detail_s = {
                lote_servico: lotSequence,
                num_sequencial: '4',
                cod_movimento: '01',
                identificacao_impressao: '1',
                numero_linha_impressa: '01',
                mensagem_recibo: '4',
                mensagem_impressa: 'COLETA PARA JUVENTUDE CONFORME A CIRCULAR 012/CNJ/2019 DE 12/05/2019 PAGAMENTO MÍNIMO R$ 10,00'
            };
            lot.trailer_lote = {
                lote_servico: lotSequence,
                qtd_registros_lote: '6'
            };
            lots.push(lot);
        }
        var filesLayout = {
            header_arquivo: {
                lote_servico: '0000',
                tipo_inscricao: '2',
                num_inscricao_empresa: '34127563000167',
                cod_trasmissao: '320100002507390',
                nome_empresa: 'CONSELHO NACIONAL DO BRASIL DA SOCIEDADE DE SAO VICENTE DE PAULO',
                data_geracao: '27072019',
                sequencial_arquivo: '7'
            },
            lots: lots,
            trailer_arquivo: {
                lote_servico: '9999',
                qtd_registros_lote: "".concat(lots.length),
                qtd_registros_arquivo: "".concat((lots.length * 6) + 2)
            }
        };
        var finalresult = yaml_generate_1.YamlGenerate.generateRemessaCnab(filesLayout, 240, yaml_generate_1.YamlGenerate.BANK.santander.code);
        fs.writeFileSync('../temp/remessa.rem', finalresult);
        return (0, rxjs_1.of)(inputArtifact);
    };
    BankHook.prototype.shipmentReturn = function (inputArtifact) {
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var shipmentReturns = yaml_generate_1.YamlGenerate.BANK[inputArtifact.object.config.bank].retorno[inputArtifact.object.config.cnab];
            inputArtifact.object = yaml_generate_1.YamlGenerate.generateRetornoCnab(yaml_generate_1.YamlGenerate.BANK[inputArtifact.object.config.bank].retorno[inputArtifact.object.config.cnab], inputArtifact.object.config.cnab, yaml_generate_1.YamlGenerate.BANK[inputArtifact.object.config.bank].code, inputArtifact.object.data, settings.environment);
            return (0, rxjs_1.of)(inputArtifact);
        }));
    };
    BankHook.prototype.boletoBradesco = function (inputArtifact) {
        var createBoleto = function () {
            var pagador = createPagador();
            var beneficiario = createBeneficiario();
            var instrucoes = createInstrucoes();
            return boletoUtils_1.Boleto.novoBoleto()
                .comDatas(datas_1.Datas.novasDatas()
                .comVencimento(inputArtifact.object.data.dueAt)
                .comProcessamento(inputArtifact.object.data.generateAt)
                .comDocumento(inputArtifact.object.data.generateAt))
                .comBeneficiario(beneficiario)
                .comPagador(pagador)
                .comBanco(new boletoUtils_1.bancos.Bradesco())
                .comValorBoleto(parseFloat(inputArtifact.object.data.ammount)) // Apenas duas casas decimais
                .comNumeroDoDocumento(1001)
                .comEspecieDocumento('DM') // Duplicata de Venda Mercantil
                .comLocaisDePagamento(['Em qualquer banco até o vencimento'])
                .comInstrucoes(instrucoes);
        };
        var createPagador = function () {
            var enderecoPagador = endereco_1.Endereco.novoEndereco();
            enderecoPagador.primeiraLinha = "".concat(inputArtifact.object.data.ownerAddress1);
            enderecoPagador.segundaLinha = "".concat(inputArtifact.object.data.ownerAddress2);
            return pagador_1.Pagador.novoPagador()
                .comNome("".concat(inputArtifact.object.data.ownerName))
                .comRegistroNacional("".concat(inputArtifact.object.data.ownerDocument))
                .comEndereco(enderecoPagador);
        };
        var createBeneficiario = function () {
            var enderecoBeneficiario = endereco_1.Endereco.novoEndereco()
                .comLogradouro('RUA RIACHUELO, 75')
                .comBairro('CENTRO')
                .comCidade('RIO DE JANEIRO')
                .comUf('RJ')
                .comCep('20230-010');
            return beneficiario_1.Beneficiario.novoBeneficiario()
                .comNome('CONSELHO NACIONAL DO BRASIL DA S.S.V.P')
                .comRegistroNacional('34127563000167')
                .comCarteira('09')
                .comAgencia('1791')
                .comDigitoAgencia('4')
                .comCodigoBeneficiario('31550')
                .comDigitoCodigoBeneficiario('8')
                .comNossoNumero(inputArtifact.object.data.ourNumber.toString().padStart(11, '0')) // 11 -digitos // "00000005752"
                .comDigitoNossoNumero(gerador_de_digito_padrao_1.GeradorDeDigitoPadrao.mod11("09".concat(inputArtifact.object.data.ourNumber.toString().padStart(11, '0')), boletoUtils_1.bancos.Bradesco.susbstituicoes, boletoUtils_1.bancos.Bradesco.series))
                .comEndereco(enderecoBeneficiario);
        };
        var createInstrucoes = function () {
            var instrucoes = [];
            instrucoes.push("".concat(inputArtifact.object.data.paymentInstruction));
            return instrucoes;
        };
        var boleto = createBoleto();
        var writeStream = new writeable_buffer_1.WritableBufferStream();
        return new rxjs_1.Observable(function (observer) {
            try {
                new gerador_de_boleto_1.GeradorDeBoleto(boleto).gerarPDF({
                    creditos: '',
                    stream: writeStream
                }, function (err, pdf) {
                    if (err)
                        return console.error(err);
                    writeStream.on('finish', function (dev) {
                        var uploadArtifact = new nick_process_commons_1.NickProcessArtfact();
                        uploadArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                        uploadArtifact.object = {
                            buffer: writeStream.toBuffer(),
                            contentType: 'application/pdf'
                        };
                        observer.next(uploadArtifact);
                        observer.complete();
                    });
                });
            }
            catch (e) {
                observer.error(e);
                observer.complete();
            }
        });
    };
    BankHook.prototype.shipmentBradesco = function (inputArtifact) {
        // generate lot of services
        // const details: any[] = inputArtifact.object.data;
        var details = inputArtifact.object.data;
        var lots = [];
        var lotSequence = 1;
        for (var i = 0; i < details.length; i++) {
            var detail = details[i];
            // if (!detail.field9 || !detail.field9.length)
            //     continue;
            var lot = {};
            ++lotSequence;
            var cep = detail.ownerAddress2.split(',')[0];
            lot.detail_type_1 = {
                identificacao_empresa: '00090179100315508',
                num_controle: detail.ourNumber,
                codigo_multa: '0',
                percentual_multa: '0',
                identificacao_titutlo: detail.ourNumber,
                digito_auto_conferencia: gerador_de_digito_padrao_1.GeradorDeDigitoPadrao.mod11("09".concat(detail.ourNumber.toString().padStart(11, '0')), boletoUtils_1.bancos.Bradesco.susbstituicoes, boletoUtils_1.bancos.Bradesco.series).toString(),
                condicao_emissao: '2',
                identificacao_debito: 'N',
                identificacao_ocorrencia: '01',
                num_documento: detail.ourNumber,
                data_vencimento: (0, moment_1.default)(detail.dueAt).format('DDMMYY'),
                valor_titulo: parseFloat(detail.ammount).toFixed(2).replace('.', ''),
                especie_titulo: '01',
                data_emissao: (0, moment_1.default)(detail.generateAt).format('DDMMYY'),
                instricao_1: '00',
                instrucao_2: '00',
                tipo_inscricao: formatacoesUtils_1.FormatacoesUtils.removerMascara(detail.ownerDocument).length == 11 ? '01' : '02',
                num_inscricao: formatacoesUtils_1.FormatacoesUtils.removerMascara(detail.ownerDocument),
                nome_pagador: detail.ownerName,
                endereco_completo: "".concat(detail.ownerAddress1, " - ").concat(detail.ownerAddress2, " "),
                mensagem_1: '',
                cep: cep.substr(0, cep.length - 3),
                cep_sufixo: cep.substr(cep.length - 3, cep.length),
                sacador: detail.paymentInstruction,
                sequencial: lotSequence
            };
            lots.push(lot);
        }
        var filesLayout = {
            header_arquivo: {
                codigo_empresa: '4857169',
                nome_empresa: 'Conselho Nacional B.S.S.V.PA',
                data_arquivo: (0, moment_1.default)().format('DDMMYY'),
                numero_remessa: inputArtifact.object.config.lotSequence,
                numero_registro: '1'
            },
            lots: lots,
            trailer_arquivo: {
                sequencial_registro: lots.length + 2
            }
        };
        var finalResult = yaml_generate_1.YamlGenerate.generateRemessaCnab(filesLayout, 400, yaml_generate_1.YamlGenerate.BANK.bradesco.code);
        var output = new nick_process_commons_1.NickProcessArtfact();
        output.kind = nick_data_commons_1.ArtfactKind.ANY;
        output.object = finalResult;
        return (0, rxjs_1.of)(output);
    };
    BankHook.prototype.digitableLineToBarCodeFEBRABAN = function (inputArtifact) {
        var value = inputArtifact.object.value;
        var checkDigit = function (digit) {
            digit = digit.replace(/[^0-9]/g, '');
            var sum = 0;
            var weight = 2;
            var base = 9;
            var rest = 0;
            var contador = digit.length - 1;
            for (var i = contador; i >= 0; i--) {
                sum = sum + (digit.substring(i, i + 1) * weight);
                if (weight < base) {
                    weight++;
                }
                else {
                    weight = 2;
                }
            }
            var result = 11 - (sum % 11);
            if (result > 9)
                result = 0;
            if (result == 0)
                result = 1;
            return result;
        };
        var calculateBarcode = function (line) {
            var barcode = line.replace(/[^0-9]/g, '');
            if (checkDigit('34191000000000000001753980229122525005423000') != 1)
                throw new Error('Error converting digitableLine to barcode');
            if (barcode.length < 47)
                barcode = barcode + '00000000000'.substr(0, 47 - barcode.length);
            if (barcode.length != 47)
                throw new Error('Invalid digitableLine, conversion failed');
            barcode = barcode.substr(0, 4)
                + barcode.substr(32, 15)
                + barcode.substr(4, 5)
                + barcode.substr(10, 10)
                + barcode.substr(21, 10);
            if (checkDigit(barcode.substr(0, 4) + barcode.substr(5, 39)) != barcode.substr(4, 1))
                throw new Error('Error 5th digit ' + barcode.substr(4, 1) + ', the correct number is ' + checkDigit(barcode.substr(0, 4) + barcode.substr(5, 39)));
            return (barcode);
        };
        var digitableLineToBarcode = function () {
            var digitableLine = value;
            var barcode = calculateBarcode(value);
            value = barcode;
        };
        if (value.length % 2 !== 0) {
            digitableLineToBarcode();
        }
        var start = String.fromCharCode(201);
        var stop = String.fromCharCode(202);
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = value.match(/.{2}/g).reduce(function (acc, part) {
            var value = parseInt(part, 10);
            var ascii;
            if (value >= 0 && value <= 93) {
                ascii = value + 33;
            }
            if (value >= 94 && value <= 99) {
                ascii = value + 101;
            }
            return acc + String.fromCharCode(ascii);
        }, start) + stop;
        return (0, rxjs_1.of)(outputArtifact);
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('6f8dfdee-a3eb-4ef0-a40c-e4da6cba51d4')
    ], BankHook.prototype, "slip", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('ec3e4b16-21f7-4546-904c-a949c3005c0c')
    ], BankHook.prototype, "shipment", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('101bd4b2-3bb2-43a7-9e3c-e1e77ddddafd')
    ], BankHook.prototype, "shipmentReturn", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('71ea5386-1726-4686-a5e6-3a6dbedb40a5')
    ], BankHook.prototype, "boletoBradesco", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('b9ed94af-126f-4324-8acd-1d1f1f8a8337')
    ], BankHook.prototype, "shipmentBradesco", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('4a846e24-58e4-4bef-b109-bd784c01effe')
    ], BankHook.prototype, "digitableLineToBarCodeFEBRABAN", null);
    BankHook = __decorate([
        (0, nick_process_commons_1.HookClass)('bank')
    ], BankHook);
    return BankHook;
}(nick_process_commons_1.BaseHook));
exports.BankHook = BankHook;
//# sourceMappingURL=bank.hook.js.map