"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BancoUtils = void 0;
var formatacoesUtils_1 = require("./formatacoesUtils");
var BancoUtils = /** @class */ (function () {
    function BancoUtils() {
    }
    BancoUtils.retornaFalso = function () {
        return false;
    };
    BancoUtils.calcularDVDoBradescoOuDoBancoDoBrasil = function (agenciaOuConta) {
        var size = agenciaOuConta.length;
        var result = 0;
        var mult = 2;
        for (var i = size - 1; i >= 0; i--) {
            var temp = agenciaOuConta.charAt(i) * mult;
            result += temp;
            mult++;
            if (mult > 9) {
                mult = 2;
            }
        }
        return ((result * 10) % 11).toString();
    };
    BancoUtils.calcularDVDoItau = function (agencia, conta) {
        conta = '0000000000' + conta;
        conta = conta.substring(conta.length - 9, conta.length);
        conta = agencia + conta;
        var total = 0;
        var fator = 2;
        for (var i = conta.length - 1; i >= 0; i--) {
            var num = conta.charAt(i);
            var temp = num * fator;
            var temp2 = Math.floor(temp / 10) + (temp % 10);
            total += temp2;
            fator = fator == 2 ? 1 : 2;
        }
        return (10 - (total % 10)).toString();
    };
    BancoUtils.validarAgenciaOuContaDoBradescoOuBancoDoBrasil = function (agenciaOuConta) {
        if (typeof agenciaOuConta !== 'string') {
            return false;
        }
        agenciaOuConta = formatacoesUtils_1.FormatacoesUtils.removerMascara(agenciaOuConta);
        var digitoInformado = agenciaOuConta.substr(agenciaOuConta.length - 1);
        var digitoCalculado = BancoUtils.calcularDVDoBradescoOuDoBancoDoBrasil(agenciaOuConta.substr(0, agenciaOuConta.length - 1));
        return digitoInformado === digitoCalculado;
    };
    BancoUtils.itau = {
        validarAgenciaEConta: function (agencia, conta) {
            // a conta deve informar o digito verificador
            if (typeof agencia !== 'string' || typeof conta !== 'string') {
                return false;
            }
            agencia = formatacoesUtils_1.FormatacoesUtils.removerMascara(agencia);
            conta = formatacoesUtils_1.FormatacoesUtils.removerMascara(conta);
            var digitoInformado = conta.substr(conta.length - 1);
            var digitoCalculado = BancoUtils.calcularDVDoItau(agencia, conta.substr(0, conta.length - 1));
            return digitoInformado === digitoCalculado;
        },
        validarAgencia: BancoUtils.retornaFalso,
        validarConta: BancoUtils.retornaFalso,
        calcularDigitoVerificador: BancoUtils.calcularDVDoItau
    };
    BancoUtils.bancoDoBrasil = {
        validarAgenciaEConta: function (agencia, conta) {
            return BancoUtils.validarAgenciaOuContaDoBradescoOuBancoDoBrasil(agencia) &&
                BancoUtils.validarAgenciaOuContaDoBradescoOuBancoDoBrasil(conta);
        },
        validarAgencia: BancoUtils.validarAgenciaOuContaDoBradescoOuBancoDoBrasil,
        validarConta: BancoUtils.validarAgenciaOuContaDoBradescoOuBancoDoBrasil,
        calcularDigitoVerificador: BancoUtils.calcularDVDoBradescoOuDoBancoDoBrasil
    };
    return BancoUtils;
}());
exports.BancoUtils = BancoUtils;
//# sourceMappingURL=bancosUtils.js.map