"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BancoBrasil = void 0;
var path = __importStar(require("path"));
var string_utils_1 = require("../../utils/string-utils");
var codigo_de_barras_builder_1 = require("../codigo-de-barras-builder");
var pad = string_utils_1.StringUtils.pad;
var insert = string_utils_1.StringUtils.insert;
var NUMERO_BANCO_BRASIL = '001';
var DIGITO_BANCO_BRASIL = '9';
var BancoBrasil = /** @class */ (function () {
    function BancoBrasil() {
    }
    BancoBrasil.prototype.getTitulos = function () {
        return {
            instrucoes: 'Informações de responsabilidade do beneficiário',
            nomeDoPagador: 'Nome do Pagador',
            especie: 'Moeda',
            quantidade: 'Quantidade',
            valor: 'Valor',
            moraMulta: '(+) Juros / Multa'
        };
    };
    BancoBrasil.prototype.exibirReciboDoPagadorCompleto = function () {
        return true;
    };
    BancoBrasil.prototype.exibirCampoCip = function () {
        return false;
    };
    BancoBrasil.prototype.geraCodigoDeBarrasPara = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        var campoLivre = [];
        if (beneficiario.getNossoNumero().length == 11) {
            campoLivre.push(beneficiario.getNossoNumero());
            campoLivre.push(beneficiario.getAgenciaFormatada());
            campoLivre.push(beneficiario.getCodigoBeneficiario());
            campoLivre.push(beneficiario.getCarteira().substring(0, 2));
        }
        if (beneficiario.getNossoNumero().length == 17) {
            campoLivre.push('000000');
            campoLivre.push(beneficiario.getNossoNumero());
            campoLivre.push(beneficiario.getCarteira().substring(0, 2));
        }
        return new codigo_de_barras_builder_1.CodigoDeBarrasBuilder(boleto).comCampoLivre(campoLivre);
    };
    BancoBrasil.prototype.getNumeroFormatadoComDigito = function () {
        return [
            NUMERO_BANCO_BRASIL,
            DIGITO_BANCO_BRASIL
        ].join('-');
    };
    BancoBrasil.prototype.getNumeroFormatado = function () {
        return NUMERO_BANCO_BRASIL;
    };
    BancoBrasil.prototype.getCarteiraFormatado = function (beneficiario) {
        return pad(beneficiario.getCarteira(), 2, '0');
    };
    BancoBrasil.prototype.getCarteiraTexto = function (beneficiario) {
        return pad(beneficiario.getCarteira(), 2, '0');
    };
    BancoBrasil.prototype.getCodigoFormatado = function (beneficiario) {
        return pad(beneficiario.getCodigoBeneficiario(), 7, '0');
    };
    BancoBrasil.prototype.getImagem = function () {
        return path.join(__dirname, 'logotipos/banco-do-brasil.png');
    };
    BancoBrasil.prototype.getNossoNumeroFormatado = function (beneficiario) {
        return pad(beneficiario.getNossoNumero(), 17, '0');
    };
    BancoBrasil.prototype.getNossoNumeroECodigoDocumento = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        return [
            this.getNossoNumeroFormatado(beneficiario)
        ].join('-');
    };
    BancoBrasil.prototype.getNome = function () {
        return 'Banco do Brasil S.A.';
    };
    BancoBrasil.prototype.getImprimirNome = function () {
        return false;
    };
    BancoBrasil.prototype.getAgenciaECodigoBeneficiario = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        var codigo = this.getCodigoFormatado(beneficiario);
        var digitoCodigo = beneficiario.getDigitoCodigoBeneficiario();
        if (digitoCodigo) {
            codigo += '-' + digitoCodigo;
        }
        return beneficiario.getAgenciaFormatada() + '/' + codigo;
    };
    BancoBrasil.prototype.novoBancoBrasil = function () {
        return new BancoBrasil();
    };
    return BancoBrasil;
}());
exports.BancoBrasil = BancoBrasil;
//# sourceMappingURL=banco-do-brasil.js.map