"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Bradesco = void 0;
var path = __importStar(require("path"));
var array_utils_1 = require("../../utils/array-utils");
var string_utils_1 = require("../../utils/string-utils");
var codigo_de_barras_builder_1 = require("../codigo-de-barras-builder");
var pad = string_utils_1.StringUtils.pad;
var insert = string_utils_1.StringUtils.insert;
var NUMERO_BRADESCO = '237';
var DIGITO_BRADESCO = '2';
var Bradesco = /** @class */ (function () {
    function Bradesco() {
    }
    Bradesco.prototype.getTitulos = function () {
        return {
            instrucoes: 'Informações de responsabilidade do beneficiário',
            nomeDoPagador: 'Nome do Pagador',
            especie: 'Moeda',
            quantidade: 'Quantidade',
            valor: 'Valor',
            moraMulta: '(+) Juros / Multa'
        };
    };
    Bradesco.prototype.exibirReciboDoPagadorCompleto = function () {
        return true;
    };
    Bradesco.prototype.exibirCampoCip = function () {
        return true;
    };
    Bradesco.prototype.geraCodigoDeBarrasPara = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        var campoLivre = [];
        campoLivre.push(beneficiario.getAgenciaFormatada());
        campoLivre.push(this.getCarteiraFormatado(beneficiario));
        campoLivre.push(this.getNossoNumeroFormatado(beneficiario));
        campoLivre.push(this.getCodigoFormatado(beneficiario));
        campoLivre.push('0');
        return new codigo_de_barras_builder_1.CodigoDeBarrasBuilder(boleto).comCampoLivre(campoLivre);
    };
    Bradesco.prototype.getNumeroFormatadoComDigito = function () {
        return [
            NUMERO_BRADESCO,
            DIGITO_BRADESCO
        ].join('-');
    };
    Bradesco.prototype.getNumeroFormatado = function () {
        return NUMERO_BRADESCO;
    };
    Bradesco.prototype.getCarteiraFormatado = function (beneficiario) {
        return pad(beneficiario.getCarteira(), 2, '0');
    };
    Bradesco.prototype.getCarteiraTexto = function (beneficiario) {
        return pad(beneficiario.getCarteira(), 2, '0');
    };
    Bradesco.prototype.getCodigoFormatado = function (beneficiario) {
        return pad(beneficiario.getCodigoBeneficiario(), 7, '0');
    };
    Bradesco.prototype.getImagem = function () {
        return path.join(__dirname, 'logotipos/bradesco.png');
    };
    Bradesco.prototype.getNossoNumeroFormatado = function (beneficiario) {
        return pad(beneficiario.getNossoNumero(), 11, '0');
    };
    Bradesco.prototype.getNossoNumeroECodigoDocumento = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        return this.getCarteiraFormatado(beneficiario) + '/' + [
            this.getNossoNumeroFormatado(beneficiario),
            beneficiario.getDigitoNossoNumero()
        ].join('-');
    };
    Bradesco.prototype.getNome = function () {
        return 'Banco Bradesco S.A.';
    };
    Bradesco.prototype.getImprimirNome = function () {
        return false;
    };
    Bradesco.prototype.getAgenciaECodigoBeneficiario = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        var codigo = this.getCodigoFormatado(beneficiario);
        var digitoCodigo = beneficiario.getDigitoCodigoBeneficiario();
        if (digitoCodigo) {
            codigo += '-' + digitoCodigo;
        }
        return beneficiario.getAgenciaFormatada() + '/' + codigo;
    };
    Bradesco.prototype.novoBradesco = function () {
        return new Bradesco();
    };
    Bradesco.series = array_utils_1.ArrayUtils.series(2, 7);
    Bradesco.susbstituicoes = {
        de: [10],
        para: 'P'
    };
    return Bradesco;
}());
exports.Bradesco = Bradesco;
//# sourceMappingURL=bradesco.js.map