"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Itau = void 0;
var path = __importStar(require("path"));
var string_utils_1 = require("../../utils/string-utils");
var codigo_de_barras_builder_1 = require("../codigo-de-barras-builder");
var gerador_de_digito_padrao_1 = require("../gerador-de-digito-padrao");
var pad = string_utils_1.StringUtils.pad;
var insert = string_utils_1.StringUtils.insert;
var NUMERO_ITAU = '341';
var DIGITO_ITAU = '7';
var Itau = /** @class */ (function () {
    function Itau() {
    }
    Itau.prototype.getTitulos = function () {
        return {};
    };
    Itau.prototype.exibirReciboDoPagadorCompleto = function () {
        return false;
    };
    Itau.prototype.exibirCampoCip = function () {
        return false;
    };
    Itau.prototype.geraCodigoDeBarrasPara = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        var campoLivre = [];
        campoLivre.push(this.getCarteiraFormatado(beneficiario));
        campoLivre.push(this.getNossoNumeroFormatado(beneficiario));
        campoLivre.push(beneficiario.getAgenciaFormatada());
        campoLivre.push(this.getCodigoFormatado(beneficiario));
        campoLivre.push('000');
        campoLivre = campoLivre.join('');
        var digito1 = gerador_de_digito_padrao_1.GeradorDeDigitoPadrao.mod10(campoLivre.substring(11, 20));
        campoLivre = insert(campoLivre, 20, digito1);
        var digito2 = gerador_de_digito_padrao_1.GeradorDeDigitoPadrao.mod10(campoLivre.substring(11, 20) + campoLivre.substring(0, 11));
        campoLivre = insert(campoLivre, 11, digito2);
        return new codigo_de_barras_builder_1.CodigoDeBarrasBuilder(boleto).comCampoLivre(campoLivre);
    };
    Itau.prototype.getNumeroFormatadoComDigito = function () {
        return [NUMERO_ITAU, DIGITO_ITAU].join('-');
    };
    Itau.prototype.getCarteiraFormatado = function (beneficiario) {
        return pad(beneficiario.getCarteira(), 3, '0');
    };
    Itau.prototype.getCarteiraTexto = function (beneficiario) {
        return this.getCarteiraFormatado(beneficiario);
    };
    Itau.prototype.getCodigoFormatado = function (beneficiario) {
        return pad(beneficiario.getCodigoBeneficiario(), 5, '0');
    };
    Itau.prototype.getImagem = function () {
        return path.join(__dirname, 'logotipos/itau.png');
    };
    Itau.prototype.getNossoNumeroFormatado = function (beneficiario) {
        return pad(beneficiario.getNossoNumero(), 8, '0');
    };
    Itau.prototype.getNossoNumeroECodigoDocumento = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        return [
            beneficiario.getCarteira(),
            this.getNossoNumeroFormatado(beneficiario)
        ].join('/') + '-' + beneficiario.getDigitoNossoNumero();
    };
    Itau.prototype.getNumeroFormatado = function () {
        return NUMERO_ITAU;
    };
    Itau.prototype.getNome = function () {
        return 'Banco Itaú S/A';
    };
    Itau.prototype.getImprimirNome = function () {
        return true;
    };
    Itau.prototype.getAgenciaECodigoBeneficiario = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        var codigo = this.getCodigoFormatado(beneficiario);
        var digitoCodigo = beneficiario.getDigitoCodigoBeneficiario();
        if (digitoCodigo) {
            codigo += '-' + digitoCodigo;
        }
        return beneficiario.getAgenciaFormatada() + '/' + codigo;
    };
    Itau.prototype.novoItau = function () {
        return new Itau();
    };
    return Itau;
}());
exports.Itau = Itau;
//# sourceMappingURL=itau.js.map