"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Santander = void 0;
var path = __importStar(require("path"));
var string_utils_1 = require("../../utils/string-utils");
var codigo_de_barras_builder_1 = require("../codigo-de-barras-builder");
var pad = string_utils_1.StringUtils.pad;
var insert = string_utils_1.StringUtils.insert;
var NUMERO_SANTANDER = '033';
var DIGITO_SANTANDER = '7';
var Santander = /** @class */ (function () {
    function Santander() {
    }
    Santander.prototype.getTitulos = function () {
        return {
            instrucoes: 'Informações de responsabilidade do beneficiário',
            nomeDoPagador: 'Nome do Pagador',
            especie: 'Moeda',
            quantidade: 'Quantidade',
            valor: 'Valor',
            moraMulta: '(+) Juros / Multa'
        };
    };
    Santander.prototype.exibirReciboDoPagadorCompleto = function () {
        return true;
    };
    Santander.prototype.exibirCampoCip = function () {
        return false;
    };
    Santander.prototype.geraCodigoDeBarrasPara = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        var campoLivre = [];
        campoLivre.push('9');
        campoLivre.push(beneficiario.getCodigoBeneficiario().substring(0, 4));
        campoLivre.push(beneficiario.getCodigoBeneficiario().substring(4));
        campoLivre.push(this.getNossoNumeroFormatado(beneficiario).substring(0, 7));
        campoLivre.push(this.getNossoNumeroFormatado(beneficiario).substring(7));
        campoLivre.push(beneficiario.getDigitoNossoNumero());
        campoLivre.push('0');
        campoLivre.push(this.getCarteiraFormatado(beneficiario));
        return new codigo_de_barras_builder_1.CodigoDeBarrasBuilder(boleto).comCampoLivre(campoLivre);
    };
    Santander.prototype.getNumeroFormatadoComDigito = function () {
        return [
            NUMERO_SANTANDER,
            DIGITO_SANTANDER
        ].join('-');
    };
    Santander.prototype.getNumeroFormatado = function () {
        return NUMERO_SANTANDER;
    };
    Santander.prototype.getCarteiraFormatado = function (beneficiario) {
        return pad(beneficiario.getCarteira(), 2, '0');
    };
    Santander.prototype.getCarteiraTexto = function (beneficiario) {
        return pad(beneficiario.getCarteira(), 2, '0');
    };
    Santander.prototype.getCodigoFormatado = function (beneficiario) {
        return pad(beneficiario.getCodigoBeneficiario(), 7, '0');
    };
    Santander.prototype.getImagem = function () {
        return path.join(__dirname, 'logotipos/santander.png');
    };
    Santander.prototype.getNossoNumeroFormatado = function (beneficiario) {
        return pad(beneficiario.getNossoNumero(), 12, '0');
    };
    Santander.prototype.getNossoNumeroECodigoDocumento = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        return [
            this.getNossoNumeroFormatado(beneficiario),
            beneficiario.getDigitoNossoNumero()
        ].join('-');
    };
    Santander.prototype.getNome = function () {
        return 'Banco Santander S.A.';
    };
    Santander.prototype.getImprimirNome = function () {
        return false;
    };
    Santander.prototype.getAgenciaECodigoBeneficiario = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        var codigo = this.getCodigoFormatado(beneficiario);
        var digitoCodigo = beneficiario.getDigitoCodigoBeneficiario();
        if (digitoCodigo) {
            codigo += '-' + digitoCodigo;
        }
        return beneficiario.getAgenciaFormatada() + '/' + codigo;
    };
    Santander.prototype.novoSantander = function () {
        return new Santander();
    };
    return Santander;
}());
exports.Santander = Santander;
//# sourceMappingURL=santander.js.map