"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sicoob = void 0;
var path = __importStar(require("path"));
var string_utils_1 = require("../../utils/string-utils");
var codigo_de_barras_builder_1 = require("../codigo-de-barras-builder");
var pad = string_utils_1.StringUtils.pad;
var insert = string_utils_1.StringUtils.insert;
var NUMERO_SICOOB = '756';
var DIGITO_SICOOB = '0';
var Sicoob = /** @class */ (function () {
    function Sicoob() {
    }
    Sicoob.prototype.getTitulos = function () {
        return {
            localDoPagamento: 'Local de Pagamento',
            especieDoDocumento: 'Espécie',
            instrucoes: 'Instruções (texto de responsabilidade do beneficiário)',
            agenciaECodigoDoBeneficiario: 'Coop. contratante/Cód. Beneficiário',
            valorDoDocumento: 'Valor Documento',
            igualDoValorDoDocumento: '',
            nomeDoPagador: 'Nome do Pagador'
        };
    };
    Sicoob.prototype.exibirReciboDoPagadorCompleto = function () {
        return false;
    };
    Sicoob.prototype.exibirCampoCip = function () {
        return false;
    };
    Sicoob.prototype.geraCodigoDeBarrasPara = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        var campoLivre = [];
        campoLivre.push(this.getCarteiraFormatado(beneficiario));
        campoLivre.push(beneficiario.getAgenciaFormatada());
        campoLivre.push(pad(beneficiario.getCarteira(), 2, '0'));
        campoLivre.push(this.getCodigoFormatado(beneficiario));
        campoLivre.push(this.getNossoNumeroFormatado(beneficiario));
        campoLivre.push(beneficiario.getDigitoNossoNumero());
        campoLivre.push('001');
        campoLivre = campoLivre.join('');
        return new codigo_de_barras_builder_1.CodigoDeBarrasBuilder(boleto).comCampoLivre(campoLivre);
    };
    Sicoob.prototype.getNumeroFormatadoComDigito = function () {
        return [NUMERO_SICOOB, DIGITO_SICOOB].join('-');
    };
    Sicoob.prototype.getCarteiraFormatado = function (beneficiario) {
        return pad(beneficiario.getCarteira(), 1, '0');
    };
    Sicoob.prototype.getCarteiraTexto = function (beneficiario) {
        return this.getCarteiraFormatado(beneficiario);
    };
    Sicoob.prototype.getCodigoFormatado = function (beneficiario) {
        return pad(beneficiario.getCodigoBeneficiario(), 7, '0');
    };
    Sicoob.prototype.getImagem = function () {
        return path.join(__dirname, 'logotipos/sicoob.png');
    };
    Sicoob.prototype.getNossoNumeroFormatado = function (beneficiario) {
        return pad(beneficiario.getNossoNumero(), 7, '0');
    };
    Sicoob.prototype.getNossoNumeroECodigoDocumento = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        return pad(beneficiario.getCarteira(), 2, '0') + '/' + [
            this.getNossoNumeroFormatado(beneficiario),
            beneficiario.getDigitoNossoNumero()
        ].join('-');
    };
    Sicoob.prototype.getNumeroFormatado = function () {
        return NUMERO_SICOOB;
    };
    Sicoob.prototype.getNome = function () {
        return '';
    };
    Sicoob.prototype.getImprimirNome = function () {
        return true;
    };
    Sicoob.prototype.getAgenciaECodigoBeneficiario = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        var codigo = this.getCodigoFormatado(beneficiario);
        var digitoCodigo = beneficiario.getDigitoCodigoBeneficiario();
        if (digitoCodigo) {
            codigo += '-' + digitoCodigo;
        }
        return beneficiario.getAgenciaFormatada() + '/' + codigo;
    };
    Sicoob.prototype.novoSicoob = function () {
        return new Sicoob();
    };
    return Sicoob;
}());
exports.Sicoob = Sicoob;
//# sourceMappingURL=sicoob.js.map