"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sicredi = void 0;
var path = __importStar(require("path"));
var string_utils_1 = require("../../utils/string-utils");
var codigo_de_barras_builder_1 = require("../codigo-de-barras-builder");
var pad = string_utils_1.StringUtils.pad;
var insert = string_utils_1.StringUtils.insert;
var NUMERO_SICREDI = '748';
var DIGITO_SICREDI = 'X';
var Sicredi = /** @class */ (function () {
    function Sicredi() {
    }
    Sicredi.prototype.getTitulos = function () {
        return {
            instrucoes: 'Informações de responsabilidade do beneficiário',
            nomeDoPagador: 'Nome do Pagador',
            especie: 'Moeda',
            quantidade: 'Quantidade',
            valor: 'Valor',
            moraMulta: '(+) Juros / Multa'
        };
    };
    Sicredi.prototype.exibirReciboDoPagadorCompleto = function () {
        return true;
    };
    Sicredi.prototype.exibirCampoCip = function () {
        return false;
    };
    Sicredi.prototype.geraCodigoDeBarrasPara = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        var campoLivre = [];
        var arrayDigitoCampoLivre = ('1'
            + beneficiario.getCarteira()
            + beneficiario.getNossoNumero()
            + beneficiario.getDigitoNossoNumero()
            + beneficiario.getAgenciaFormatada()
            + beneficiario.getCodposto()
            + beneficiario.getCodigoBeneficiario()
            + '10').split('');
        var pesos = [9, 8, 7, 6, 5, 4, 3, 2, 9, 8, 7, 6, 5, 4, 3, 2, 9, 8, 7, 6, 5, 4, 3, 2];
        var soma = 0;
        for (var i = 0; i < arrayDigitoCampoLivre.length; i++) {
            soma += pesos[i] * parseInt(arrayDigitoCampoLivre[i], 10);
        }
        var digCampoLivre = soma % 11;
        if (digCampoLivre == 1 || digCampoLivre == 0) {
            digCampoLivre = 0;
        }
        else {
            digCampoLivre = 11 - digCampoLivre;
        }
        campoLivre.push('1');
        campoLivre.push(this.getCarteiraFormatado(beneficiario));
        campoLivre.push(beneficiario.getNossoNumero().substring(0, 3));
        campoLivre.push(beneficiario.getNossoNumero().substring(3, 8));
        campoLivre.push(beneficiario.getDigitoNossoNumero());
        campoLivre.push(beneficiario.getAgenciaFormatada());
        campoLivre.push(beneficiario.getCodposto());
        campoLivre.push(beneficiario.getCodigoBeneficiario());
        campoLivre.push('1');
        campoLivre.push('0');
        campoLivre.push(digCampoLivre);
        return new codigo_de_barras_builder_1.CodigoDeBarrasBuilder(boleto).comCampoLivre(campoLivre);
    };
    Sicredi.prototype.getNumeroFormatadoComDigito = function () {
        return [
            NUMERO_SICREDI,
            DIGITO_SICREDI
        ].join('-');
    };
    Sicredi.prototype.getNumeroFormatado = function () {
        return NUMERO_SICREDI;
    };
    Sicredi.prototype.getCarteiraFormatado = function (beneficiario) {
        return pad(beneficiario.getCarteira(), 1, '0');
    };
    Sicredi.prototype.getCarteiraTexto = function (beneficiario) {
        return pad(beneficiario.getCarteira(), 2, '0');
    };
    Sicredi.prototype.getCodigoFormatado = function (beneficiario) {
        return pad(beneficiario.getCodigoBeneficiario(), 7, '0');
    };
    Sicredi.prototype.getImagem = function () {
        return path.join(__dirname, 'logotipos/sicredi.png');
    };
    Sicredi.prototype.getNossoNumeroFormatado = function (beneficiario) {
        return pad(beneficiario.getNossoNumero(), 8, '0');
    };
    Sicredi.prototype.getNossoNumeroECodigoDocumento = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        return this.getNossoNumeroFormatado(beneficiario).substring(0, 2) + '/' + [
            this.getNossoNumeroFormatado(beneficiario).substring(2),
            beneficiario.getDigitoNossoNumero()
        ].join('-');
    };
    Sicredi.prototype.getNome = function () {
        return 'Sicredi';
    };
    Sicredi.prototype.getImprimirNome = function () {
        return false;
    };
    Sicredi.prototype.getAgenciaECodigoBeneficiario = function (boleto) {
        var beneficiario = boleto.getBeneficiario();
        var codigo = beneficiario.getCodposto() + '.' + beneficiario.getCodigoBeneficiario();
        var digitoCodigo = beneficiario.getDigitoCodigoBeneficiario();
        if (digitoCodigo) {
            codigo += '-' + digitoCodigo;
        }
        return beneficiario.getAgenciaFormatada() + '.' + codigo;
    };
    Sicredi.prototype.novoSicredi = function () {
        return new Sicredi();
    };
    return Sicredi;
}());
exports.Sicredi = Sicredi;
//# sourceMappingURL=sicredi.js.map