"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CodigoDeBarrasBuilder = void 0;
var string_utils_1 = require("../utils/string-utils");
var gerador_de_digito_padrao_1 = require("./gerador-de-digito-padrao");
var valida_codigo_barras_1 = require("./valida-codigo-barras");
var insert = string_utils_1.StringUtils.insert;
var CodigoDeBarrasBuilder = /** @class */ (function () {
    function CodigoDeBarrasBuilder(boleto) {
        var codigoDeBarras = [];
        var banco = boleto.getBanco();
        codigoDeBarras.push(banco.getNumeroFormatado());
        codigoDeBarras.push(boleto.getCodigoEspecieMoeda());
        codigoDeBarras.push(boleto.getFatorVencimento());
        codigoDeBarras.push(boleto.getValorFormatado());
        this['_banco'] = banco;
        this['_codigoDeBarras'] = codigoDeBarras.join('');
    }
    CodigoDeBarrasBuilder.prototype.comCampoLivre = function (campoLivre) {
        var codigoDeBarras = this._codigoDeBarras;
        var banco = this._banco;
        if (Array.isArray(campoLivre))
            campoLivre = campoLivre.join('');
        if (!campoLivre.length)
            throw new Error('Campo livre está vazio');
        codigoDeBarras += campoLivre;
        var digito = gerador_de_digito_padrao_1.GeradorDeDigitoPadrao.mod11(codigoDeBarras);
        codigoDeBarras = insert(codigoDeBarras, 4, digito);
        (0, valida_codigo_barras_1.validarCodigoBarras)(codigoDeBarras);
        return codigoDeBarras;
    };
    return CodigoDeBarrasBuilder;
}());
exports.CodigoDeBarrasBuilder = CodigoDeBarrasBuilder;
//# sourceMappingURL=codigo-de-barras-builder.js.map