"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GeradorDeDigitoPadrao = void 0;
var array_utils_1 = require("../utils/array-utils");
var math_utils_1 = require("../utils/math-utils");
var series = array_utils_1.ArrayUtils.series;
var mod = math_utils_1.MathUtils.mod;
var GeradorDeDigitoPadrao = /** @class */ (function () {
    function GeradorDeDigitoPadrao() {
    }
    GeradorDeDigitoPadrao.mod10 = function (campo) {
        var digito = mod({
            value: campo,
            factors: [2, 1],
            divider: 10,
            direction: 'rightToLeft',
            cumplimentaryToDivider: true,
            reduceSummationTerms: true
        });
        return digito === 10 ? 0 : digito;
    };
    GeradorDeDigitoPadrao.mod11 = function (codigoDeBarras, substituicoes, _series) {
        if (!substituicoes) {
            substituicoes = {
                de: [0, 1, 10, 11],
                para: 1
            };
        }
        if (!Array.isArray(substituicoes.de)) {
            substituicoes.de = [substituicoes.de];
        }
        var digito = mod({
            value: codigoDeBarras.toString(),
            factors: _series ? _series : series(2, 9),
            cumplimentaryToDivider: true
        });
        if (substituicoes.de.indexOf(digito) !== -1) {
            digito = substituicoes.para;
        }
        return digito;
    };
    return GeradorDeDigitoPadrao;
}());
exports.GeradorDeDigitoPadrao = GeradorDeDigitoPadrao;
//# sourceMappingURL=gerador-de-digito-padrao.js.map