import { BancoBrasil } from './boleto/bancos/banco-do-brasil';
import { Bradesco } from './boleto/bancos/bradesco';
import { Caixa } from './boleto/bancos/caixa';
import { Cecred } from './boleto/bancos/cecred';
import { Itau } from './boleto/bancos/itau';
import { Santander } from './boleto/bancos/santander';
import { Sicoob } from './boleto/bancos/sicoob';
import { Sicredi } from './boleto/bancos/sicredi';
export declare const especiesDeDocumento: any;
export declare const bancos: {
    Itau: typeof Itau;
    '341': typeof Itau;
    Caixa: typeof Caixa;
    '104': typeof Caixa;
    Bradesco: typeof Bradesco;
    '237': typeof Bradesco;
    BancoBrasil: typeof BancoBrasil;
    '001': typeof BancoBrasil;
    Cecred: typeof Cecred;
    '085': typeof Cecred;
    Sicoob: typeof Sicoob;
    '756': typeof Sicoob;
    Santander: typeof Santander;
    '033': typeof Santander;
    Sicredi: typeof Sicredi;
    '748': typeof Sicredi;
};
export declare class Boleto {
    [key: string]: any;
    static novoBoleto(): Boleto;
    formatarValor(valor: any): string;
    formatarBRL(valor: any): string;
    getFatorVencimento(): string;
    comEspecieMoeda(_especieMoeda: any): this;
    getEspecieMoeda(): any;
    getCodigoEspecieMoeda(): any;
    comCodigoEspecieMoeda(_codigoEspecieMoeda: any): this;
    getAceite(): any;
    getAceiteFormatado(): "S" | "N";
    comAceite(_aceite: any): this;
    getEspecieDocumento(): any;
    comEspecieDocumento(_especieDocumento: any): this;
    getDatas(): any;
    comDatas(_datas: any): this;
    getValorFormatado(): string;
    getValorFormatadoBRL(): string;
    getValorBoleto(): any;
    comValorBoleto(_valorBoleto: any): this;
    comValor(_valorBoleto: any): void;
    getNumeroDoDocumentoFormatado(): string;
    getNumeroDoDocumento(): any;
    comNumeroDoDocumento(_numeroDoDocumento: any): this;
    getInstrucoes(): any;
    comInstrucoes(_instrucoes: any): this;
    getDescricoes(): any;
    comDescricoes(_descricoes: any): this;
    getLocaisDePagamento(): any;
    comLocaisDePagamento(_locaisDePagamento: any): this;
    getQuantidadeDeMoeda(): any;
    comQuantidadeDeMoeda(_quantidadeDeMoeda: any): this;
    getBanco(): any;
    comBanco(_banco: any): this;
    getPagador(): any;
    comPagador(_pagador: any): this;
    getBeneficiario(): any;
    comBeneficiario(_beneficiario: any): this;
    getValorDescontosFormatadoBRL(): string;
    getValorDescontos(): any;
    comValorDescontos(_valorDescontos: any): this;
    getValorDeducoesFormatadoBRL(): string;
    getValorDeducoes(): any;
    comValorDeducoes(_valorDeducoes: any): this;
    getValorMultaFormatadoBRL(): string;
    getValorMulta(): any;
    comValorMulta(_valorMulta: any): this;
    getValorAcrescimosFormatadoBRL(): any;
    getValorAcrescimos(): any;
    comValorAcrescimos(_valorAcrescimos: any): this;
}
//# sourceMappingURL=boletoUtils.d.ts.map