"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Datas = void 0;
var string_utils_1 = require("./utils/string-utils");
var Datas = /** @class */ (function () {
    function Datas() {
    }
    Datas.novasDatas = function () {
        return new Datas();
    };
    Datas.prototype.removerHoras = function (data) {
        if (typeof data == 'string')
            data = new Date(data);
        data.setHours(0);
        data.setMinutes(0);
        data.setSeconds(0);
        data.setMilliseconds(0);
        return data;
    };
    Datas.prototype.formatar = function (data) {
        if (typeof data == 'string')
            data = new Date(data);
        return [
            string_utils_1.StringUtils.pad(data.getDate(), 2, '0'),
            string_utils_1.StringUtils.pad(data.getMonth() + 1, 2, '0'),
            data.getFullYear()
        ].join('/');
    };
    Datas.prototype.validarData = function (data) {
        if (typeof data == 'string')
            data = new Date(data);
        var ano = data.getFullYear();
        return ano >= 1997 && ano < 2024;
    };
    Datas.prototype.comDocumento = function (_documento) {
        if (arguments.length > 1) {
            _documento = new Date(arguments[2], arguments[1] - 1, arguments[0]);
        }
        if (!this.validarData(_documento)) {
            throw new Error('O ano do documento deve ser maior que 1997 e menor que 2024');
        }
        this._documento = this.removerHoras(_documento);
        return this;
    };
    Datas.prototype.getDocumento = function () {
        return this._documento;
    };
    Datas.prototype.getDocumentoFormatado = function () {
        return this.formatar(this.getDocumento());
    };
    Datas.prototype.comProcessamento = function (_processamento) {
        if (arguments.length > 1) {
            _processamento = new Date(arguments[2], arguments[1] - 1, arguments[0]);
        }
        if (!this.validarData(_processamento)) {
            throw new Error('O ano do documento deve ser maior que 1997 e menor que 2024');
        }
        this._processamento = this.removerHoras(_processamento);
        return this;
    };
    Datas.prototype.getProcessamento = function () {
        return this._processamento;
    };
    Datas.prototype.getProcessamentoFormatado = function () {
        return this.formatar(this.getProcessamento());
    };
    Datas.prototype.comVencimento = function (_vencimento) {
        if (arguments.length > 1) {
            _vencimento = new Date(arguments[2], arguments[1] - 1, arguments[0]);
        }
        if (!this.validarData(_vencimento)) {
            throw new Error('O ano do documento deve ser maior que 1997 e menor que 2024');
        }
        this._vencimento = this.removerHoras(_vencimento);
        return this;
    };
    Datas.prototype.getVencimento = function () {
        return this._vencimento;
    };
    Datas.prototype.getVencimentoFormatado = function () {
        return this.formatar(this._vencimento);
    };
    return Datas;
}());
exports.Datas = Datas;
//# sourceMappingURL=datas.js.map