"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormatacoesUtils = void 0;
var date_utils_1 = require("./utils/date-utils");
var object_utils_1 = require("./utils/object-utils");
var string_utils_1 = require("./utils/string-utils");
var validacoesUtils_1 = require("./validacoesUtils");
var pad = string_utils_1.StringUtils.pad;
var insert = string_utils_1.StringUtils.insert;
var merge = object_utils_1.ObjectUtils.merge;
var isValidDate = date_utils_1.DateUtils.isValidDate;
var FormatacoesUtils = /** @class */ (function () {
    function FormatacoesUtils() {
    }
    FormatacoesUtils.dinheiro = function (_numero, args) {
        if (isNaN(_numero)) {
            return _numero;
        }
        args = merge({
            separadorDecimal: ',',
            separadorDeMilhar: '.',
            casasDecimais: 2,
            simbolo: 'R$ ',
            posicionamento: 'esquerda'
        }, args);
        if (args.posicionamento === 'esquerda') {
            return args.simbolo + FormatacoesUtils.numero(_numero, args);
        }
        else {
            return FormatacoesUtils.numero(_numero, args) + args.simbolo;
        }
    };
    FormatacoesUtils.dinheiroPorExtenso = function (numero) {
        var ex = [
            ['zero', 'um', 'dois', 'três', 'quatro', 'cinco', 'seis', 'sete', 'oito', 'nove', 'dez', 'onze', 'doze', 'treze', 'quatorze', 'quinze', 'dezesseis', 'dezessete', 'dezoito', 'dezenove'],
            ['dez', 'vinte', 'trinta', 'quarenta', 'cinquenta', 'sessenta', 'setenta', 'oitenta', 'noventa'],
            ['cem', 'cento', 'duzentos', 'trezentos', 'quatrocentos', 'quinhentos', 'seiscentos', 'setecentos', 'oitocentos', 'novecentos'],
            ['mil', 'milhão', 'bilhão', 'trilhão', 'quadrilhão', 'quintilhão', 'sextilhão', 'setilhão', 'octilhão', 'nonilhão', 'decilhão', 'undecilhão', 'dodecilhão', 'tredecilhão', 'quatrodecilhão', 'quindecilhão', 'sedecilhão', 'septendecilhão', 'octencilhão', 'nonencilhão']
        ];
        numero = numero.toString();
        numero = numero.replace('.', ',');
        var c = true;
        var a;
        var v;
        var i;
        var n = numero.replace(c ? /[^,\d]/g : /\D/g, '').split(',');
        var e = ' e ';
        var $ = 'real';
        var d = 'centavo';
        var r = [];
        var sl;
        for (var f = n.length - 1, l = void 0, j = -1, s = [], t = ''; ++j <= f; s = []) {
            // tslint:disable-next-line:no-unused-expression
            j && (n[j] = (parseFloat(('.' + n[j]))).toFixed(2).slice(2));
            if (!(a = (v = n[j]).slice((l = v.length) % 3).match(/\d{3}/g), v = l % 3 ? [v.slice(0, l % 3)] : [], v = a ? v.concat(a) : v).length)
                continue;
            for (a = -1, l = v.length; ++a < l; t = '') {
                // tslint:disable-next-line:no-conditional-assignment
                if (!(i = v[a] * 1))
                    continue;
                // tslint:disable-next-line:no-unused-expression
                i % 100 < 20 && (t += ex[0][i % 100]) ||
                    // tslint:disable-next-line:no-bitwise
                    i % 100 + 1 && (t += ex[1][(i % 100 / 10 >> 0) - 1] + (i % 10 ? e + ex[0][i % 10] : ''));
                // tslint:disable-next-line:no-bitwise
                s.push((i < 100 ? t : !(i % 100) ? ex[2][i == 100 ? 0 : i / 100 >> 0] : (ex[2][i / 100 >> 0] + e + t)) +
                    // tslint:disable-next-line:no-conditional-assignment
                    ((t = l - a - 2) > -1 ? ' ' + (i > 1 && t > 0 ? ex[3][t].replace('?o', '?es') : ex[3][t]) : ''));
            }
            // tslint:disable-next-line:no-conditional-assignment
            a = ((sl = s.length) > 1 ? (a = s.pop(), s.join(' ') + e + a) : s.join('') || ((!j && (n[j + 1] * 1 > 0) || r.length) ? '' : ex[0][0]));
            // tslint:disable-next-line:no-unused-expression
            a && r.push(a + (c ? (' ' + (v.join('') * 1 > 1 ? j ? d + 's' : (/0{6,}$/.test(n[0]) ? 'de ' : '') + $.replace('l', 'is') : j ? d : $)) : ''));
        }
        var resultado = r.join(e);
        if (resultado === 'zero real') {
            return 'zero reais';
        }
        return resultado;
    };
    FormatacoesUtils.numero = function (numero, args) {
        if (isNaN(numero)) {
            return numero;
        }
        var casasDecimaisOriginais = numero.toString().split('.');
        if (casasDecimaisOriginais.length > 1) {
            casasDecimaisOriginais = casasDecimaisOriginais[1].length;
        }
        else {
            casasDecimaisOriginais = 0;
        }
        args = merge({
            separadorDecimal: ',',
            separadorDeMilhar: '.',
            casasDecimais: casasDecimaisOriginais
        }, args);
        var _format = function (n, x, s, c) {
            // http://stackoverflow.com/questions/149055/how-can-i-format-numbers-as-money-in-javascript
            var re = '\\d(?=(\\d{' + (x || 3) + '})+' + (n > 0 ? '\\D' : '$') + ')';
            var num = numero.toString().replace(new RegExp('\\.([\\d]{' + args.casasDecimais + '})[\\d]*?$'), '.$1');
            num = parseFloat(num).toFixed(args.casasDecimais);
            return (c ? num.replace('.', c) : num).replace(new RegExp(re, 'g'), '$&' + (s || ','));
        };
        return _format(args.casasDecimais, 3, args.separadorDeMilhar, args.separadorDecimal);
    };
    FormatacoesUtils.removerMascara = function (texto) {
        if (typeof texto !== 'string') {
            return texto;
        }
        return texto
            .trim()
            .replace(/\(/g, '')
            .replace(/\)/g, '')
            .replace(/\./g, '')
            .replace(/\//g, '')
            .replace(/-/g, '')
            .replace(/\s/g, '')
            .replace(/R\$/g, '')
            .replace(/%/g, '')
            .trim();
    };
    FormatacoesUtils.linhaDigitavel = function (valor) {
        valor = FormatacoesUtils.removerMascara(valor);
        if (valor.length !== 47) {
            return valor;
        }
        valor = insert(valor, 5, '.');
        valor = insert(valor, 11, ' ');
        valor = insert(valor, 17, '.');
        valor = insert(valor, 24, ' ');
        valor = insert(valor, 30, '.');
        valor = insert(valor, 37, ' ');
        valor = insert(valor, 39, ' ');
        return valor;
    };
    FormatacoesUtils.hora = function (data, args) {
        if (!isValidDate(data)) {
            return data;
        }
        args = merge({
            comSegundos: true
        }, args);
        var componentes = [
            pad(data.getHours(), 2, '0'),
            pad(data.getMinutes(), 2, '0')
        ];
        if (args.comSegundos) {
            componentes.push(pad(data.getSeconds(), 2, '0'));
        }
        return componentes.join(':');
    };
    FormatacoesUtils.data = function (data) {
        if (!isValidDate(data)) {
            return data;
        }
        return [
            pad(data.getDate(), 2, '0'),
            pad(data.getMonth() + 1, 2, '0'),
            data.getFullYear()
        ].join('/');
    };
    FormatacoesUtils.dataEHora = function (_data, args) {
        if (!isValidDate(_data)) {
            return _data;
        }
        return [
            FormatacoesUtils.data(_data),
            FormatacoesUtils.hora(_data, args)
        ].join(' ');
    };
    FormatacoesUtils.tituloDeEleitor = function (texto) {
        if (!validacoesUtils_1.ValidacoesUtils.eTituloDeEleitor(texto)) {
            return texto;
        }
        return FormatacoesUtils.removerMascara(texto).match(/.{4}/g).join(' ');
    };
    FormatacoesUtils.cnpj = function (texto) {
        if (!validacoesUtils_1.ValidacoesUtils.eCnpj(texto))
            return texto;
        if (texto.trim().length > 14)
            return texto;
        texto = texto.trim();
        return texto.substr(0, 2) + '.' +
            texto.substr(2, 3) + '.' +
            texto.substr(5, 3) + '/' +
            texto.substr(8, 4) + '-' +
            texto.substr(12, 2);
    };
    FormatacoesUtils.cpf = function (texto) {
        if (!validacoesUtils_1.ValidacoesUtils.eCpf(texto))
            return texto;
        if (texto.trim().length > 11)
            return texto;
        texto = texto.trim();
        return texto.substr(0, 3) + '.' +
            texto.substr(3, 3) + '.' +
            texto.substr(6, 3) + '-' +
            texto.substr(9, 2);
    };
    FormatacoesUtils.pisPasep = function (texto) {
        if (!validacoesUtils_1.ValidacoesUtils.ePisPasep(texto))
            return texto;
        if (texto.trim().length > 11)
            return texto;
        texto = texto.trim();
        return texto.substr(0, 3) + '.' +
            texto.substr(3, 4) + '.' +
            texto.substr(7, 3) + '-' +
            texto.substr(10, 1);
    };
    FormatacoesUtils.registroNacional = function (texto) {
        var tipo = validacoesUtils_1.ValidacoesUtils.eRegistroNacional(texto);
        if (!tipo) {
            return texto;
        }
        switch (tipo) {
            case 'cpf':
                return FormatacoesUtils.cpf(texto);
            case 'cnpj':
                return FormatacoesUtils.cnpj(texto);
        }
    };
    FormatacoesUtils.placa = function (texto) {
        if (!validacoesUtils_1.ValidacoesUtils.ePlaca(texto))
            return texto;
        texto = texto.trim().replace(/-/g, '');
        return texto.substr(0, 3).toUpperCase() + '-' + texto.substr(3, 4);
    };
    FormatacoesUtils.cep = function (texto) {
        if (!validacoesUtils_1.ValidacoesUtils.eCep(texto))
            return texto;
        texto = texto.trim().replace(/-/g, '').replace(/\./g, '');
        return texto.substr(0, 2) + '.' + texto.substr(2, 3) + '-' + texto.substr(5, 3);
    };
    return FormatacoesUtils;
}());
exports.FormatacoesUtils = FormatacoesUtils;
//# sourceMappingURL=formatacoesUtils.js.map