"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Pagador = void 0;
var endereco_1 = require("./endereco");
var formatacoesUtils_1 = require("./formatacoesUtils");
var validacoesUtils_1 = require("./validacoesUtils");
var Pagador = /** @class */ (function () {
    function Pagador() {
    }
    Pagador.novoPagador = function () {
        return new Pagador().comEndereco(endereco_1.Endereco.novoEndereco());
    };
    Pagador.prototype.getNome = function () {
        return this._nome;
    };
    Pagador.prototype.comNome = function (_nome) {
        this._nome = _nome;
        return this;
    };
    Pagador.prototype.getIdentificacao = function () {
        var identificacao = this.getNome();
        var tipo = this.temRegistroNacional();
        // TODO: Inserir novamente o registro nacional depois
        // de implementar mecanismo para o texto não extravassar
        // do campo.
        if (tipo) {
            identificacao += [
                ' (',
                tipo.toUpperCase(),
                ': ',
                this.getRegistroNacionalFormatado(),
                ')'
            ].join('') || '';
        }
        return (identificacao || '').toUpperCase();
    };
    Pagador.prototype.getRegistroNacional = function () {
        return this._registroNacional;
    };
    Pagador.prototype.getRegistroNacionalFormatado = function () {
        return formatacoesUtils_1.FormatacoesUtils.registroNacional(this._registroNacional);
    };
    Pagador.prototype.temRegistroNacional = function () {
        return validacoesUtils_1.ValidacoesUtils.eRegistroNacional(this._registroNacional);
    };
    Pagador.prototype.comCNPJ = function (_cnpj) {
        this.comRegistroNacional(_cnpj);
        return this;
    };
    Pagador.prototype.comCPF = function (_cpf) {
        this.comRegistroNacional(_cpf);
        return this;
    };
    Pagador.prototype.comRegistroNacional = function (_registroNacional) {
        this._registroNacional = _registroNacional;
        return this;
    };
    Pagador.prototype.getDocumento = function () {
        return this._documento;
    };
    Pagador.prototype.comDocumento = function (_documento) {
        this._documento = _documento;
        return this;
    };
    Pagador.prototype.getEndereco = function () {
        return this._endereco;
    };
    Pagador.prototype.comEndereco = function (_endereco) {
        this._endereco = _endereco;
        return this;
    };
    return Pagador;
}());
exports.Pagador = Pagador;
//# sourceMappingURL=pagador.js.map