"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MathUtils = void 0;
var array_utils_1 = require("./array-utils");
var MathUtils = /** @class */ (function () {
    function MathUtils() {
    }
    MathUtils.mod = function (value, factors, divider, direction) {
        var reduceSummationTerms = false;
        var complimentaryToDivider = false;
        if (arguments.length === 1 && typeof value === 'object') {
            factors = value.factors;
            divider = value.divider;
            direction = value.direction;
            reduceSummationTerms = value.reduceSummationTerms;
            complimentaryToDivider = value.cumplimentaryToDivider;
            value = value.value;
        }
        if (divider === undefined) {
            divider = 11;
        }
        if (factors === undefined) {
            factors = array_utils_1.ArrayUtils.series(2, 9);
        }
        if (direction === undefined) {
            direction = 'rightToLeft';
        }
        var reduceMethod = direction === 'leftToRight' ? 'reduce' : 'reduceRight';
        var i = 0;
        var result = value.split('')[reduceMethod](function (last, current) {
            if (i > factors.length - 1) {
                i = 0;
            }
            var total = factors[i++] * parseInt(current, 10);
            var sum = function (a, b) { return a + b; };
            if (reduceSummationTerms) {
                total = total.toString().split('').map(Number).reduce(sum, 0);
            }
            return total + last;
        }, 0) % divider;
        // todo result zero somente no bradesco da problema
        if (result && complimentaryToDivider) {
            result = divider - result;
        }
        return result;
    };
    return MathUtils;
}());
exports.MathUtils = MathUtils;
//# sourceMappingURL=math-utils.js.map