"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StringUtils = void 0;
var StringUtils = /** @class */ (function () {
    function StringUtils() {
    }
    StringUtils.pad = function (str, length, padStr, type) {
        /* jshint ignore:start, unused:false */
        str = str == null ? '' : String(str);
        // tslint:disable-next-line:no-bitwise
        length = ~~length;
        var padlen = 0;
        if (!padStr)
            padStr = ' ';
        else if (padStr.length > 1)
            padStr = padStr.charAt(0);
        switch (type) {
            case 'right':
                padlen = length - str.length;
                return str + StringUtils.strRepeat(padStr, padlen);
            case 'both':
                padlen = length - str.length;
                return StringUtils.strRepeat(padStr, Math.ceil(padlen / 2)) + str +
                    StringUtils.strRepeat(padStr, Math.floor(padlen / 2));
            default: // 'left'
                padlen = length - str.length;
                return StringUtils.strRepeat(padStr, padlen) + str;
        }
        /* jshint ignore:end */
    };
    StringUtils.strRepeat = function (str, qty) {
        if (qty < 1)
            return '';
        var result = '';
        while (qty > 0) {
            // tslint:disable-next-line:no-bitwise
            if (qty & 1)
                result += str;
            // tslint:disable-next-line:no-bitwise
            qty >>= 1, str += str;
        }
        return result;
    };
    StringUtils.insert = function (string, index, value) {
        return [
            string.substring(0, index),
            value,
            string.substring(index, string.length)
        ].join('');
    };
    StringUtils.capitalize = function (value) {
        if (typeof value !== 'string') {
            return value;
        }
        return value.substr(0, 1).toUpperCase() + value.substr(1);
    };
    return StringUtils;
}());
exports.StringUtils = StringUtils;
//# sourceMappingURL=string-utils.js.map