"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CacheHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var operators_1 = require("rxjs/operators");
var CacheHook = /** @class */ (function (_super) {
    __extends(CacheHook, _super);
    function CacheHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CacheHook.prototype.invalidate = function (inputArtifact) {
        return this.service('CacheService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.invalidate(inputArtifact.object.key, inputArtifact.object.systemId);
        })).pipe((0, operators_1.map)(function (result) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = result;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    CacheHook.prototype.set = function (inputArtifact) {
        return this.service('CacheService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.setCache(inputArtifact.object.key, inputArtifact.object.data, inputArtifact.object.expire);
        })).pipe((0, operators_1.map)(function (result) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = inputArtifact.object.data;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    CacheHook.prototype.get = function (inputArtifact) {
        return this.service('CacheService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.getCache(inputArtifact.object.key);
        })).pipe((0, operators_1.map)(function (result) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = result;
            if (result != null)
                artifact.object = JSON.parse(result);
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('3c0042cc-d5ed-4088-8b5b-6290938b0bf0')
    ], CacheHook.prototype, "invalidate", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('17e5711d-68d9-4a3d-bcf6-e4d9b4ff32b7')
    ], CacheHook.prototype, "set", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('cccd534a-e764-4519-88ac-5d968eb05879')
    ], CacheHook.prototype, "get", null);
    CacheHook = __decorate([
        (0, nick_process_commons_1.HookClass)('cache')
    ], CacheHook);
    return CacheHook;
}(nick_process_commons_1.BaseHook));
exports.CacheHook = CacheHook;
//# sourceMappingURL=cache.hook.js.map