"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColorHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var ColorHook = /** @class */ (function () {
    function ColorHook() {
    }
    ColorHook.prototype.contrastColor = function (input) {
        var colourIsLight = function (r, g, b) {
            // Counting the perceptive luminance
            // human eye favors green color...
            var a = 1 - (0.299 * r + 0.587 * g + 0.114 * b) / 255;
            return (a < 0.5);
        };
        var hexToRgb = function (hex) {
            // Expand shorthand form (e.g. "03F") to full form (e.g. "0033FF")
            var shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])$/i;
            hex = hex.replace(shorthandRegex, function (m, r, g, b) {
                return r + r + g + g + b + b;
            });
            var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
            return result ? {
                r: parseInt(result[1], 16),
                g: parseInt(result[2], 16),
                b: parseInt(result[3], 16)
            } : null;
        };
        var colorRGB = hexToRgb(input.object.data);
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = colourIsLight(colorRGB.r, colorRGB.g, colorRGB.b) ? 'black' : 'white';
        return (0, rxjs_1.of)(outputArtifact);
    };
    ColorHook.prototype.darkLightColor = function (input) {
        var color = input.object.data.color;
        var amount = input.object.data.value;
        var usePound = false;
        if (color[0] == '#') {
            color = color.slice(1);
            usePound = true;
        }
        var num = parseInt(color, 16);
        var r = (num >> 16) + amount;
        if (r > 255)
            r = 255;
        else if (r < 0)
            r = 0;
        var b = ((num >> 8) & 0x00FF) + amount;
        if (b > 255)
            b = 255;
        else if (b < 0)
            b = 0;
        var g = (num & 0x0000FF) + amount;
        if (g > 255)
            g = 255;
        else if (g < 0)
            g = 0;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = (usePound ? '#' : '') + (g | (b << 8) | (r << 16)).toString(16);
        return (0, rxjs_1.of)(outputArtifact);
    };
    ColorHook.prototype.randomColor = function (input) {
        var red = Math.random() * 256 >> 0;
        var green = Math.random() * 256 >> 0;
        var blue = Math.random() * 256 >> 0;
        // mix the color
        if (input.object.config) {
            red = (red + input.object.config.red) / 2 >> 0;
            green = (green + input.object.config.green) / 2 >> 0;
            blue = (blue + input.object.config.blue) / 2 >> 0;
        }
        var rr = red.toString(16);
        if (rr.length === 1) {
            rr = '0' + rr[0];
        }
        var gg = green.toString(16);
        if (gg.length === 1) {
            gg = '0' + gg[0];
        }
        var bb = blue.toString(16);
        if (bb.length === 1) {
            bb = '0' + bb[0];
        }
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = "#".concat(rr).concat(gg).concat(bb);
        return (0, rxjs_1.of)(outputArtifact);
    };
    ColorHook.prototype.randomPastelColor = function (input) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = 'hsl(' + 360 * Math.random() + ',' +
            (25 + 70 * Math.random()) + '%,' +
            (85 + 10 * Math.random()) + '%)';
        return (0, rxjs_1.of)(outputArtifact);
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('d6c20898-06e1-42af-aa76-1de98e3c9a06')
    ], ColorHook.prototype, "contrastColor", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('cdaf37c7-220b-43f5-9c18-88f67db1b23b')
    ], ColorHook.prototype, "darkLightColor", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('1f1aed97-ffc0-434c-9aed-104673c041a3')
    ], ColorHook.prototype, "randomColor", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('af43e66b-c581-439a-ac49-b52f32a728be')
    ], ColorHook.prototype, "randomPastelColor", null);
    ColorHook = __decorate([
        (0, nick_process_commons_1.HookClass)('color.hook')
    ], ColorHook);
    return ColorHook;
}());
exports.ColorHook = ColorHook;
//# sourceMappingURL=color.hook.js.map