"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataNormalizeHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var OperationKind;
(function (OperationKind) {
    OperationKind[OperationKind["REGEX"] = 0] = "REGEX";
})(OperationKind || (OperationKind = {}));
var DataNormalizeHook = /** @class */ (function (_super) {
    __extends(DataNormalizeHook, _super);
    function DataNormalizeHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DataNormalizeHook.prototype.normalize = function (input) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = {};
        return (0, rxjs_1.from)(input.object.operations)
            .pipe((0, operators_1.concatMap)(function (operation) {
            switch (operation.kind) {
                case OperationKind.REGEX: {
                    var ls = Object.keys(input.object.data);
                    return (0, rxjs_1.from)(ls)
                        .pipe((0, operators_1.filter)(function (property) { return input.object.data[property] != undefined; }))
                        .pipe((0, operators_1.map)(function (property) {
                        if (operation.field == property && input.object.data[property] != undefined) {
                            if (!input.object.data[property].match)
                                input.object.data[property] = input.object.data[property].toString();
                            var result = input.object.data[property].match(new RegExp(operation.regex.expression, operation.regex.type));
                            if (operation.defaultValue != undefined && !result)
                                input.object.data[property] = operation.defaultValue;
                            else
                                input.object.data[property] = result === null || result === void 0 ? void 0 : result.join('');
                        }
                        return input.object.data[property];
                    }), (0, operators_1.toArray)())
                        .pipe((0, operators_1.map)(function () {
                        outputArtifact.object = input.object.data;
                    }));
                }
            }
        }), (0, operators_1.toArray)())
            .pipe((0, operators_1.map)(function () { return outputArtifact; }));
    };
    DataNormalizeHook.prototype.padLeft = function (input) {
        input.object.data = input.object.data.toString().padStart(input.object.config.length, input.object.config.character);
        return (0, rxjs_1.of)(input);
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('822d265b-1ffa-46fd-a324-12f68e2cf589')
    ], DataNormalizeHook.prototype, "normalize", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('20cb8ef6-1c3d-455b-a7ea-2f9758167c15')
    ], DataNormalizeHook.prototype, "padLeft", null);
    DataNormalizeHook = __decorate([
        (0, nick_process_commons_1.HookClass)('data')
    ], DataNormalizeHook);
    return DataNormalizeHook;
}(nick_process_commons_1.BaseHook));
exports.DataNormalizeHook = DataNormalizeHook;
//# sourceMappingURL=data.normalize.hook.js.map