"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DatabaseCassandraHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var fs_1 = __importDefault(require("fs"));
var os_1 = __importDefault(require("os"));
var rxjs_1 = require("rxjs");
var cassandra_driver_1 = require("cassandra-driver");
var sigV4 = __importStar(require("aws-sigv4-auth-cassandra-plugin"));
var operators_1 = require("rxjs/operators");
var uuid_1 = require("uuid");
var aws_s3_hook_1 = require("../../aws/aws.s3.hook");
var DatabaseCassandraHook = /** @class */ (function (_super) {
    __extends(DatabaseCassandraHook, _super);
    function DatabaseCassandraHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DatabaseCassandraHook_1 = DatabaseCassandraHook;
    DatabaseCassandraHook.prototype.authenticate = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.dbId)
                throw new Error('Invalid Database ID.');
            if (DatabaseCassandraHook_1.connections.has(inputArtifact.object.dbId))
                return (0, rxjs_1.of)(DatabaseCassandraHook_1.connections.get(inputArtifact.object.dbId));
            return _this.service('DbService')
                .pipe((0, operators_1.concatMap)(function (service) {
                return service.findOne(inputArtifact.object.dbId)
                    .pipe((0, operators_1.map)(function (dbEntity) {
                    dbEntity.accessKey$ = service.getAccessKey(dbEntity);
                    return dbEntity;
                }));
            }))
                .pipe((0, operators_1.concatMap)(function (dbEntity) {
                return dbEntity.accessKey$
                    .pipe((0, operators_1.concatMap)(function (access) {
                    var accessConnect$ = (0, rxjs_1.of)(access);
                    if (access.secureConnectBundle) {
                        accessConnect$ = _this.make(aws_s3_hook_1.AwsS3Hook)
                            .pipe((0, operators_1.concatMap)(function (s3Hook) {
                            var downloadArtifact = new nick_process_commons_1.NickProcessArtfact();
                            downloadArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                            downloadArtifact.object = { data: { key: access.secureConnectBundle } };
                            return s3Hook.downloadToBuffer(downloadArtifact)
                                .pipe((0, operators_1.concatMap)(function (downloadArtifact) {
                                access.secureConnectBundle = "".concat(os_1.default.tmpdir(), "/").concat(access.key, ".zip");
                                var writeStream = fs_1.default.createWriteStream(access.secureConnectBundle);
                                return new rxjs_1.Observable(function (observer) {
                                    writeStream.write(downloadArtifact.object, function (err) {
                                        if (err) {
                                            observer.error(err);
                                            observer.complete();
                                            return;
                                        }
                                        observer.next(access);
                                        observer.complete();
                                    });
                                });
                            }));
                        }));
                    }
                    if (access.sigV4AuthProvider) {
                        access.authProvider = new sigV4.SigV4AuthProvider(access.sigV4AuthProvider);
                        accessConnect$ = _this.make(aws_s3_hook_1.AwsS3Hook)
                            .pipe((0, operators_1.concatMap)(function (s3Hook) {
                            var downloadArtifact = new nick_process_commons_1.NickProcessArtfact();
                            downloadArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                            downloadArtifact.object = { data: { key: access.sslOptions.ca } };
                            return s3Hook.downloadToBuffer(downloadArtifact)
                                .pipe((0, operators_1.concatMap)(function (downloadArtifact) {
                                access.sslOptions.ca = "".concat(os_1.default.tmpdir(), "/").concat(access.key);
                                var writeStream = fs_1.default.createWriteStream(access.sslOptions.ca);
                                return new rxjs_1.Observable(function (observer) {
                                    writeStream.write(downloadArtifact.object, function (err) {
                                        if (err) {
                                            observer.error(err);
                                            observer.complete();
                                            return;
                                        }
                                        access.sslOptions.ca = [fs_1.default.readFileSync(access.sslOptions.ca, 'utf-8')];
                                        observer.next(access);
                                        observer.complete();
                                    });
                                });
                            }));
                        }));
                    }
                    return accessConnect$
                        .pipe((0, operators_1.concatMap)(function () {
                        var client = new cassandra_driver_1.Client({
                            id: cassandra_driver_1.types.Uuid.fromString(dbEntity.id),
                            cloud: access.secureConnectBundle ? {
                                secureConnectBundle: access.secureConnectBundle
                            } : null,
                            credentials: access.user ? {
                                username: access.user,
                                password: access.password
                            } : null,
                            pooling: {},
                            authProvider: access.authProvider ? access.authProvider : null,
                            sslOptions: access.sslOptions ? access.sslOptions : null,
                            protocolOptions: access.protocolOptions ? access.protocolOptions : null,
                            contactPoints: access.contactPoints,
                            localDataCenter: access.localDataCenter
                            // keyspace: dbEntity.dbName
                        });
                        return _this.service('ModelDbXrefService')
                            .pipe((0, operators_1.concatMap)(function (service) {
                            return service.findModelsByDatabaseId(dbEntity.id);
                        }))
                            .pipe((0, operators_1.concatMap)(function (models) {
                            client._models = models;
                            client._modelsMap = new Map();
                            client._dbEntity = dbEntity;
                            models.forEach(function (model) {
                                DatabaseCassandraHook_1.connectionByModel.set(model.modelId, dbEntity.id);
                                client._modelsMap.set(model.modelId, model.model);
                            });
                            // todo: store connection with keyspace in hash key name
                            DatabaseCassandraHook_1.connections.set(dbEntity.id, client);
                            return (0, rxjs_1.from)(client.connect())
                                .pipe((0, operators_1.map)(function () { return client; }));
                        }));
                    }));
                }));
            }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            // const queryArtifact = new NickProcessArtfact();
            // queryArtifact.kind = ArtfactKind.ANY;
            // queryArtifact.object = {
            //     dbId: inputArtifact.object.dbId,
            //     query: `CREATE KEYSPACE IF NOT EXISTS "${client._dbEntity.dbName}" WITH replication = {'class': 'SimpleStrategy', 'replication_factor' : 3}`,
            //     params: []
            // };
            // return this.query(queryArtifact)
            //     .pipe(concatMap(() => {
            var queryArtifact = new nick_process_commons_1.NickProcessArtfact();
            queryArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            queryArtifact.object = {
                dbId: inputArtifact.object.dbId,
                query: "USE \"".concat(client._dbEntity.dbName, "\""),
                params: []
            };
            return _this.query(queryArtifact);
            // }));
        }))
            .pipe((0, operators_1.map)(function () {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = { success: true };
            return outputArtifact;
        }));
    };
    DatabaseCassandraHook.prototype.query = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.dbId)
                throw new Error('Invalid modelId');
            if (DatabaseCassandraHook_1.connections.has(inputArtifact.object.dbId))
                return (0, rxjs_1.of)(DatabaseCassandraHook_1.connections.get(inputArtifact.object.dbId));
            var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
            connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            connectArtifact.object = { dbId: inputArtifact.object.dbId };
            return _this.authenticate(connectArtifact)
                .pipe((0, operators_1.map)(function () { return DatabaseCassandraHook_1.connections.get(inputArtifact.object.dbId); }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            return (0, rxjs_1.from)(client.execute(inputArtifact.object.query, inputArtifact.object.params));
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result;
            return outputArtifact;
        }));
    };
    DatabaseCassandraHook.prototype.sync = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.dbId)
                throw new Error('Invalid dbId');
            if (DatabaseCassandraHook_1.connections.has(inputArtifact.object.dbId))
                return (0, rxjs_1.of)(DatabaseCassandraHook_1.connections.get(inputArtifact.object.dbId));
            var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
            connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            connectArtifact.object = { dbId: inputArtifact.object.dbId };
            return _this.authenticate(connectArtifact)
                .pipe((0, operators_1.map)(function () { return DatabaseCassandraHook_1.connections.get(inputArtifact.object.dbId); }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            return (0, rxjs_1.from)(Array.from(client._modelsMap.values()))
                .pipe((0, operators_1.concatMap)(function (model) {
                var createArtifact = new nick_process_commons_1.NickProcessArtfact();
                createArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                createArtifact.object = { modelId: model.id };
                return _this.createTable(createArtifact);
            }), (0, operators_1.toArray)());
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result;
            return outputArtifact;
        }));
    };
    DatabaseCassandraHook.prototype.createTable = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.modelId)
                throw new Error('Invalid modelId');
            var connect$ = function (dbId) { return (0, rxjs_1.of)(inputArtifact)
                .pipe((0, operators_1.concatMap)(function () {
                if (DatabaseCassandraHook_1.connectionByModel.has(inputArtifact.object.modelId))
                    return (0, rxjs_1.of)(DatabaseCassandraHook_1.connections.get(DatabaseCassandraHook_1.connectionByModel.get(inputArtifact.object.modelId)));
                var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
                connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                connectArtifact.object = { dbId: dbId };
                return _this.authenticate(connectArtifact);
            })); };
            return _this.service('ModelDbXrefService')
                .pipe((0, operators_1.concatMap)(function (service) {
                return service.findModelDbXrefByModelId(inputArtifact.object.modelId)
                    .pipe((0, operators_1.concatMap)(function (modelDbXref) {
                    // load metadata of model
                    return _this.service('ModelService')
                        .pipe((0, operators_1.concatMap)(function (modelService) {
                        return modelService.buildTableMetadata(modelDbXref.model, 'cassandra')
                            .pipe((0, operators_1.concatMap)(function (metadata) {
                            return connect$(modelDbXref.dbId)
                                .pipe((0, operators_1.map)(function () {
                                var client = DatabaseCassandraHook_1.connections.get(DatabaseCassandraHook_1.connectionByModel.get(inputArtifact.object.modelId));
                                client._modelsMap.get(inputArtifact.object.modelId).metadata = metadata;
                                return client;
                            }));
                        }));
                    }));
                }));
            }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            var model = client._modelsMap.get(inputArtifact.object.modelId);
            var fields = Object.keys(model.metadata).map(function (columnName) {
                var field = model.metadata[columnName];
                var type = null;
                switch (field.type) {
                    case nick_data_commons_1.FieldTypeKind.STRING:
                        type = 'VARCHAR';
                        break;
                    case nick_data_commons_1.FieldTypeKind.GUID:
                        type = 'UUID';
                        break;
                    case nick_data_commons_1.FieldTypeKind.BOOLEAN:
                        type = 'BOOLEAN';
                        break;
                    case nick_data_commons_1.FieldTypeKind.DATE:
                        type = 'TIMESTAMP';
                        break;
                    case nick_data_commons_1.FieldTypeKind.LONG:
                        type = 'INT';
                        break;
                    case nick_data_commons_1.FieldTypeKind.ANY:
                        break;
                    case nick_data_commons_1.FieldTypeKind.MODEL:
                        break;
                    case nick_data_commons_1.FieldTypeKind.VIRTUAL:
                        break;
                    case nick_data_commons_1.FieldTypeKind.ENUM:
                        type = 'DECIMAL';
                        break;
                    case nick_data_commons_1.FieldTypeKind.HTML:
                        type = 'TEXT';
                        break;
                    case nick_data_commons_1.FieldTypeKind.MONEY:
                        type = 'DECIMAL';
                        break;
                    case nick_data_commons_1.FieldTypeKind.DECIMAL:
                        type = 'DECIMAL';
                        break;
                    case nick_data_commons_1.FieldTypeKind.TELEPHONE:
                        type = 'VARCHAR';
                        break;
                    case nick_data_commons_1.FieldTypeKind.TEXT:
                        type = 'TEXT';
                        break;
                    case nick_data_commons_1.FieldTypeKind.POINT:
                        type = 'PointType';
                        break;
                    case nick_data_commons_1.FieldTypeKind.FILE:
                        break;
                    case nick_data_commons_1.FieldTypeKind.MONGOID:
                        type = 'VARCHAR';
                        break;
                    case nick_data_commons_1.FieldTypeKind.BLOB:
                        type = 'BLOB';
                        break;
                    case nick_data_commons_1.FieldTypeKind.BIGINT:
                        type = 'BIGINT';
                        break;
                    case nick_data_commons_1.FieldTypeKind.SEARCH:
                        break;
                }
                return "\"".concat(columnName, "\" ").concat(type);
            }).join(', ');
            var primaryKeys = "PRIMARY KEY (".concat(model.settings.primaryKey, ")");
            var clustering;
            var compacting;
            var sufix;
            /**
             * WITH CLUSTERING ORDER BY ("startAt" DESC)
             *    AND COMPACTION = {'class': 'TimeWindowCompactionStrategy',
             *             'compaction_window_unit': 'DAYS',
             *             'compaction_window_size': 1};
             */
            if (model.settings.clustering)
                clustering = "CLUSTERING ORDER BY (".concat(model.settings.clustering, ")");
            if (model.settings.compacting)
                compacting = "COMPACTION = ".concat(JSON.stringify(model.settings.compacting).replace(/\"/g, '\''));
            if (clustering && compacting)
                sufix = "WITH ".concat(clustering, " AND ").concat(compacting);
            return (0, rxjs_1.from)(client.execute("\n                    CREATE TABLE IF NOT EXISTS \"".concat(model.tableName, "\"\n                    (\n                        ").concat(fields, ",\n                        ").concat(primaryKeys, "\n                    )\n                    ").concat(sufix, ";"), [], { consistency: cassandra_driver_1.types.consistencies.localQuorum }));
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result.rows;
            return outputArtifact;
        }));
    };
    DatabaseCassandraHook.prototype.findRows = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.modelId)
                throw new Error('Invalid modelId');
            if (DatabaseCassandraHook_1.connectionByModel.has(inputArtifact.object.modelId))
                return (0, rxjs_1.of)(DatabaseCassandraHook_1.connections.get(DatabaseCassandraHook_1.connectionByModel.get(inputArtifact.object.modelId)));
            return _this.service('ModelDbXrefService')
                .pipe((0, operators_1.concatMap)(function (service) {
                return service.findModelDbXrefByModelId(inputArtifact.object.modelId)
                    .pipe((0, operators_1.concatMap)(function (modelDbXref) {
                    var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
                    connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                    connectArtifact.object = { dbId: modelDbXref.dbId };
                    return _this.authenticate(connectArtifact);
                }))
                    .pipe((0, operators_1.concatMap)(function () {
                    return (0, rxjs_1.of)(DatabaseCassandraHook_1.connections.get(DatabaseCassandraHook_1.connectionByModel.get(inputArtifact.object.modelId)));
                }));
            }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            // const model = client._modelsMap.get(inputArtifact.object.modelId);
            // const customAttributes = new Map<string, any>();
            //
            // if (inputArtifact.object.config?.attributes) {
            //     inputArtifact.object.config?.attributes.forEach((attr: string) => {
            //         if (attr.indexOf('|fn:count') >= 0) {
            //             const attribute = attr.replace('|fn:count', '');
            //             customAttributes.set(attribute, {aggregate: 'count'});
            //         } else
            //             customAttributes.set(attr, {});
            //     })
            // }
            //
            // let columns = Object.keys(model.metadata);
            // if (customAttributes.size)
            //     columns = columns.filter((columnName: string) => customAttributes.has(columnName));
            //
            // const fields = columns.map((columnName: string) => {
            //
            //     if (customAttributes.has(columnName) && customAttributes.get(columnName).aggregate == 'count')
            //         return `COUNT("${columnName}") as "count${columnName}"`;
            //
            //     return `"${columnName}"`;
            // }).join(', ');
            //
            // let where: string = '';
            //
            // if (inputArtifact.object.where)
            //     where = 'WHERE ' + inputArtifact.object.where
            return (0, rxjs_1.from)(client.execute("".concat(inputArtifact.object.query), [], { prepare: true, consistency: cassandra_driver_1.types.consistencies.localQuorum }));
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result.rows;
            return outputArtifact;
        }));
    };
    DatabaseCassandraHook.prototype.createOrUpdateRow = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.modelId)
                throw new Error('Invalid modelId');
            if (DatabaseCassandraHook_1.connectionByModel.has(inputArtifact.object.modelId))
                return (0, rxjs_1.of)(DatabaseCassandraHook_1.connections.get(DatabaseCassandraHook_1.connectionByModel.get(inputArtifact.object.modelId)));
            return _this.service('ModelDbXrefService')
                .pipe((0, operators_1.concatMap)(function (service) {
                return service.findModelDbXrefByModelId(inputArtifact.object.modelId)
                    .pipe((0, operators_1.concatMap)(function (modelDbXref) {
                    var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
                    connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                    connectArtifact.object = { dbId: modelDbXref.dbId };
                    return _this.authenticate(connectArtifact);
                }))
                    .pipe((0, operators_1.concatMap)(function () {
                    return (0, rxjs_1.of)(DatabaseCassandraHook_1.connections.get(DatabaseCassandraHook_1.connectionByModel.get(inputArtifact.object.modelId)));
                }));
            }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            var model = client._modelsMap.get(inputArtifact.object.modelId);
            var prepareModel$ = (0, rxjs_1.of)(model);
            if (!model.metadata) {
                var syncTableArtifact = new nick_process_commons_1.NickProcessArtfact();
                syncTableArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                syncTableArtifact.object = { modelId: inputArtifact.object.modelId };
                prepareModel$ = _this.createTable(syncTableArtifact);
            }
            var primaryKeyColumn;
            var isInsert;
            var row = inputArtifact.object.data ? inputArtifact.object.data : {};
            var fieldsToUseInWhere = [];
            var fieldsToUse = [];
            var params = {};
            return prepareModel$
                .pipe((0, operators_1.concatMap)(function () {
                var _a, _b;
                model = client._modelsMap.get(inputArtifact.object.modelId);
                Object.keys(model.metadata).forEach(function (columnName) {
                    var field = model.metadata[columnName];
                    if (field.primaryKey) {
                        primaryKeyColumn = field;
                        if (!row.hasOwnProperty(columnName) || !row[columnName]) {
                            isInsert = true;
                            row[columnName] = (0, uuid_1.v4)();
                            fieldsToUse.push({ field: field, columnName: columnName });
                        }
                        else {
                            fieldsToUseInWhere.push({ field: field, columnName: columnName });
                        }
                        params[columnName] = row[columnName];
                    }
                    else if (row.hasOwnProperty(columnName)) {
                        fieldsToUse.push({ field: field, columnName: columnName });
                        switch (field.type) {
                            case nick_data_commons_1.FieldTypeKind.DATE:
                                params[columnName] = new Date(row[columnName]);
                                break;
                            case nick_data_commons_1.FieldTypeKind.STRING:
                            case nick_data_commons_1.FieldTypeKind.GUID:
                            case nick_data_commons_1.FieldTypeKind.BOOLEAN:
                            case nick_data_commons_1.FieldTypeKind.LONG:
                            case nick_data_commons_1.FieldTypeKind.ANY:
                            case nick_data_commons_1.FieldTypeKind.MODEL:
                            case nick_data_commons_1.FieldTypeKind.VIRTUAL:
                            case nick_data_commons_1.FieldTypeKind.ENUM:
                            case nick_data_commons_1.FieldTypeKind.HTML:
                            case nick_data_commons_1.FieldTypeKind.MONEY:
                            case nick_data_commons_1.FieldTypeKind.DECIMAL:
                            case nick_data_commons_1.FieldTypeKind.TELEPHONE:
                            case nick_data_commons_1.FieldTypeKind.TEXT:
                            case nick_data_commons_1.FieldTypeKind.POINT:
                            case nick_data_commons_1.FieldTypeKind.FILE:
                            case nick_data_commons_1.FieldTypeKind.MONGOID:
                            case nick_data_commons_1.FieldTypeKind.BLOB:
                            case nick_data_commons_1.FieldTypeKind.BIGINT:
                            case nick_data_commons_1.FieldTypeKind.SEARCH:
                                params[columnName] = row[columnName];
                                break;
                        }
                    }
                });
                var fields = fieldsToUse.map(function (item, index) {
                    if (isInsert)
                        return "\"".concat(item.columnName, "\"");
                    else
                        return "\"".concat(item.columnName, "\" = :").concat(item.columnName);
                }).join(', ');
                var fieldsWhere = fieldsToUseInWhere.map(function (item, index) {
                    return "\"".concat(item.columnName, "\" = :").concat(item.columnName);
                }).join(', ');
                /**
                 * INSERT INTO flow_telemetry.flow_execution (id, endat, name, startat)
                 * VALUES (1dc8bb2e-c4f3-4041-8d82-2e5b8e15c833, '2022-07-29 22:42:31.000', 'teste', '2022-07-29 22:42:38.000');
                 */
                /**
                 * UPDATE flow_telemetry.flow_execution
                 * SET endat   = '2022-07-29 22:42:31.000',
                 *     name    = 'teste',
                 *     startat = '2022-07-29 22:42:38.000'
                 * WHERE id = 1dc8bb2e-c4f3-4041-8d82-2e5b8e15c833;
                 */
                var ttl = '';
                if ((_a = model.settings) === null || _a === void 0 ? void 0 : _a.ttl)
                    ttl = "USING TTL ".concat((_b = model.settings) === null || _b === void 0 ? void 0 : _b.ttl);
                var query;
                if (isInsert)
                    query = "INSERT INTO \"".concat(model.tableName, "\" (").concat(fields, ")\n                                     VALUES (").concat(fieldsToUse.map(function (item) { return ":".concat(item.columnName); }).join(', '), ") ").concat(ttl, ";");
                else
                    query = "UPDATE \"".concat(model.tableName, "\"\n                                     SET ").concat(fields, "\n                                     WHERE ").concat(fieldsWhere, " ").concat(ttl);
                return (0, rxjs_1.from)(client.execute("".concat(query), params, { prepare: true, consistency: cassandra_driver_1.types.consistencies.localQuorum }));
            }));
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result.rows;
            return outputArtifact;
        }));
    };
    var DatabaseCassandraHook_1;
    DatabaseCassandraHook.connections = new Map();
    DatabaseCassandraHook.connectionByModel = new Map();
    __decorate([
        (0, nick_process_commons_1.Hook)('8f4cf88c-1b40-46f8-ac6b-bacaed14f81f')
    ], DatabaseCassandraHook.prototype, "authenticate", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('8895c2c0-ec7e-4996-b237-3a48f79c22da')
    ], DatabaseCassandraHook.prototype, "query", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('0fb2922f-b367-47d8-b1f2-ee8524e173e9')
    ], DatabaseCassandraHook.prototype, "sync", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('4dcbd711-5492-4c66-ad7e-2eafb73d538c')
    ], DatabaseCassandraHook.prototype, "createTable", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('1750c5ba-1415-42bd-be06-2620429fe169')
    ], DatabaseCassandraHook.prototype, "findRows", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('8e4f07af-e721-4d6a-b71f-66fa8babd332')
    ], DatabaseCassandraHook.prototype, "createOrUpdateRow", null);
    DatabaseCassandraHook = DatabaseCassandraHook_1 = __decorate([
        (0, nick_process_commons_1.HookClass)('database.cassandra', '1611fa9f-ceaa-4316-99c5-3aebee1aba1b')
    ], DatabaseCassandraHook);
    return DatabaseCassandraHook;
}(nick_process_commons_1.BaseHook));
exports.DatabaseCassandraHook = DatabaseCassandraHook;
//# sourceMappingURL=database.cassandra.hook.js.map