"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DatabaseMongoHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var mongodb_1 = require("mongodb");
var DatabaseMongoHook = /** @class */ (function (_super) {
    __extends(DatabaseMongoHook, _super);
    function DatabaseMongoHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DatabaseMongoHook_1 = DatabaseMongoHook;
    DatabaseMongoHook.prototype.authenticate = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.dbId)
                throw new Error('Invalid Database ID.');
            if (DatabaseMongoHook_1.connections.has(inputArtifact.object.dbId))
                return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(inputArtifact.object.dbId));
            return _this.service('DbService')
                .pipe((0, operators_1.concatMap)(function (service) {
                return service.findOne(inputArtifact.object.dbId)
                    .pipe((0, operators_1.map)(function (dbEntity) {
                    dbEntity.accessKey$ = service.getAccessKey(dbEntity);
                    return dbEntity;
                }));
            }))
                .pipe((0, operators_1.concatMap)(function (dbEntity) {
                return dbEntity.accessKey$
                    .pipe((0, operators_1.concatMap)(function (access) {
                    var _client = new mongodb_1.MongoClient(access.url, { monitorCommands: false });
                    return (0, rxjs_1.from)(_client.connect())
                        .pipe((0, operators_1.concatMap)(function (_client) {
                        var client = _client.db(dbEntity.dbName);
                        return _this.service('ModelDbXrefService')
                            .pipe((0, operators_1.concatMap)(function (service) {
                            return service.findModelsByDatabaseId(dbEntity.id);
                        }))
                            .pipe((0, operators_1.map)(function (models) {
                            client._models = models;
                            client._modelsMap = new Map();
                            client._dbEntity = dbEntity;
                            models.forEach(function (model) {
                                DatabaseMongoHook_1.connectionByModel.set(model.modelId, dbEntity.id);
                                client._modelsMap.set(model.modelId, model.model);
                            });
                            // todo: store connection with keyspace in hash key name
                            DatabaseMongoHook_1.connections.set(dbEntity.id, client);
                            return client;
                        }));
                    }));
                }));
            }));
        }))
            .pipe((0, operators_1.map)(function () {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = { success: true };
            return outputArtifact;
        }));
    };
    DatabaseMongoHook.prototype.query = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.dbId)
                throw new Error('Invalid modelId');
            if (DatabaseMongoHook_1.connections.has(inputArtifact.object.dbId))
                return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(inputArtifact.object.dbId));
            var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
            connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            connectArtifact.object = { dbId: inputArtifact.object.dbId };
            return _this.authenticate(connectArtifact)
                .pipe((0, operators_1.map)(function () { return DatabaseMongoHook_1.connections.get(inputArtifact.object.dbId); }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            return (0, rxjs_1.from)(client.execute(inputArtifact.object.query, inputArtifact.object.params));
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result;
            return outputArtifact;
        }));
    };
    DatabaseMongoHook.prototype.sync = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.dbId)
                throw new Error('Invalid dbId');
            if (DatabaseMongoHook_1.connections.has(inputArtifact.object.dbId))
                return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(inputArtifact.object.dbId));
            var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
            connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            connectArtifact.object = { dbId: inputArtifact.object.dbId };
            return _this.authenticate(connectArtifact)
                .pipe((0, operators_1.map)(function () { return DatabaseMongoHook_1.connections.get(inputArtifact.object.dbId); }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            return (0, rxjs_1.from)(Array.from(client._modelsMap.values()))
                .pipe((0, operators_1.concatMap)(function (model) {
                var createArtifact = new nick_process_commons_1.NickProcessArtfact();
                createArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                createArtifact.object = { modelId: model.id };
                return _this.createTable(createArtifact);
            }), (0, operators_1.toArray)());
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result;
            return outputArtifact;
        }));
    };
    DatabaseMongoHook.prototype.createTable = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.modelId)
                throw new Error('Invalid modelId');
            var connect$ = function (dbId) { return (0, rxjs_1.of)(inputArtifact)
                .pipe((0, operators_1.concatMap)(function () {
                if (DatabaseMongoHook_1.connectionByModel.has(inputArtifact.object.modelId))
                    return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
                var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
                connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                connectArtifact.object = { dbId: dbId };
                return _this.authenticate(connectArtifact);
            })); };
            return _this.service('ModelDbXrefService')
                .pipe((0, operators_1.concatMap)(function (service) {
                return service.findModelDbXrefByModelId(inputArtifact.object.modelId)
                    .pipe((0, operators_1.concatMap)(function (modelDbXref) {
                    // load metadata of model
                    return _this.service('ModelService')
                        .pipe((0, operators_1.concatMap)(function (modelService) {
                        return modelService.buildTableMetadata(modelDbXref.model, 'mongo')
                            .pipe((0, operators_1.concatMap)(function (metadata) {
                            return connect$(modelDbXref.dbId)
                                .pipe((0, operators_1.map)(function () {
                                var client = DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId));
                                client._modelsMap.get(inputArtifact.object.modelId).metadata = metadata;
                                return client;
                            }));
                        }));
                    }));
                }));
            }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            var model = client._modelsMap.get(inputArtifact.object.modelId);
            var metadata = model.metadata;
            var _client = client;
            return (0, rxjs_1.from)(_client.listCollections({ name: model.tableName }).toArray())
                .pipe((0, operators_1.concatMap)(function (collections) {
                if (collections.length)
                    return (0, rxjs_1.of)(null);
                return (0, rxjs_1.from)(_client.createCollection(model.tableName));
            }))
                .pipe((0, operators_1.concatMap)(function () {
                // check indexes
                var indexColumns = new Map(Array.from(Object.keys(metadata)).filter(function (key) { var _a; return (_a = metadata[key].options) === null || _a === void 0 ? void 0 : _a.index; }).map(function (key) { return [key, metadata[key]]; }));
                var _collection = _client.collection(model.tableName);
                return (0, rxjs_1.from)(_collection.listIndexes().toArray())
                    .pipe((0, operators_1.concatMap)(function (indexes) {
                    var keys = new Map(indexes.map(function (idx) { return [Object.keys(idx.key)[0], idx]; }));
                    return (0, rxjs_1.from)(Array.from(indexColumns.keys()))
                        .pipe((0, operators_1.filter)(function (column) { return !keys.has(column); }))
                        .pipe((0, operators_1.concatMap)(function (column) {
                        var _a;
                        var _col = indexColumns.get(column);
                        return (0, rxjs_1.from)(_collection.createIndex((_a = {}, _a[column] = 1, _a), _col.options.index));
                    }), (0, operators_1.toArray)());
                }));
            }));
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result;
            return outputArtifact;
        }));
    };
    DatabaseMongoHook.prototype.findOne = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.modelId)
                throw new Error('Invalid modelId');
            if (DatabaseMongoHook_1.connectionByModel.has(inputArtifact.object.modelId))
                return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
            return _this.service('ModelDbXrefService')
                .pipe((0, operators_1.concatMap)(function (service) {
                return service.findModelDbXrefByModelId(inputArtifact.object.modelId)
                    .pipe((0, operators_1.concatMap)(function (modelDbXref) {
                    var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
                    connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                    connectArtifact.object = { dbId: modelDbXref.dbId };
                    return _this.authenticate(connectArtifact);
                }))
                    .pipe((0, operators_1.concatMap)(function () {
                    return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
                }));
            }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            var model = client._modelsMap.get(inputArtifact.object.modelId);
            var _collection = client.collection(model.tableName);
            return (0, rxjs_1.from)(_collection.findOne(inputArtifact.object.filter));
            //     .pipe(map(() => {
            //
            //     }))
            // return new Observable((observer: Observer<any>) => {
            //     _collection.findOne(inputArtifact.object.filter, (err: any, result: any) => {
            //         if (err)
            //             observer.error(err);
            //         else if (!result)
            //             observer.next(null);
            //         else
            //             observer.next(result);
            //
            //         observer.complete();
            //     });
            // });
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result;
            return outputArtifact;
        }));
    };
    DatabaseMongoHook.prototype.find = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.modelId)
                throw new Error('Invalid modelId');
            if (DatabaseMongoHook_1.connectionByModel.has(inputArtifact.object.modelId))
                return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
            return _this.service('ModelDbXrefService')
                .pipe((0, operators_1.concatMap)(function (service) {
                return service.findModelDbXrefByModelId(inputArtifact.object.modelId)
                    .pipe((0, operators_1.concatMap)(function (modelDbXref) {
                    var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
                    connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                    connectArtifact.object = { dbId: modelDbXref.dbId };
                    return _this.authenticate(connectArtifact);
                }))
                    .pipe((0, operators_1.concatMap)(function () {
                    return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
                }));
            }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            var model = client._modelsMap.get(inputArtifact.object.modelId);
            var _collection = client.collection(model.tableName);
            return (0, rxjs_1.from)(_collection.find(inputArtifact.object.filter).toArray());
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result;
            return outputArtifact;
        }));
    };
    DatabaseMongoHook.prototype.findOneAndUpdateOLD = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.modelId)
                throw new Error('Invalid modelId');
            if (DatabaseMongoHook_1.connectionByModel.has(inputArtifact.object.modelId))
                return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
            return _this.service('ModelDbXrefService')
                .pipe((0, operators_1.concatMap)(function (service) {
                return service.findModelDbXrefByModelId(inputArtifact.object.modelId)
                    .pipe((0, operators_1.concatMap)(function (modelDbXref) {
                    var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
                    connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                    connectArtifact.object = { dbId: modelDbXref.dbId };
                    return _this.authenticate(connectArtifact);
                }))
                    .pipe((0, operators_1.concatMap)(function () {
                    return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
                }));
            }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            var model = client._modelsMap.get(inputArtifact.object.modelId);
            var _collection = client.collection(model.tableName);
            return (0, rxjs_1.from)(_collection.findOneAndUpdate(inputArtifact.object.filter, { $set: inputArtifact.object.data }, inputArtifact.object.options));
            // return new Observable((observer: Observer<any>) => {
            //     _collection.findOneAndUpdate(inputArtifact.object.filter, {$set: inputArtifact.object.data}, inputArtifact.object.options, (err: any, result: any) => {
            //         if (err)
            //             observer.error(err);
            //         else
            //             observer.next(result);
            //         observer.complete();
            //     });
            // });
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result.value;
            return outputArtifact;
        }));
    };
    DatabaseMongoHook.prototype.findOneAndUpdate = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.modelId)
                throw new Error('Invalid modelId');
            if (DatabaseMongoHook_1.connectionByModel.has(inputArtifact.object.modelId))
                return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
            return _this.service('ModelDbXrefService')
                .pipe((0, operators_1.concatMap)(function (service) {
                return service.findModelDbXrefByModelId(inputArtifact.object.modelId)
                    .pipe((0, operators_1.concatMap)(function (modelDbXref) {
                    var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
                    connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                    connectArtifact.object = { dbId: modelDbXref.dbId };
                    return _this.authenticate(connectArtifact);
                }))
                    .pipe((0, operators_1.concatMap)(function () {
                    return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
                }));
            }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            var model = client._modelsMap.get(inputArtifact.object.modelId);
            var _collection = client.collection(model.tableName);
            return (0, rxjs_1.from)(_collection.findOneAndUpdate(inputArtifact.object.filter, { $set: inputArtifact.object.data }, inputArtifact.object.options));
            // return new Observable((observer: Observer<any>) => {
            //     _collection.findOneAndUpdate(inputArtifact.object.filter, {$set: inputArtifact.object.data}, inputArtifact.object.options, (err: any, result: any) => {
            //         if (err)
            //             observer.error(err);
            //         else
            //             observer.next(result);
            //         observer.complete();
            //     });
            // });
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result.value;
            return outputArtifact;
        }));
    };
    DatabaseMongoHook.prototype.insertMany = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.modelId)
                throw new Error('Invalid modelId');
            if (DatabaseMongoHook_1.connectionByModel.has(inputArtifact.object.modelId))
                return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
            return _this.service('ModelDbXrefService')
                .pipe((0, operators_1.concatMap)(function (service) {
                return service.findModelDbXrefByModelId(inputArtifact.object.modelId)
                    .pipe((0, operators_1.concatMap)(function (modelDbXref) {
                    var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
                    connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                    connectArtifact.object = { dbId: modelDbXref.dbId };
                    return _this.authenticate(connectArtifact);
                }))
                    .pipe((0, operators_1.concatMap)(function () {
                    return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
                }));
            }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            var model = client._modelsMap.get(inputArtifact.object.modelId);
            var _collection = client.collection(model.tableName);
            return (0, rxjs_1.from)(_collection.insertMany(inputArtifact.object.data, inputArtifact.object.options));
            // return new Observable((observer: Observer<any>) => {
            //     _collection.insertMany(inputArtifact.object.data, inputArtifact.object.options, (err: any, result: any) => {
            //         if (err)
            //             observer.error(err);
            //         else
            //             observer.next(result);
            //         observer.complete();
            //     });
            // });
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result.value;
            return outputArtifact;
        }));
    };
    DatabaseMongoHook.prototype.findAndModify = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.modelId)
                throw new Error('Invalid modelId');
            if (DatabaseMongoHook_1.connectionByModel.has(inputArtifact.object.modelId))
                return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
            return _this.service('ModelDbXrefService')
                .pipe((0, operators_1.concatMap)(function (service) {
                return service.findModelDbXrefByModelId(inputArtifact.object.modelId)
                    .pipe((0, operators_1.concatMap)(function (modelDbXref) {
                    var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
                    connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                    connectArtifact.object = { dbId: modelDbXref.dbId };
                    return _this.authenticate(connectArtifact);
                }))
                    .pipe((0, operators_1.concatMap)(function () {
                    return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
                }));
            }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            var model = client._modelsMap.get(inputArtifact.object.modelId);
            var _collection = client.collection(model.tableName);
            return (0, rxjs_1.from)(_collection.findOneAndUpdate(inputArtifact.object.filter, inputArtifact.object.update, inputArtifact.object.options));
            // return new Observable((observer: Observer<any>) => {
            //     _collection.findAndModify(inputArtifact.object.data, inputArtifact.object.options, (err: any, result: any) => {
            //         if (err)
            //             observer.error(err);
            //         else
            //             observer.next(result);
            //         observer.complete();
            //     });
            // });
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result.value;
            return outputArtifact;
        }));
    };
    DatabaseMongoHook.prototype.deleteOne = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.modelId)
                throw new Error('Invalid modelId');
            if (DatabaseMongoHook_1.connectionByModel.has(inputArtifact.object.modelId))
                return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
            return _this.service('ModelDbXrefService')
                .pipe((0, operators_1.concatMap)(function (service) {
                return service.findModelDbXrefByModelId(inputArtifact.object.modelId)
                    .pipe((0, operators_1.concatMap)(function (modelDbXref) {
                    var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
                    connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                    connectArtifact.object = { dbId: modelDbXref.dbId };
                    return _this.authenticate(connectArtifact);
                }))
                    .pipe((0, operators_1.concatMap)(function () {
                    return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
                }));
            }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            var model = client._modelsMap.get(inputArtifact.object.modelId);
            var _collection = client.collection(model.tableName);
            return (0, rxjs_1.from)(_collection.deleteOne(inputArtifact.object.data, inputArtifact.object.options));
            // return new Observable((observer: Observer<any>) => {
            //     _collection.deleteOne(inputArtifact.object.data, inputArtifact.object.options, (err: any, result: any) => {
            //         if (err)
            //             observer.error(err);
            //         else
            //             observer.next(result);
            //         observer.complete();
            //     });
            // });
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result.value;
            return outputArtifact;
        }));
    };
    DatabaseMongoHook.prototype.deleteMany = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.modelId)
                throw new Error('Invalid modelId');
            if (DatabaseMongoHook_1.connectionByModel.has(inputArtifact.object.modelId))
                return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
            return _this.service('ModelDbXrefService')
                .pipe((0, operators_1.concatMap)(function (service) {
                return service.findModelDbXrefByModelId(inputArtifact.object.modelId)
                    .pipe((0, operators_1.concatMap)(function (modelDbXref) {
                    var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
                    connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                    connectArtifact.object = { dbId: modelDbXref.dbId };
                    return _this.authenticate(connectArtifact);
                }))
                    .pipe((0, operators_1.concatMap)(function () {
                    return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
                }));
            }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            var model = client._modelsMap.get(inputArtifact.object.modelId);
            var _collection = client.collection(model.tableName);
            return (0, rxjs_1.from)(_collection.deleteMany(inputArtifact.object.filter, inputArtifact.object.options));
            // return new Observable((observer: Observer<any>) => {
            //     _collection.deleteOne(inputArtifact.object.data, inputArtifact.object.options, (err: any, result: any) => {
            //         if (err)
            //             observer.error(err);
            //         else
            //             observer.next(result);
            //         observer.complete();
            //     });
            // });
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result.value;
            return outputArtifact;
        }));
    };
    DatabaseMongoHook.prototype.findOneAndDelete = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.modelId)
                throw new Error('Invalid modelId');
            if (DatabaseMongoHook_1.connectionByModel.has(inputArtifact.object.modelId))
                return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
            return _this.service('ModelDbXrefService')
                .pipe((0, operators_1.concatMap)(function (service) {
                return service.findModelDbXrefByModelId(inputArtifact.object.modelId)
                    .pipe((0, operators_1.concatMap)(function (modelDbXref) {
                    var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
                    connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                    connectArtifact.object = { dbId: modelDbXref.dbId };
                    return _this.authenticate(connectArtifact);
                }))
                    .pipe((0, operators_1.concatMap)(function () {
                    return (0, rxjs_1.of)(DatabaseMongoHook_1.connections.get(DatabaseMongoHook_1.connectionByModel.get(inputArtifact.object.modelId)));
                }));
            }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            var model = client._modelsMap.get(inputArtifact.object.modelId);
            var _collection = client.collection(model.tableName);
            return (0, rxjs_1.from)(_collection.findOneAndDelete(inputArtifact.object.data, inputArtifact.object.options));
            // return new Observable((observer: Observer<any>) => {
            //     _collection.findOneAndDelete(inputArtifact.object.data, inputArtifact.object.options, (err: any, result: any) => {
            //         if (err)
            //             observer.error(err);
            //         else
            //             observer.next(result);
            //         observer.complete();
            //     });
            // });
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result.value;
            return outputArtifact;
        }));
    };
    var DatabaseMongoHook_1;
    DatabaseMongoHook.connections = new Map();
    DatabaseMongoHook.connectionByModel = new Map();
    __decorate([
        (0, nick_process_commons_1.Hook)('bb2d56bd-ce0a-42bc-8966-8dfd40971d12')
    ], DatabaseMongoHook.prototype, "authenticate", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('e9405ee2-e83b-4ad4-83a9-37052b1517bb')
    ], DatabaseMongoHook.prototype, "query", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('09d4fef2-f20d-453e-ad19-b4da33b1de68')
    ], DatabaseMongoHook.prototype, "sync", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('95cdcc6b-20d0-4ac1-a965-6c93ae5a5ed1')
    ], DatabaseMongoHook.prototype, "createTable", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('85aa4347-d54c-491e-9a1c-5c0d2abddd95')
    ], DatabaseMongoHook.prototype, "findOne", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('d2c6246a-bc3d-4971-b515-5441e8a0a6c3')
    ], DatabaseMongoHook.prototype, "find", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('858ae5f98-cb8a-44ca-90ee-cea7e4604691')
    ], DatabaseMongoHook.prototype, "findOneAndUpdateOLD", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('c5f32174-63b3-4329-922d-bd86672aea9e')
    ], DatabaseMongoHook.prototype, "findOneAndUpdate", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('038927da-72d4-4b1c-a98d-1f03710d0847')
    ], DatabaseMongoHook.prototype, "insertMany", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('83d3dad4-c1a5-4c0b-b363-078c72e09336')
    ], DatabaseMongoHook.prototype, "findAndModify", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('c65317fc-f888-46c1-809a-aa921a53fb2c')
    ], DatabaseMongoHook.prototype, "deleteOne", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('ce933db6-154c-4b90-bef2-e27d52a50fa5')
    ], DatabaseMongoHook.prototype, "deleteMany", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('80370238-9df4-4482-a073-0827811e3d58')
    ], DatabaseMongoHook.prototype, "findOneAndDelete", null);
    DatabaseMongoHook = DatabaseMongoHook_1 = __decorate([
        (0, nick_process_commons_1.HookClass)('database.mongo', '684176ab-baab-4ab1-bf18-060ae55c1623')
    ], DatabaseMongoHook);
    return DatabaseMongoHook;
}(nick_process_commons_1.BaseHook));
exports.DatabaseMongoHook = DatabaseMongoHook;
//# sourceMappingURL=database.mongo.hook.js.map