"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DatabaseOracleHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var oracledb_1 = __importDefault(require("oracledb"));
var DatabaseOracleHook = /** @class */ (function (_super) {
    __extends(DatabaseOracleHook, _super);
    function DatabaseOracleHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DatabaseOracleHook_1 = DatabaseOracleHook;
    DatabaseOracleHook.prototype.authenticate = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.dbId)
                throw new Error('Invalid Database ID.');
            if (DatabaseOracleHook_1.connections.has(inputArtifact.object.dbId))
                return (0, rxjs_1.of)(DatabaseOracleHook_1.connections.get(inputArtifact.object.dbId));
            return _this.service('DbService')
                .pipe((0, operators_1.concatMap)(function (service) {
                return service.findOne(inputArtifact.object.dbId)
                    .pipe((0, operators_1.map)(function (dbEntity) {
                    dbEntity.accessKey$ = service.getAccessKey(dbEntity);
                    return dbEntity;
                }));
            }))
                .pipe((0, operators_1.concatMap)(function (dbEntity) {
                return dbEntity.accessKey$
                    .pipe((0, operators_1.concatMap)(function (access) {
                    oracledb_1.default.outFormat = oracledb_1.default.OUT_FORMAT_OBJECT;
                    return (0, rxjs_1.from)(oracledb_1.default.getConnection({
                        user: access.user,
                        password: access.password,
                        connectString: access.connectionString
                    }))
                        .pipe((0, operators_1.concatMap)(function (client) {
                        return _this.service('ModelDbXrefService')
                            .pipe((0, operators_1.concatMap)(function (service) {
                            return service.findModelsByDatabaseId(dbEntity.id);
                        }))
                            .pipe((0, operators_1.map)(function (models) {
                            client._models = models;
                            client._modelsMap = new Map();
                            client._dbEntity = dbEntity;
                            models.forEach(function (model) {
                                DatabaseOracleHook_1.connectionByModel.set(model.modelId, dbEntity.id);
                                client._modelsMap.set(model.modelId, model.model);
                            });
                            // todo: store connection with keyspace in hash key name
                            DatabaseOracleHook_1.connections.set(dbEntity.id, client);
                            return client;
                        }));
                    }));
                }));
            }));
        }))
            .pipe((0, operators_1.map)(function () {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = { success: true };
            return outputArtifact;
        }));
    };
    DatabaseOracleHook.prototype.query = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            if (!inputArtifact.object.dbId)
                throw new Error('Invalid modelId');
            if (DatabaseOracleHook_1.connections.has(inputArtifact.object.dbId))
                return (0, rxjs_1.of)(DatabaseOracleHook_1.connections.get(inputArtifact.object.dbId));
            var connectArtifact = new nick_process_commons_1.NickProcessArtfact();
            connectArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            connectArtifact.object = { dbId: inputArtifact.object.dbId };
            return _this.authenticate(connectArtifact)
                .pipe((0, operators_1.map)(function () { return DatabaseOracleHook_1.connections.get(inputArtifact.object.dbId); }));
        }))
            .pipe((0, operators_1.concatMap)(function (client) {
            return (0, rxjs_1.from)(client.execute(inputArtifact.object.query, inputArtifact.object.params, inputArtifact.object.options));
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result;
            return outputArtifact;
        }));
    };
    var DatabaseOracleHook_1;
    DatabaseOracleHook.connections = new Map();
    DatabaseOracleHook.connectionByModel = new Map();
    __decorate([
        (0, nick_process_commons_1.Hook)('bb2d56bd-ce0a-42bc-8966-8dfd40971d12')
    ], DatabaseOracleHook.prototype, "authenticate", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('dddc2c43-0d06-4e9e-b520-e81709f90983')
    ], DatabaseOracleHook.prototype, "query", null);
    DatabaseOracleHook = DatabaseOracleHook_1 = __decorate([
        (0, nick_process_commons_1.HookClass)('database.oracle', '23bac333-af71-4444-8473-0530cabd9629')
    ], DatabaseOracleHook);
    return DatabaseOracleHook;
}(nick_process_commons_1.BaseHook));
exports.DatabaseOracleHook = DatabaseOracleHook;
//# sourceMappingURL=database.oracle.hook.js.map