"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CronHook = void 0;
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var moment_1 = __importDefault(require("moment"));
var CronHook = /** @class */ (function (_super) {
    __extends(CronHook, _super);
    function CronHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CronHook.prototype.checkConflict = function (inputArtifact) {
        var _this = this;
        // verificar se já existe registro com os dados informados
        return this.crud(inputArtifact.object.model)
            .pipe((0, operators_1.concatMap)(function (service) {
            var resultArtifact = new nick_process_commons_1.NickProcessArtfact();
            // selecionar todos os registros do key e período informado
            return _this.crud(inputArtifact.object.model)
                .pipe((0, operators_1.concatMap)(function (service) {
                var uniqueFields = inputArtifact.object.data.uniqueFields;
                var input = inputArtifact.object.data.input;
                var whereClause = { $and: [] };
                // driverId: event.driverId,
                for (var i = 0; i < uniqueFields.length; i++) {
                    var uniqueFieldClause = {};
                    uniqueFieldClause[uniqueFields[i]] = input[uniqueFields[i]];
                    whereClause.$and.push(uniqueFieldClause);
                }
                // caso input possua valor em todos os periodFields
                // $or: [{
                //     startDate: {
                //         $between: [event.startDate, event.recurrenceEndDate],
                //     }
                // },
                // {
                //     recurrenceEndDate: {
                //         $between: [event.startDate, event.recurrenceEndDate],
                //     }
                // }],
                // caso input nao possua valor em todos os periodFields utilizamos startDateField e endDateField
                // pois significa que não é um evento recorrente
                // $or: [{
                //     startDate: {
                //         $between: [event.startDate, event.endDate],
                //     }
                // },
                // {
                //     endDate: {
                //         $between: [event.startDate, event.endDate],
                //     }
                // }],
                var periodFields = inputArtifact.object.data.periodFields;
                var orClause = { $or: [] };
                // verifica se é evento periodico, se não for altera periodFields para startDateField e endDateField
                for (var i = 0; i < periodFields.length; i++) {
                    if (!input[periodFields[i]]) {
                        periodFields = [inputArtifact.object.data.startDateField, inputArtifact.object.data.endDateField];
                        break;
                    }
                }
                for (var i = 0; i < periodFields.length; i++) {
                    var orItem = {};
                    var beetweenItem = [];
                    for (var j = 0; j < periodFields.length; j++) {
                        beetweenItem.push(input[periodFields[j]]);
                    }
                    orItem[periodFields[i]] = {
                        $between: beetweenItem
                    };
                    orClause.$or.push(orItem);
                }
                if (orClause.$or.length > 0) {
                    whereClause.$and.push(orClause);
                }
                // $or: [
                //     { ownerEventId: { $is: null } },
                //     { independent: true }
                // ],
                var parentField = inputArtifact.object.data.parentField;
                var ignoreParentField = inputArtifact.object.data.ignoreParentField;
                if (parentField) {
                    var parentClause = {};
                    parentClause[parentField] = {
                        $is: null
                    };
                    if (ignoreParentField) {
                        var ignoreParentClause = {};
                        ignoreParentClause[ignoreParentField] = {
                            $eq: true
                        };
                        var _parentClause = parentClause;
                        parentClause = { $or: [] };
                        parentClause.$or.push(_parentClause);
                        parentClause.$or.push(ignoreParentClause);
                    }
                    whereClause.$and.push(parentClause);
                }
                //     cron: {
                //         $or: dayOfWeekWhereClause
                //     }
                var dayOfWeekField = inputArtifact.object.data.dayOfWeekField;
                var cronField = inputArtifact.object.data.cronField;
                if (dayOfWeekField) {
                    if (input[dayOfWeekField]) {
                        var dayOfWeekList = input[dayOfWeekField].split(',');
                        var dayOfWeekWhereClause = [];
                        for (var i = 0; i < dayOfWeekList.length; i++) {
                            dayOfWeekWhereClause.push({ $like: '%' + dayOfWeekList[i] + '%' });
                        }
                        var cronClause = {};
                        cronClause[cronField] = {
                            $or: dayOfWeekWhereClause
                        };
                        whereClause.$and.push(cronClause);
                    }
                }
                // não incluir o proprio registro na consulta (update)
                if (input.id) {
                    whereClause.$and.push({
                        id: {
                            $ne: input.id
                        }
                    });
                }
                // com o driver informado
                // no periodo de data informado
                // somente eventos pais ou filhos avulsos
                // somente cron que possuir pelo menos um dayOfWeek informado
                return service.findAll(whereClause);
            }))
                // verificar se alguma registro está contemplado no periodo informado
                .pipe((0, operators_1.concatMap)(function (records) {
                if (records.length > 0) {
                    var input = inputArtifact.object.data.input;
                    var startDate = (0, moment_1.default)(input[inputArtifact.object.data.startDateField]);
                    var endDate = (0, moment_1.default)(input[inputArtifact.object.data.endDateField]);
                    for (var i = 0; i < records.length; i++) {
                        var record = records[i];
                        var recordMoment = (0, moment_1.default)(record.startDate);
                        if (recordMoment.isBetween(startDate, endDate, null, '[]')) {
                            var resultArtifact_1 = new nick_process_commons_1.NickProcessArtfact();
                            resultArtifact_1.kind = nick_data_commons_1.ArtfactKind.ERROR;
                            resultArtifact_1.object.data = record.dataValues;
                            return (0, rxjs_1.of)(resultArtifact_1);
                        }
                    }
                }
                return (0, rxjs_1.of)(resultArtifact);
            }));
        }));
    };
    CronHook.prototype.configureExpression = function (inputArtifact) {
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = {};
            var seconds = inputArtifact.object.seconds;
            var minutes = inputArtifact.object.minutes;
            var hours = inputArtifact.object.hours;
            var days = inputArtifact.object.days;
            var months = inputArtifact.object.months;
            var years = inputArtifact.object.years;
            var secondsExpression = '* ';
            var minutesExpression = '* ';
            var hoursExpression = '* ';
            var daysExpression = '? ';
            var monthsExpression = '* ';
            var dayOfWeekExpression = '* ';
            var yearsExpression = '*';
            if (seconds === null || seconds === void 0 ? void 0 : seconds.everySecondStartingAt) {
                secondsExpression = seconds.secondGap + '/' + seconds.secondLapse + ' ';
            }
            else if (seconds === null || seconds === void 0 ? void 0 : seconds.specificSecond) {
                if (seconds.specificSecondSelection instanceof Array)
                    seconds.specificSecondSelection = seconds.specificSecondSelection.toString();
                secondsExpression = seconds.specificSecondSelection + ' ';
            }
            else if (seconds === null || seconds === void 0 ? void 0 : seconds.everySecondBetween) {
                secondsExpression = seconds.firstSecondBetween + '-' + seconds.secondSecondBetween + ' ';
            }
            if (minutes === null || minutes === void 0 ? void 0 : minutes.everyMinuteStartingAt) {
                minutesExpression = minutes.minuteGap + '/' + minutes.minuteLapse + ' ';
            }
            else if (minutes === null || minutes === void 0 ? void 0 : minutes.specificMinute) {
                if (minutes.specificMinuteSelection instanceof Array)
                    minutes.specificMinuteSelection = minutes.specificMinuteSelection.toString();
                minutesExpression = minutes.specificMinuteSelection + ' ';
            }
            else if (minutes === null || minutes === void 0 ? void 0 : minutes.everyMinuteBetween) {
                minutesExpression = minutes.firstMinuteBetween + '-' + minutes.secondMinuteBetween + ' ';
            }
            if (hours === null || hours === void 0 ? void 0 : hours.everyHourStartingAt) {
                hoursExpression = hours.hourLapse + '/' + hours.hourGap + ' ';
            }
            else if (hours === null || hours === void 0 ? void 0 : hours.specificHour) {
                if (hours.specificHourSelection instanceof Array)
                    hours.specificHourSelection = hours.specificHourSelection.toString();
                hoursExpression = hours.specificHourSelection + ' ';
            }
            else if (hours === null || hours === void 0 ? void 0 : hours.everyHourBetween) {
                hoursExpression = hours.firstHourBetween + '-' + hours.secondHourBetween + ' ';
            }
            if (days === null || days === void 0 ? void 0 : days.everyDayStartingOnWeekDay) {
                dayOfWeekExpression = days.everyDayStartingOnWeekDay1 + '/' + days.everyDayStartingOnWeekDay2 + ' ';
            }
            else if (days === null || days === void 0 ? void 0 : days.everyDayStartingOnOrdinalDay) {
                daysExpression = days.everyDayStartingOnOrdinalDay1 + '/' + days.everyDayStartingOnOrdinalDay2 + ' ';
                dayOfWeekExpression = '? ';
            }
            else if (days === null || days === void 0 ? void 0 : days.specificDayOfWeek) {
                if (days.specificDaySelection instanceof Array)
                    days.specificDaySelection = days.specificDaySelection.toString();
                daysExpression = '? ';
                dayOfWeekExpression = days.specificDaySelection + ' ';
            }
            else if (days === null || days === void 0 ? void 0 : days.specificDayOfMonth) {
                if (days.specificDaysSelection instanceof Array)
                    days.specificDaysSelection = days.specificDaysSelection.toString();
                daysExpression = days.specificDaysSelection + ' ';
                dayOfWeekExpression = '? ';
            }
            else if (days === null || days === void 0 ? void 0 : days.lastDayOfMonth) {
                daysExpression = 'L ';
                dayOfWeekExpression = '? ';
            }
            else if (days === null || days === void 0 ? void 0 : days.lastWeekdayOfMonth) {
                daysExpression = 'LW ';
                dayOfWeekExpression = '? ';
            }
            else if (days === null || days === void 0 ? void 0 : days.lastOrdinalDayOfMonth) {
                daysExpression = '? ';
                dayOfWeekExpression = days.lastOrdinalDayOfMonth1 + 'L ';
            }
            else if (days === null || days === void 0 ? void 0 : days.lastDayBeforeEndOfMonth) {
                daysExpression = 'L-' + days.lastDayBeforeEndOfMonth1 + ' ';
                dayOfWeekExpression = '? ';
            }
            else if (days === null || days === void 0 ? void 0 : days.nearestWeekdayToOrdinalDay) {
                daysExpression = days.nearestWeekdayToOrdinalDay1 + 'W ';
                dayOfWeekExpression = '? ';
            }
            else if (days === null || days === void 0 ? void 0 : days.firstOrdinalDayOfMonth) {
                daysExpression = '? ';
                dayOfWeekExpression = days.firstOrdinalDayOfMonth2 + '#' + days.firstOrdinalDayOfMonth1 + ' ';
            }
            if (months === null || months === void 0 ? void 0 : months.everyMonthStartingAt) {
                monthsExpression = months.everyDaysStartingAtNumber + '/' + months.everyDaysNumber + ' ';
            }
            else if (months === null || months === void 0 ? void 0 : months.everyMonthStartingAtDay) {
                if (months.specificMonthSelection instanceof Array)
                    months.specificMonthSelection = months.specificMonthSelection.toString();
                monthsExpression = months.specificMonthSelection + ' ';
            }
            else if (months === null || months === void 0 ? void 0 : months.everyMonthBetween) {
                monthsExpression = months.everyDaysNumber2 + '-' + months.everyDaysStartingAtOrdinalDay + ' ';
            }
            if (years === null || years === void 0 ? void 0 : years.everyYearStartingAt) {
                yearsExpression = years.everyYearsStartingAtNumber + '/' + years.everyYearsNumber + ' ';
            }
            else if (years === null || years === void 0 ? void 0 : years.specificYear) {
                if (years.specificYearsSelection instanceof Array)
                    years.specificYearsSelection = years.specificYearsSelection.toString();
                yearsExpression = years.specificYearsSelection + ' ';
            }
            else if (years === null || years === void 0 ? void 0 : years.everyYearBetween) {
                yearsExpression = years.everyYearBetweenFirstNumber + '-' + years.everyYearBetweenSecondNumber;
            }
            outputArtifact.object = secondsExpression + minutesExpression + hoursExpression + daysExpression +
                monthsExpression + dayOfWeekExpression + yearsExpression;
            return (0, rxjs_1.of)(outputArtifact);
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('0cbb5273-bdf8-457b-8e8b-3aa011951b95')
    ], CronHook.prototype, "checkConflict", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('34afccc2-87bb-4666-8311-6979080d722d')
    ], CronHook.prototype, "configureExpression", null);
    CronHook = __decorate([
        (0, nick_process_commons_1.HookClass)('cron')
    ], CronHook);
    return CronHook;
}(nick_process_commons_1.BaseHook));
exports.CronHook = CronHook;
//# sourceMappingURL=cron.hook.js.map