"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DateHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var moment_1 = __importDefault(require("moment"));
var moment_timezone_1 = __importDefault(require("moment-timezone"));
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var cron_1 = require("cron");
var OperationKind;
(function (OperationKind) {
    OperationKind[OperationKind["PLUS"] = 0] = "PLUS";
    OperationKind[OperationKind["MINUS"] = 1] = "MINUS";
    OperationKind[OperationKind["DIFF"] = 2] = "DIFF";
    OperationKind[OperationKind["START"] = 3] = "START";
    OperationKind[OperationKind["END"] = 4] = "END";
})(OperationKind || (OperationKind = {}));
var OperationType;
(function (OperationType) {
    OperationType["YEAR"] = "y";
    OperationType["MONTH"] = "m";
    OperationType["DAY"] = "d";
    OperationType["HOURS"] = "h";
    OperationType["MINUTES"] = "M";
    OperationType["SECONDS"] = "s";
})(OperationType || (OperationType = {}));
var DateHook = /** @class */ (function (_super) {
    __extends(DateHook, _super);
    function DateHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /*
     * @deprecated
     */
    DateHook.prototype.set = function (inputArtifact) {
        var fields = Object.keys(inputArtifact.object.map);
        return (0, rxjs_1.from)(fields)
            .pipe((0, operators_1.map)(function (field) {
            var fn = inputArtifact.object.map[field];
            inputArtifact.object.data[field] = new Date();
            var values = fn.val.match(/(\d+)(\D+)/);
            if (values.length > 2) {
                var value = values[1];
                var quantify = values[2];
                switch (fn.op) {
                    case 'plus':
                        inputArtifact.object.data[field].setDate(new Date().getDate() + parseInt(value, 10));
                        break;
                }
            }
        }), (0, operators_1.toArray)())
            .pipe((0, operators_1.concatMap)(function () { return (0, rxjs_1.of)(inputArtifact); }));
    };
    DateHook.prototype.operations = function (inputArtifact) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = {};
        return (0, rxjs_1.from)(inputArtifact.object.operations)
            .pipe((0, operators_1.map)(function (operation) {
            if (operation.value == undefined)
                operation.value = 0;
            if (operation.reference) {
                if (operation.reference.startsWith && operation.reference.startsWith('...'))
                    operation.reference = (0, moment_1.default)(outputArtifact.object[operation.reference.replace('...', '')]);
                else
                    operation.reference = (0, moment_1.default)(operation.reference);
            }
            if (!operation.reference)
                operation.reference = (0, moment_1.default)(new Date());
            else if (!operation.reference.isValid()) {
                outputArtifact.object[operation.as] = null;
                return;
            }
            switch (operation.kind) {
                case OperationKind.PLUS: {
                    switch (operation.type) {
                        case OperationType.YEAR:
                            outputArtifact.object[operation.as] = (operation.reference).add(operation.value, 'years').toDate();
                            break;
                        case OperationType.MONTH:
                            outputArtifact.object[operation.as] = (operation.reference).add(operation.value, 'months').toDate();
                            break;
                        case OperationType.DAY:
                            outputArtifact.object[operation.as] = (operation.reference).add(operation.value, 'days').toDate();
                            break;
                        case OperationType.HOURS:
                            outputArtifact.object[operation.as] = (operation.reference).add(operation.value, 'hours').toDate();
                            break;
                        case OperationType.MINUTES:
                            outputArtifact.object[operation.as] = (operation.reference).add(operation.value, 'minutes').toDate();
                            break;
                        case OperationType.SECONDS:
                            outputArtifact.object[operation.as] = (operation.reference).add(operation.value, 'seconds').toDate();
                            break;
                    }
                    break;
                }
                case OperationKind.MINUS: {
                    switch (operation.type) {
                        case OperationType.YEAR:
                            outputArtifact.object[operation.as] = (operation.reference).subtract(operation.value, 'years').toDate();
                            break;
                        case OperationType.MONTH:
                            outputArtifact.object[operation.as] = (operation.reference).subtract(operation.value, 'months').toDate();
                            break;
                        case OperationType.DAY:
                            outputArtifact.object[operation.as] = (operation.reference).subtract(operation.value, 'days').toDate();
                            break;
                        case OperationType.HOURS:
                            outputArtifact.object[operation.as] = (operation.reference).subtract(operation.value, 'hours').toDate();
                            break;
                        case OperationType.MINUTES:
                            outputArtifact.object[operation.as] = (operation.reference).subtract(operation.value, 'minutes').toDate();
                            break;
                        case OperationType.SECONDS:
                            outputArtifact.object[operation.as] = (operation.reference).subtract(operation.value, 'seconds').toDate();
                            break;
                    }
                    break;
                }
                case OperationKind.DIFF: {
                    switch (operation.type) {
                        case OperationType.YEAR:
                            outputArtifact.object[operation.as] = (operation.reference).diff(operation.value, 'years');
                            break;
                        case OperationType.MONTH:
                            outputArtifact.object[operation.as] = (operation.reference).diff(operation.value, 'months');
                            break;
                        case OperationType.DAY:
                            outputArtifact.object[operation.as] = (operation.reference).diff(operation.value, 'days');
                            break;
                        case OperationType.HOURS:
                            outputArtifact.object[operation.as] = (operation.reference).diff(operation.value, 'hours');
                            break;
                        case OperationType.MINUTES:
                            outputArtifact.object[operation.as] = (operation.reference).diff(operation.value, 'minutes');
                            break;
                        case OperationType.SECONDS:
                            outputArtifact.object[operation.as] = (operation.reference).diff(operation.value, 'seconds');
                            break;
                    }
                    break;
                }
                case OperationKind.START: {
                    switch (operation.type) {
                        case OperationType.YEAR:
                            outputArtifact.object[operation.as] = (operation.reference).startOf('year').toDate();
                            break;
                        case OperationType.MONTH:
                            outputArtifact.object[operation.as] = (operation.reference).startOf('month').toDate();
                            break;
                        case OperationType.DAY:
                            outputArtifact.object[operation.as] = (operation.reference).startOf('day').toDate();
                            break;
                    }
                    break;
                }
                case OperationKind.END: {
                    switch (operation.type) {
                        case OperationType.YEAR:
                            outputArtifact.object[operation.as] = (operation.reference).endOf('year').toDate();
                            break;
                        case OperationType.MONTH:
                            outputArtifact.object[operation.as] = (operation.reference).endOf('month').toDate();
                            break;
                        case OperationType.DAY:
                            outputArtifact.object[operation.as] = (operation.reference).endOf('day').toDate();
                            break;
                    }
                    break;
                }
            }
        }), (0, operators_1.toArray)())
            .pipe((0, operators_1.concatMap)(function () {
            return (0, rxjs_1.of)(outputArtifact);
        }));
    };
    DateHook.prototype.get = function (inputArtifact) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        var date = (0, moment_1.default)(inputArtifact.object.data);
        outputArtifact.object = date.get(inputArtifact.object.config.unit);
        return (0, rxjs_1.of)(outputArtifact);
    };
    DateHook.prototype.age = function (inputArtifact) {
        var date = (0, moment_1.default)(inputArtifact.object.data);
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = (0, moment_1.default)().diff(date, 'years');
        return (0, rxjs_1.of)(outputArtifact);
    };
    DateHook.prototype.now = function (inputArtifact) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = new Date();
        return (0, rxjs_1.of)(outputArtifact);
    };
    DateHook.prototype.format = function (inputArtifact) {
        return (0, rxjs_1.from)(Object.keys(inputArtifact.object.data))
            .pipe((0, operators_1.map)(function (key) {
            var _a;
            var locale = ((_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.locale) ? inputArtifact.object.config.locale : 'pt-br';
            moment_1.default.locale(locale);
            var date = (0, moment_1.default)(!inputArtifact.object.data[key] ? new Date() : inputArtifact.object.data[key]);
            if (inputArtifact.object.config.timeZone)
                date = date.tz(inputArtifact.object.config.timeZone);
            inputArtifact.object.data[key] = date.format(inputArtifact.object.config.format).toString();
        }), (0, operators_1.toArray)())
            .pipe((0, operators_1.concatMap)(function () {
            return (0, rxjs_1.of)(inputArtifact);
        }));
    };
    DateHook.prototype.parse = function (inputArtifact) {
        return (0, rxjs_1.from)(Object.keys(inputArtifact.object.data))
            .pipe((0, operators_1.map)(function (key) {
            inputArtifact.object.data[key] = (0, moment_1.default)(inputArtifact.object.data[key], inputArtifact.object.config.format).toDate();
        }), (0, operators_1.toArray)())
            .pipe((0, operators_1.concatMap)(function () {
            return (0, rxjs_1.of)(inputArtifact);
        }));
    };
    DateHook.prototype.availableSeriesWorksheet = function (inputArtifact) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
        var seriesField = 'day';
        var seriesEndField = 'dayEnd';
        var timeZone = 'America/Sao_Paulo';
        var seriesDuration = '60';
        if ((_b = (_a = inputArtifact.object) === null || _a === void 0 ? void 0 : _a.config) === null || _b === void 0 ? void 0 : _b.timeZone)
            timeZone = (_d = (_c = inputArtifact.object) === null || _c === void 0 ? void 0 : _c.config) === null || _d === void 0 ? void 0 : _d.timeZone;
        if ((_f = (_e = inputArtifact.object) === null || _e === void 0 ? void 0 : _e.config) === null || _f === void 0 ? void 0 : _f.seriesDuration)
            seriesDuration = (_h = (_g = inputArtifact.object) === null || _g === void 0 ? void 0 : _g.config) === null || _h === void 0 ? void 0 : _h.seriesDuration;
        var selectedDateStart;
        var selectedDateEnd;
        var maxDate;
        var minDate;
        if (inputArtifact.object.config.range) {
            selectedDateStart = (0, moment_timezone_1.default)(inputArtifact.object.config.range[0]).format('YYYY-MM-DD HH:mm:ss');
            selectedDateEnd = (0, moment_timezone_1.default)(inputArtifact.object.config.range[1]).format('YYYY-MM-DD HH:mm:ss');
        }
        if (inputArtifact.object.config.minDate)
            minDate = (0, moment_timezone_1.default)(inputArtifact.object.config.minDate).format('YYYY-MM-DD HH:mm:ss');
        if (inputArtifact.object.config.maxDate)
            maxDate = (0, moment_timezone_1.default)(inputArtifact.object.config.maxDate).format('YYYY-MM-DD HH:mm:ss');
        var startField = (_k = (_j = inputArtifact.object) === null || _j === void 0 ? void 0 : _j.config) === null || _k === void 0 ? void 0 : _k.startField;
        var endField = (_m = (_l = inputArtifact.object) === null || _l === void 0 ? void 0 : _l.config) === null || _m === void 0 ? void 0 : _m.endField;
        return this.crud(inputArtifact.object.model)
            .pipe((0, operators_1.concatMap)(function (service) {
            var include = null;
            var exclude = null;
            var insideAttributes = [];
            var includeAttributes = new Map();
            if (inputArtifact.object.config && inputArtifact.object.config.include) {
                include = inputArtifact.object.config.include;
                var organize$_1 = function (include, associations, level) {
                    include.forEach(function (item) {
                        item.attributes = item.attributes ? item.attributes : [];
                        item.model = associations[item.as].target;
                        item.association = associations[item.as];
                        item.parent = { model: associations[item.as].source };
                        if (item.attributes)
                            includeAttributes.set(item.as, item.attributes);
                        if (level == 0)
                            insideAttributes.push(item.association.foreignKey);
                        if (item.include)
                            organize$_1(item.include, item.model.associations, ++level);
                    });
                };
                organize$_1(include, service.associations, 0);
            }
            // organize exclude tables
            if (inputArtifact.object.config && inputArtifact.object.config.exclude) {
                exclude = inputArtifact.object.config.exclude;
                var organize$_2 = function (include, associations, level) {
                    include.forEach(function (item) {
                        if (!associations[item.as])
                            item.model = service.repository.instance.models[item.as];
                        else {
                            item.model = associations[item.as].target;
                            item.association = associations[item.as];
                            item.parent = { model: associations[item.as].source };
                        }
                        if (item.include)
                            organize$_2(item.include, item.model.associations, ++level);
                    });
                };
                organize$_2(exclude, service.associations, 0);
            }
            var search = new nick_data_commons_1.Search(inputArtifact.object.data);
            return service.getMetadata()
                .pipe((0, operators_1.concatMap)(function (metadata) {
                search.setMetadata(metadata);
                return search.buildWhere()
                    .pipe((0, operators_1.concatMap)(function (_where) {
                    if (_where.length)
                        _where = { $or: nick_data_commons_1.Search.literalFn(_where) };
                    // func to generate series
                    var generateSeriesRef = service.fn('generate_series', service.col("".concat(metadata.modelTableName, ".").concat(startField)), service.col("".concat(metadata.modelTableName, ".").concat(endField)), "".concat(seriesDuration, " minute"));
                    var dateTruncRef = service.fn('date_trunc', 'second', generateSeriesRef);
                    // const startColumn = service.literal(`"${startField}" at time zone '${timeZone}' as "${startField}"`);
                    // const endColumn = service.literal(`"${endField}" at time zone '${timeZone}' as "${endField}"`);
                    var startColumn = service.literal("\"".concat(metadata.modelTableName, "\".\"").concat(startField, "\" as \"").concat(startField, "\""));
                    var endColumn = service.literal("\"".concat(metadata.modelTableName, "\".\"").concat(endField, "\" as \"").concat(endField, "\""));
                    if (!inputArtifact.object.config.attributes)
                        inputArtifact.object.config.attributes = [];
                    // add series attribute and concat with fields user requested
                    var attributes = [[dateTruncRef, seriesField], startColumn, endColumn].concat(insideAttributes);
                    var externalWhere = {
                        $and: []
                    };
                    // filter by min date
                    if (inputArtifact.object.config.minDate)
                        externalWhere.$and.push({ day: { $gt: minDate } });
                    // filter by max date
                    if (inputArtifact.object.config.maxDate)
                        externalWhere.$and.push({ day: { $lte: maxDate } });
                    // filter hours between range
                    if (inputArtifact.object.config.range)
                        externalWhere.$and.push({ day: { $between: [selectedDateStart, selectedDateEnd] } });
                    // filter hour between worksheet start and end
                    var datePartHour = service.fn('date_part', 'HOUR', service.repository.model.sequelize.col("\"".concat(metadata.modelTableName, "\".").concat(seriesField)));
                    var dateStartAtPartHour = service.fn('date_part', 'HOUR', service.repository.model.sequelize.col("\"".concat(metadata.modelTableName, "\".").concat(startField)));
                    var dateEndAtPartHour = service.fn('date_part', 'HOUR', service.repository.model.sequelize.col("\"".concat(metadata.modelTableName, "\".").concat(endField)));
                    externalWhere.$and.push(service.where(datePartHour, { $gte: dateStartAtPartHour }));
                    externalWhere.$and.push(service.where(datePartHour, { $lte: dateEndAtPartHour }));
                    // filter weekDays in worksheet (Example: weekday 1,2,3)
                    if (inputArtifact.object.config.weekDaysField) {
                        var datePartDOW = service.fn('date_part', 'DOW', service.repository.model.sequelize.col("\"".concat(metadata.modelTableName, "\".").concat(seriesField)));
                        externalWhere.$and.push(service.where(datePartDOW, service.literal("ANY (string_to_array(\"".concat(metadata.modelTableName, "\".\"").concat(inputArtifact.object.config.weekDaysField, "\", ',')::int[])"))));
                        attributes = attributes.concat([inputArtifact.object.config.weekDaysField]);
                    }
                    if (exclude === null || exclude === void 0 ? void 0 : exclude.length) {
                        // prevent collision between other event table, comparing startAt and endAt fields
                        exclude.forEach(function (excludeItem) {
                            var $and = [];
                            var $or = [];
                            excludeItem.where = { $and: excludeItem.where ? [excludeItem.where] : [] };
                            var replaceFields = new Map();
                            if (excludeItem.joinBy) {
                                excludeItem.joinBy.forEach(function (joinColumn) {
                                    replaceFields.set("'...".concat(metadata.modelTableName, ".").concat(joinColumn, "'"), "\"".concat(metadata.modelTableName, "\".\"").concat(joinColumn, "\""));
                                });
                            }
                            // ("worksheet"."day" >= "room"."startAt" AND "worksheet"."day" < "room"."endAt") OR
                            // ("worksheet"."day" < "room"."startAt" AND ("worksheet".day + INTERVAL '60 minutes') > "room"."startAt")
                            var seriesColumn = service.literal("\"".concat(metadata.modelTableName, "\".").concat(seriesField));
                            var seriesEndColumn = service.literal("(\"".concat(metadata.modelTableName, "\".").concat(seriesField, " + INTERVAL '").concat(seriesDuration, " minutes')"));
                            var startColumn = service.literal("\"".concat(excludeItem.as, "\".\"").concat(excludeItem.field.start, "\""));
                            var endColumn = service.literal("\"".concat(excludeItem.as, "\".\"").concat(excludeItem.field.end, "\""));
                            $or.push({
                                $and: [
                                    service.where(seriesColumn, { $gte: startColumn }),
                                    service.where(seriesColumn, { $lt: endColumn })
                                ]
                            });
                            $or.push({
                                $and: [
                                    service.where(seriesColumn, { $lt: startColumn }),
                                    service.where(seriesEndColumn, { $gt: startColumn })
                                ]
                            });
                            excludeItem.where.$and.push({ $or: $or });
                            var excludeQuery = excludeItem.model.QueryGenerator.selectQuery(excludeItem.model.tableName, {
                                where: excludeItem.where,
                                tableAs: excludeItem.as,
                                include: excludeItem.include,
                                attributes: excludeItem.attributes,
                                model: excludeItem.model
                            }, service.repository.model);
                            Array.from(replaceFields.keys()).forEach(function (key) {
                                excludeQuery = excludeQuery.replace(new RegExp("".concat(key), 'g'), replaceFields.get(key));
                            });
                            excludeQuery = excludeQuery.replace("SELECT *", "SELECT \"".concat(excludeItem.as, "\".\"").concat(excludeItem.field.start, "\"")).slice(0, -1);
                            excludeQuery = excludeQuery.replace("SELECT \"".concat(excludeItem.as, "\".*"), "SELECT \"".concat(excludeItem.as, "\".\"").concat(excludeItem.field.start, "\""));
                            externalWhere.$and.push(service.where(service.literal("(".concat(excludeQuery, ")")), { $is: null }));
                            // $and.push(service.where(service.literal(`"${excludeModel}"`), {$eq: null}));
                            // $or.push(service.where(service.repository.model.sequelize.col(`"${metadata.modelTableName}".${seriesField}`), {$gte: service.literal(`"${excludeModel}"."${excludeInfo.endField}"`)}));
                            //
                            // const $subAnd = [];
                            // $subAnd.push(service.where(service.repository.model.sequelize.col(`"${metadata.modelTableName}".${seriesField}`), {$lt: service.literal(`"${excludeModel}"."${excludeInfo.startField}"`)}));
                            // $subAnd.push(service.where(service.literal(`("${metadata.modelTableName}".${seriesField} + INTERVAL '${seriesDuration} minutes')`), {$lt: service.literal(`"${excludeModel}"."${excludeInfo.endField}"`)}));
                            //
                            // $or.push({$and: $subAnd});
                            // $and.push({$or});
                            // externalWhere.$and.push({$or: $and});
                        });
                    }
                    // generate external where sentence
                    var externalWhereSentence = service.repository.model.QueryGenerator.getWhereConditions(externalWhere, metadata.modelTableName, service.repository.model, {});
                    var internalQueryGenerateSeries = service.repository.model.QueryGenerator.selectQuery(service.repository.model.tableName, {
                        where: _where,
                        tableAs: metadata.modelTableName,
                        include: include,
                        attributes: attributes,
                        model: service.repository.model
                    }, service.repository.model);
                    var mainQueryWithFilters = service.repository.model.QueryGenerator.selectQuery(service.repository.model.tableName, {
                        where: _where,
                        tableAs: metadata.modelTableName,
                        include: include,
                        attributes: attributes,
                        model: service.repository.model,
                        subQuery: internalQueryGenerateSeries
                    }, service.repository.model);
                    var groupAttributesText = ["\"".concat(metadata.modelTableName, "\".\"").concat(seriesField, "\"")];
                    var mainAttributesText = ["\"".concat(metadata.modelTableName, "\".\"").concat(seriesField, "\"")];
                    // required attributes by includes
                    Array.from(includeAttributes.keys()).forEach(function (model) {
                        groupAttributesText = groupAttributesText.concat(includeAttributes.get(model).map(function (attribute) { return "\"".concat(model, "\".\"").concat(attribute, "\""); }));
                    });
                    if (inputArtifact.object.config.showEndDate)
                        mainAttributesText.push("(\"".concat(metadata.modelTableName, "\".").concat(seriesField, " + INTERVAL '").concat(seriesDuration, " minutes') as \"dayEnd\""));
                    mainQueryWithFilters = mainQueryWithFilters.replace("SELECT \"".concat(metadata.modelTableName, "\".*"), "SELECT ".concat(mainAttributesText.join(', '))).slice(0, -1);
                    mainQueryWithFilters = "".concat(mainQueryWithFilters, " WHERE ").concat(externalWhereSentence, " GROUP BY ").concat(groupAttributesText.join(', '), ";");
                    return (0, rxjs_1.from)(service.repository.instance.query(mainQueryWithFilters, { nest: true }))
                        .pipe((0, operators_1.map)(function (result) {
                        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
                        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                        outputArtifact.object = { data: result.map(function (entity) { return entity && entity.toJSON ? entity.toJSON() : entity; }) };
                        return outputArtifact;
                    }));
                }));
            }));
        }));
    };
    DateHook.prototype.seriesGeneration = function (inputArtifact) {
        var dates = [];
        var currDate = (0, moment_1.default)(inputArtifact.object.config.startAt).milliseconds(0);
        var lastDate = (0, moment_1.default)(inputArtifact.object.config.endAt).milliseconds(0);
        while (currDate.diff(lastDate) < 0) {
            dates = __spreadArray(__spreadArray([], __read(dates), false), [currDate.clone()], false);
            currDate = currDate.add(inputArtifact.object.config.value, inputArtifact.object.config.kind);
        }
        dates = __spreadArray(__spreadArray([], __read(dates), false), [lastDate], false);
        dates = __spreadArray([], __read(new Set(dates)), false);
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = dates;
        return (0, rxjs_1.of)(outputArtifact);
    };
    DateHook.prototype.isDateTimeBetween = function (inputArtifact) {
        var currentWeekDay = (0, moment_1.default)().isoWeekday();
        var currentDateTime = moment_1.default.utc();
        console.log('SALVOU');
        var auxCurrentDate = (0, moment_1.default)(currentDateTime).format('YYYY-MM-DD');
        var currentDate = (0, moment_1.default)(auxCurrentDate);
        var auxCurrentTime = (0, moment_1.default)(currentDateTime).format('HH-mm-ss');
        var currentTime = (0, moment_1.default)(auxCurrentTime, 'HH-mm-ss');
        var auxStartAtDate = (0, moment_1.default)(inputArtifact.object.data.startAt).utc().format('YYYY-MM-DD');
        var startAtDate = (0, moment_1.default)(auxStartAtDate);
        var auxStartAtTime = (0, moment_1.default)(inputArtifact.object.data.startAt).utc().format('HH-mm-ss');
        var startAtTime = (0, moment_1.default)(auxStartAtTime, 'HH-mm-ss');
        var auxEndAtDate = (0, moment_1.default)(inputArtifact.object.data.endAt).utc().format('YYYY-MM-DD');
        var endAtDate = (0, moment_1.default)(auxEndAtDate);
        var auxEndAtTime = (0, moment_1.default)(inputArtifact.object.data.endAt).utc().format('HH-mm-ss');
        var endAtTime = (0, moment_1.default)(auxEndAtTime, 'HH-mm-ss');
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = ((inputArtifact.object.data.weekDays.includes(currentWeekDay)) &&
            (currentDate.isBetween(startAtDate, endAtDate) || currentDate.isSame(startAtDate) || currentDate.isSame(endAtDate)) &&
            (currentTime.isBetween(startAtTime, endAtTime) || currentTime.isSame(startAtTime)));
        return (0, rxjs_1.of)(outputArtifact);
    };
    DateHook.prototype.setDatePeriodsPerYear = function (inputArtifact) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        var cron = new cron_1.CronJob(inputArtifact.object.data.cron);
        var recurrenceEndDate = inputArtifact.object.data.recurrenceEndDate;
        var duration = (0, moment_1.default)(inputArtifact.object.data.endDate).diff(inputArtifact.object.data.startDate);
        var nextStartDates = cron.nextDates(365);
        if (nextStartDates instanceof Array) {
            return (0, rxjs_1.from)(nextStartDates)
                .pipe((0, operators_1.takeWhile)(function (nextStartDate) {
                return !(0, moment_1.default)(nextStartDate).isAfter((0, moment_1.default)(recurrenceEndDate));
            }))
                .pipe((0, operators_1.map)(function (nextStartDate) {
                var nextEndDate = (0, moment_1.default)(nextStartDate).add(duration);
                return [nextStartDate, nextEndDate];
            }), (0, operators_1.toArray)())
                .pipe((0, operators_1.concatMap)(function (eventChilds) {
                outputArtifact.object = eventChilds;
                return (0, rxjs_1.of)(outputArtifact);
            }));
        }
        return (0, rxjs_1.of)(outputArtifact);
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('3d224630-0df3-458e-97b9-c34a9d4cad82')
    ], DateHook.prototype, "set", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('f53ac677-cb59-4cdd-8d3c-172e5902ca0a')
    ], DateHook.prototype, "operations", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('e8106e5e-fcac-4e16-b504-69e52b4ccb71')
    ], DateHook.prototype, "get", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('11b82c46-b350-4d92-b1b1-e5efaa0949fe')
    ], DateHook.prototype, "age", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('2ed54dee-ebe1-4c07-9e97-d795d7beeb4f')
    ], DateHook.prototype, "now", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('3a5e9094-1630-446b-8b3f-2d16c1ffab07')
    ], DateHook.prototype, "format", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('295ecbb4-2f65-4bd3-8a4b-26098302e2ad')
    ], DateHook.prototype, "parse", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('c0a345d8-50ea-4a19-b7ed-0f982aa75b64')
    ], DateHook.prototype, "availableSeriesWorksheet", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('18d7258f-d6f5-4163-8051-acf5dfcb2685')
    ], DateHook.prototype, "seriesGeneration", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('411456f6-035b-42fe-aea5-91ffceb398a3')
    ], DateHook.prototype, "isDateTimeBetween", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('7d4c3a80-87ed-4c99-a2c1-d4c114851b46')
    ], DateHook.prototype, "setDatePeriodsPerYear", null);
    DateHook = __decorate([
        (0, nick_process_commons_1.HookClass)('date')
    ], DateHook);
    return DateHook;
}(nick_process_commons_1.BaseHook));
exports.DateHook = DateHook;
//# sourceMappingURL=date.hook.js.map