"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EntityHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var http_hook_1 = require("../http/http.hook");
var EntityHook = /** @class */ (function (_super) {
    __extends(EntityHook, _super);
    function EntityHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    EntityHook.prototype.createOrUpdate = function (inputArtifact) {
        return this.crud(inputArtifact.object.model, inputArtifact.object.dbId)
            .pipe((0, operators_1.concatMap)(function (service) {
            var loopArtifact = inputArtifact.object.data;
            if (inputArtifact.kind != nick_data_commons_1.ArtfactKind.ARRAY)
                loopArtifact = [inputArtifact];
            var saveItems = loopArtifact.map(function (value) {
                if (value && value.hasOwnProperty('object') && value.object.hasOwnProperty('data'))
                    return value.object.data;
                return value;
            });
            // adicionar uma pequena lógica temporária de filtro
            if (!saveItems.length) {
                var artifact = new nick_process_commons_1.NickProcessArtfact();
                artifact.object = {
                    data: []
                };
                artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                return (0, rxjs_1.of)(artifact);
            }
            if (saveItems.length == 1)
                return service.save(saveItems[0], null, null, null, { where: inputArtifact.object.where, upsert: inputArtifact.object.upsert })
                    .pipe((0, operators_1.map)(function (entity) {
                    var returnArtifact = new nick_process_commons_1.NickProcessArtfact();
                    returnArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                    returnArtifact.object = {
                        data: entity && entity.toJSON ? entity.toJSON() : entity,
                        model: inputArtifact.object.model
                    };
                    if (inputArtifact.kind == nick_data_commons_1.ArtfactKind.ARRAY)
                        returnArtifact.object.data = [returnArtifact.object.data];
                    return returnArtifact;
                }));
            return service.bulkSave(saveItems, inputArtifact.object.options)
                .pipe((0, operators_1.map)(function (entity) {
                var returnArtifact = new nick_process_commons_1.NickProcessArtfact();
                returnArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                if (inputArtifact.kind != nick_data_commons_1.ArtfactKind.ARRAY)
                    returnArtifact.object = {
                        data: entity[0] ? entity[0].toJSON ? entity[0].toJSON() : entity[0] : entity,
                        model: inputArtifact.object.model
                    };
                else
                    returnArtifact.object = {
                        data: entity.map(function (entity) { return entity && entity.toJSON ? entity.toJSON() : entity; }),
                        // metadata: cacheMetadata,
                        model: inputArtifact.object.model
                    };
                return returnArtifact;
            }));
        }));
    };
    EntityHook.prototype.findOne = function (inputArtifact) {
        return this.crud(inputArtifact.object.model, inputArtifact.object.dbId)
            .pipe((0, operators_1.concatMap)(function (service) {
            var _a, _b, _c;
            var include = null;
            if (inputArtifact.object.config && inputArtifact.object.config.include) {
                include = inputArtifact.object.config.include;
                var organize$_1 = function (include, associations) {
                    include.forEach(function (item) {
                        var _a;
                        if ((_a = item.where) === null || _a === void 0 ? void 0 : _a.hasOwnProperty('__customWhere')) {
                            if (!item.where['$and'])
                                item.where['$and'] = [];
                            item.where['$and'].push(nick_data_commons_1.Search.literalFn(item.where.__customWhere));
                            delete item.where.__customWhere;
                        }
                        if (!associations[item.as]) {
                            throw new Error("Association not found ".concat(item.as, " - ").concat(item.tableName));
                        }
                        else {
                            item.model = associations[item.as].target;
                        }
                        if (item.include)
                            organize$_1(item.include, item.model.associations);
                    });
                };
                organize$_1(include, service.associations);
            }
            if (!inputArtifact.object.config)
                inputArtifact.object.config = {};
            if (inputArtifact.object.config.raw == undefined)
                inputArtifact.object.config.raw = true;
            return service.findOne(inputArtifact.object.data.id, null, include, {
                raw: (_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.raw,
                attributes: (_c = (_b = inputArtifact === null || inputArtifact === void 0 ? void 0 : inputArtifact.object) === null || _b === void 0 ? void 0 : _b.config) === null || _c === void 0 ? void 0 : _c.attributes
            })
                .pipe((0, operators_1.concatMap)(function (entity) {
                inputArtifact.object.data = entity && entity.toJSON ? entity.toJSON() : entity;
                return service.getMetadata()
                    .pipe((0, operators_1.map)(function (metadata) {
                    inputArtifact.object.metadata = metadata;
                    return inputArtifact;
                }));
            }));
        }));
    };
    EntityHook.prototype.findOneWhere = function (inputArtifact) {
        var cacheMetadata;
        return this.crud(inputArtifact.object.model, inputArtifact.object.dbId)
            .pipe((0, operators_1.concatMap)(function (service) {
            var repo = service.repository;
            var loopArtifact = inputArtifact.object.data;
            if (inputArtifact.kind != nick_data_commons_1.ArtfactKind.ARRAY)
                loopArtifact = [inputArtifact];
            return (0, rxjs_1.from)(loopArtifact)
                .pipe((0, operators_1.flatMap)(function (singleInputArtifact) {
                var include = null;
                if (singleInputArtifact.object.config && singleInputArtifact.object.config.include) {
                    include = singleInputArtifact.object.config.include;
                    var organize$_2 = function (include, associations) {
                        include.forEach(function (item) {
                            var _a;
                            if ((_a = item.where) === null || _a === void 0 ? void 0 : _a.hasOwnProperty('__customWhere')) {
                                if (!item.where['$and'])
                                    item.where['$and'] = [];
                                item.where['$and'].push(nick_data_commons_1.Search.literalFn(item.where.__customWhere));
                                delete item.where.__customWhere;
                            }
                            if (!associations[item.as]) {
                                throw new Error("Association not found ".concat(item.as, " - ").concat(item.tableName));
                            }
                            else {
                                item.model = associations[item.as].target;
                            }
                            if (item.include)
                                organize$_2(item.include, item.model.associations);
                        });
                    };
                    organize$_2(include, service.associations);
                }
                if (singleInputArtifact.object.config && singleInputArtifact.object.config.where && singleInputArtifact.object.data) {
                    singleInputArtifact.object.data = Object.assign(singleInputArtifact.object.data, singleInputArtifact.object.config.where);
                }
                var search = new nick_data_commons_1.Search(singleInputArtifact.object.data);
                return service.getMetadata()
                    .pipe((0, operators_1.concatMap)(function (metadata) {
                    search.setMetadata(metadata);
                    return search.buildWhere()
                        .pipe((0, operators_1.concatMap)(function (_where) {
                        var _a, _b, _c, _d, _e, _f, _g, _h, _j;
                        if (_where.length)
                            _where = { $or: nick_data_commons_1.Search.literalFn(_where) };
                        if ((_b = (_a = inputArtifact.object) === null || _a === void 0 ? void 0 : _a.config) === null || _b === void 0 ? void 0 : _b.ignoreWhere)
                            _where = inputArtifact.object.data;
                        return service.findOneWhere(_where, include, (_d = (_c = inputArtifact === null || inputArtifact === void 0 ? void 0 : inputArtifact.object) === null || _c === void 0 ? void 0 : _c.config) === null || _d === void 0 ? void 0 : _d.sort, (_f = (_e = inputArtifact === null || inputArtifact === void 0 ? void 0 : inputArtifact.object) === null || _e === void 0 ? void 0 : _e.config) === null || _f === void 0 ? void 0 : _f.group, null, (_h = (_g = inputArtifact === null || inputArtifact === void 0 ? void 0 : inputArtifact.object) === null || _g === void 0 ? void 0 : _g.config) === null || _h === void 0 ? void 0 : _h.attributes, (_j = inputArtifact.object.config) === null || _j === void 0 ? void 0 : _j.raw)
                            .pipe((0, operators_1.map)(function (entity) {
                            singleInputArtifact.object.data = entity && entity.toJSON ? entity.toJSON() : entity;
                            if (cacheMetadata) {
                                singleInputArtifact.object.metadata = cacheMetadata;
                                return singleInputArtifact;
                            }
                            cacheMetadata = metadata;
                            singleInputArtifact.object.metadata = metadata;
                            return singleInputArtifact;
                        }));
                    }));
                }));
            }, 6), (0, operators_1.toArray)())
                .pipe((0, operators_1.map)(function (result) {
                if (inputArtifact.kind != nick_data_commons_1.ArtfactKind.ARRAY)
                    return result[0];
                var returnArtifact = new nick_process_commons_1.NickProcessArtfact();
                returnArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                returnArtifact.object = {
                    data: result.map(function (artifact) { return artifact.object.data; }),
                    metadata: cacheMetadata,
                    model: cacheMetadata ? cacheMetadata.modelType : null
                };
                return returnArtifact;
            }));
        }));
    };
    EntityHook.prototype.findAll = function (inputArtifact) {
        return this.crud(inputArtifact.object.model, inputArtifact.object.dbId)
            .pipe((0, operators_1.concatMap)(function (service) {
            var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
            var include = null;
            var repo = service.repository;
            if (inputArtifact.object.config && inputArtifact.object.config.include) {
                include = inputArtifact.object.config.include;
                var organize$_3 = function (include, associations) {
                    include.forEach(function (item) {
                        var _a;
                        if ((_a = item.where) === null || _a === void 0 ? void 0 : _a.hasOwnProperty('__customWhere')) {
                            if (!item.where['$and'])
                                item.where['$and'] = [];
                            item.where['$and'].push(nick_data_commons_1.Search.literalFn(item.where.__customWhere));
                            delete item.where.__customWhere;
                        }
                        if (!associations[item.as]) {
                            throw new Error("Association not found ".concat(item.as, " - ").concat(item.tableName));
                        }
                        else {
                            item.model = associations[item.as].target;
                        }
                        if (item.include)
                            organize$_3(item.include, item.model.associations);
                    });
                };
                organize$_3(include, service.associations);
            }
            if ((_b = (_a = inputArtifact.object) === null || _a === void 0 ? void 0 : _a.config) === null || _b === void 0 ? void 0 : _b.attributes) {
                inputArtifact.object.config.attributes = (_d = (_c = inputArtifact.object) === null || _c === void 0 ? void 0 : _c.config) === null || _d === void 0 ? void 0 : _d.attributes.map(function (col) {
                    if (col.indexOf('|fn:count') >= 0) {
                        var colName = col.replace('|fn:count', '');
                        return [service.fn('COUNT', service.col("\"".concat(service.repository.model.name, "\".\"").concat(colName, "\""))), "".concat(colName, "Count")];
                    }
                    else if (col.indexOf('|fn:date_trunc') >= 0) {
                        var ops = col.split('|');
                        var colName = ops[0];
                        ops = ops[1].split(':');
                        return [service.fn('date_trunc', "".concat(ops[2]), service.col("\"".concat(service.repository.model.name, "\".\"").concat(colName, "\""))), "".concat(colName)];
                    }
                    else if (col.indexOf('|fn:sum') >= 0) {
                        var colName = col.replace('|fn:sum', '');
                        return [service.fn('SUM', service.col("\"".concat(service.repository.model.name, "\".\"").concat(colName, "\""))), "".concat(colName, "Sum")];
                    }
                    else if (col.indexOf('|fn:max') >= 0) {
                        var colName = col.replace('|fn:max', '');
                        return [service.fn('MAX', service.col("\"".concat(service.repository.model.name, "\".\"").concat(colName, "\""))), "".concat(colName, "Max")];
                    }
                    return col;
                });
            }
            if ((_f = (_e = inputArtifact.object) === null || _e === void 0 ? void 0 : _e.config) === null || _f === void 0 ? void 0 : _f.group) {
                inputArtifact.object.config.group = (_h = (_g = inputArtifact.object) === null || _g === void 0 ? void 0 : _g.config) === null || _h === void 0 ? void 0 : _h.group.map(function (col) {
                    if (col.indexOf('|fn:count') >= 0) {
                        var colName = col.replace('|fn:count', '');
                        return [service.fn('COUNT', service.col("\"".concat(service.repository.model.name, "\".\"").concat(colName, "\""))), "".concat(colName, "Count")];
                    }
                    else if (col.indexOf('|fn:date_trunc') >= 0) {
                        var ops = col.split('|');
                        var colName = ops[0];
                        ops = ops[1].split(':');
                        return [service.fn('date_trunc', "".concat(ops[2]), service.col("\"".concat(service.repository.model.name, "\".\"").concat(colName, "\""))), "".concat(colName)];
                    }
                    else if (col.indexOf('|fn:sum') >= 0) {
                        var colName = col.replace('|fn:sum', '');
                        return [service.fn('SUM', service.col("\"".concat(service.repository.model.name, "\".\"").concat(colName, "\""))), "".concat(colName, "Sum")];
                    }
                    else if (col.indexOf('|fn:max') >= 0) {
                        var colName = col.replace('|fn:max', '');
                        return [service.fn('MAX', service.col("\"".concat(service.repository.model.name, "\".\"").concat(colName, "\""))), "".concat(colName, "Max")];
                    }
                    return col;
                });
            }
            if ((_k = (_j = inputArtifact.object) === null || _j === void 0 ? void 0 : _j.config) === null || _k === void 0 ? void 0 : _k.sort) {
                inputArtifact.object.config.sort = (_m = (_l = inputArtifact.object) === null || _l === void 0 ? void 0 : _l.config) === null || _m === void 0 ? void 0 : _m.sort.map(function (_col) {
                    var col = _col;
                    if (_col instanceof Array)
                        col = _col[0];
                    else
                        _col = [, 'ASC'];
                    if (_col[1] instanceof Array) {
                        //     ORDER BY case when "tournament_person_order"."stopKind" = 0 then "tournament_person_order"."price" end ASC,
                        // case when "tournament_person_order"."stopKind" = 1 then "tournament_person_order"."price" end DESC
                        // "stopKind|0|ASC",
                        // "stopKind|1|DESC"
                        col = service.literal(_col[1].map(function (query) {
                            var fields = query.split('|');
                            return "case when \"".concat(service.repository.model.name, "\".\"").concat(fields[0], "\" = ").concat(fields[1], " then \"").concat(service.repository.model.name, "\".\"").concat(_col[0], "\" end ").concat(fields[2]);
                        }).join(','));
                        return col;
                    }
                    if (col.indexOf('|fn:count') >= 0) {
                        var colName = col.replace('|fn:count', '');
                        return [service.fn('COUNT', service.col("\"".concat(service.repository.model.name, "\".\"").concat(colName, "\""))), "".concat(colName, "Count")];
                    }
                    else if (col.indexOf('|fn:date_trunc') >= 0) {
                        var ops = col.split('|');
                        var colName = ops[0];
                        ops = ops[1].split(':');
                        return [service.fn('date_trunc', "".concat(ops[2]), service.col("\"".concat(service.repository.model.name, "\".\"").concat(colName, "\"")))];
                    }
                    else if (col.indexOf('|fn:sum') >= 0) {
                        var colName = col.replace('|fn:sum', '');
                        return [service.fn('SUM', service.col("\"".concat(service.repository.model.name, "\".\"").concat(colName, "\""))), "".concat(colName, "Sum")];
                    }
                    else if (col.indexOf('|fn:max') >= 0) {
                        var colName = col.replace('|fn:max', '');
                        return [service.fn('MAX', service.col("\"".concat(service.repository.model.name, "\".\"").concat(colName, "\""))), "".concat(colName, "Max")];
                    }
                    return [col, _col[1]];
                });
            }
            var search = new nick_data_commons_1.Search(inputArtifact.object.data);
            return service.getMetadata()
                .pipe((0, operators_1.concatMap)(function (metadata) {
                search.setMetadata(metadata);
                return search.buildWhere()
                    .pipe((0, operators_1.concatMap)(function (_where) {
                    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
                    if (_where.length)
                        _where = { $or: nick_data_commons_1.Search.literalFn(_where) };
                    if ((_b = (_a = inputArtifact.object) === null || _a === void 0 ? void 0 : _a.config) === null || _b === void 0 ? void 0 : _b.ignoreWhere)
                        _where = inputArtifact.object.data;
                    return service.findAll(_where, include, null, (_d = (_c = inputArtifact === null || inputArtifact === void 0 ? void 0 : inputArtifact.object) === null || _c === void 0 ? void 0 : _c.config) === null || _d === void 0 ? void 0 : _d.sort, (_f = (_e = inputArtifact === null || inputArtifact === void 0 ? void 0 : inputArtifact.object) === null || _e === void 0 ? void 0 : _e.config) === null || _f === void 0 ? void 0 : _f.group, (_h = (_g = inputArtifact === null || inputArtifact === void 0 ? void 0 : inputArtifact.object) === null || _g === void 0 ? void 0 : _g.config) === null || _h === void 0 ? void 0 : _h.attributes, (_j = inputArtifact.object.config) === null || _j === void 0 ? void 0 : _j.raw)
                        .pipe((0, operators_1.map)(function (entities) {
                        inputArtifact.object.data = entities.map(function (entity) { return entity && entity.toJSON ? entity.toJSON() : entity; });
                        inputArtifact.object.metadata = metadata;
                        return inputArtifact;
                    }));
                }));
            }));
        }));
    };
    EntityHook.prototype.page = function (inputArtifact) {
        return this.crud(inputArtifact.object.model, inputArtifact.object.database)
            .pipe((0, operators_1.concatMap)(function (service) {
            var include = null;
            var sort = null;
            if (inputArtifact.object.config && inputArtifact.object.config.include) {
                include = inputArtifact.object.config.include;
                var organize$_4 = function (include, associations) {
                    include.forEach(function (item) {
                        var _a;
                        if ((_a = item.where) === null || _a === void 0 ? void 0 : _a.hasOwnProperty('__customWhere')) {
                            if (!item.where['$and'])
                                item.where['$and'] = [];
                            item.where['$and'].push(nick_data_commons_1.Search.literalFn(item.where.__customWhere));
                            delete item.where.__customWhere;
                        }
                        if (!associations[item.as]) {
                            throw new Error("Association not found ".concat(item.as, " - ").concat(item.tableName));
                        }
                        else {
                            item.model = associations[item.as].target;
                        }
                        if (item.include)
                            organize$_4(item.include, item.model.associations);
                    });
                };
                organize$_4(include, service.associations);
            }
            if (inputArtifact.object.config && inputArtifact.object.config.sort) {
                sort = inputArtifact.object.config.sort;
            }
            var search = new nick_data_commons_1.Search(inputArtifact.object.data);
            return service.getMetadata()
                .pipe((0, operators_1.concatMap)(function (metadata) {
                search.setMetadata(metadata);
                return search.buildWhere()
                    .pipe((0, operators_1.concatMap)(function (_where) {
                    var _a, _b;
                    if (_where.length)
                        _where = { $or: nick_data_commons_1.Search.literalFn(_where) };
                    if ((_b = (_a = inputArtifact.object) === null || _a === void 0 ? void 0 : _a.config) === null || _b === void 0 ? void 0 : _b.ignoreWhere)
                        _where = inputArtifact.object.data;
                    return service.countAll(_where, include)
                        .pipe((0, operators_1.concatMap)(function (total) {
                        var _a, _b, _c, _d, _e, _f, _g;
                        inputArtifact.object.config.total = total;
                        inputArtifact.object.config.totalPages = Math.ceil(total / ((_a = inputArtifact === null || inputArtifact === void 0 ? void 0 : inputArtifact.object) === null || _a === void 0 ? void 0 : _a.config.pageSize));
                        var offset = (((_b = inputArtifact === null || inputArtifact === void 0 ? void 0 : inputArtifact.object) === null || _b === void 0 ? void 0 : _b.config.page) - 1) * ((_c = inputArtifact === null || inputArtifact === void 0 ? void 0 : inputArtifact.object) === null || _c === void 0 ? void 0 : _c.config.pageSize);
                        return service.findPage(_where, (_d = inputArtifact === null || inputArtifact === void 0 ? void 0 : inputArtifact.object) === null || _d === void 0 ? void 0 : _d.config.pageSize, offset, include, null, sort, (_e = inputArtifact === null || inputArtifact === void 0 ? void 0 : inputArtifact.object) === null || _e === void 0 ? void 0 : _e.config.group, (_f = inputArtifact === null || inputArtifact === void 0 ? void 0 : inputArtifact.object) === null || _f === void 0 ? void 0 : _f.config.attributes, (_g = inputArtifact.object.config) === null || _g === void 0 ? void 0 : _g.raw)
                            .pipe((0, operators_1.map)(function (entities) {
                            inputArtifact.object.data = entities.map(function (entity) { return entity && entity.toJSON ? entity.toJSON() : entity; });
                            inputArtifact.object.metadata = metadata;
                            return inputArtifact;
                        }));
                    }));
                }));
            }));
        }));
    };
    EntityHook.prototype.count = function (inputArtifact) {
        return this.crud(inputArtifact.object.model, inputArtifact.object.dbId)
            .pipe((0, operators_1.concatMap)(function (service) {
            var include = null;
            var repo = service.repository;
            if (inputArtifact.object.config && inputArtifact.object.config.include) {
                include = inputArtifact.object.config.include;
                var organize$_5 = function (include, associations) {
                    include.forEach(function (item) {
                        var _a;
                        if ((_a = item.where) === null || _a === void 0 ? void 0 : _a.hasOwnProperty('__customWhere')) {
                            if (!item.where['$and'])
                                item.where['$and'] = [];
                            item.where['$and'].push(nick_data_commons_1.Search.literalFn(item.where.__customWhere));
                            delete item.where.__customWhere;
                        }
                        if (!associations[item.as]) {
                            throw new Error("Association not found ".concat(item.as, " - ").concat(item.tableName));
                        }
                        else {
                            item.model = associations[item.as].target;
                        }
                        if (item.include)
                            organize$_5(item.include, item.model.associations);
                    });
                };
                organize$_5(include, service.associations);
            }
            var search = new nick_data_commons_1.Search(inputArtifact.object.data);
            return service.getMetadata()
                .pipe((0, operators_1.concatMap)(function (metadata) {
                search.setMetadata(metadata);
                return search.buildWhere()
                    .pipe((0, operators_1.concatMap)(function (_where) {
                    if (_where.length)
                        _where = { $or: nick_data_commons_1.Search.literalFn(_where) };
                    return service.countAll(_where, include);
                }));
            }))
                .pipe((0, operators_1.concatMap)(function (count) {
                inputArtifact.object.data = count;
                return (0, rxjs_1.of)(inputArtifact);
            }));
        }));
    };
    EntityHook.prototype.delete = function (inputArtifact) {
        return this.crud(inputArtifact.object.model, inputArtifact.object.dbId)
            .pipe((0, operators_1.concatMap)(function (service) {
            var _a, _b;
            if (inputArtifact.object.where) {
                return service.deleteWhere(inputArtifact.object.where, (_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.permanent)
                    .pipe((0, operators_1.map)(function () {
                    return inputArtifact;
                }));
            }
            else {
                if (inputArtifact.object.data.id instanceof Array)
                    return (0, rxjs_1.from)(inputArtifact.object.data.id)
                        .pipe((0, operators_1.concatMap)(function (id) {
                        var _a;
                        return service.delete(id, (_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.permanent);
                    }), (0, operators_1.toArray)())
                        .pipe((0, operators_1.map)(function () {
                        return inputArtifact;
                    }));
                return service.delete(inputArtifact.object.data.id, (_b = inputArtifact.object.config) === null || _b === void 0 ? void 0 : _b.permanent)
                    .pipe((0, operators_1.concatMap)(function (entity) {
                    inputArtifact.object.data = entity;
                    return (0, rxjs_1.of)(inputArtifact);
                }));
            }
        }));
    };
    EntityHook.prototype.findMaxWhere = function (inputArtifact) {
        return this.crud(inputArtifact.object.model, inputArtifact.object.dbId)
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.max(inputArtifact.object.config.column, inputArtifact.object.data)
                .pipe((0, operators_1.concatMap)(function (result) {
                // todo: o max pode ser para qualquer tipo de campo, verificar no metadata qual o tipo para fazer o tratamento correto.
                inputArtifact.object.data = {};
                if (result == null || isNaN(result))
                    inputArtifact.object.data[inputArtifact.object.config.column] = 0;
                else
                    inputArtifact.object.data[inputArtifact.object.config.column] = result;
                return (0, rxjs_1.of)(inputArtifact);
            }));
        }));
    };
    EntityHook.prototype.empty = function (inputArtifact) {
        if (!inputArtifact.object.model)
            return (0, rxjs_1.of)(inputArtifact);
        return this.crud(inputArtifact.object.model, inputArtifact.object.dbId)
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.getMetadata()
                .pipe((0, operators_1.map)(function (metadata) {
                inputArtifact.object.metadata = metadata;
                return inputArtifact;
            }));
        }));
    };
    EntityHook.prototype.modelEntity = function (inputArtifact) {
        var metadataHookInput = new nick_process_commons_1.NickProcessArtfact();
        metadataHookInput.kind = nick_data_commons_1.ArtfactKind.ANY;
        metadataHookInput.object = {
            config: {
                url: "/api/model/metadata/".concat(inputArtifact.object.model)
            }
        };
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) { return httpHook.get(metadataHookInput); }));
    };
    EntityHook.prototype.export = function (inputArtifact) {
        // let _service: any;
        //
        // let modelEntity: any;
        // const fields: any[] = [];
        // const fieldsModel: any[] = [];
        // let modelDbXref: any;
        // let hookModel: any[];
        // const modelService = 'f9b070ee-daa1-4a14-922e-62cfcd8d625d';
        // const fieldsService = '690d8463-4367-4fd0-9200-3e2399b6288c';
        // const fieldsModelService = 'ce4741dc-b7bb-4aff-aa1b-20655853ff0b';
        // const modelDbXrefService = '81cf939e-baff-4c06-b4ce-7f9c05bcd8a6';
        // const hookModelService = '290d516e-d2de-440b-98e3-c95f08e5c78c';
        return (0, rxjs_1.of)(inputArtifact);
        // return this.crudService
        //     .pipe(concatMap((services: ICoreCrudService[]) => from(services)))
        //     .pipe(concatMap((service: ICoreCrudService) => {
        //         _service = service;
        //         return service.getModelById(modelService);
        //     }))
        //     .pipe(concatMap((service: ICoreCrudService) => service.findOne(inputArtifact.object.data.modelId)))
        //     .pipe(concatMap((model: any) => {
        //         modelEntity = model;
        //         return _service.getModelById(fieldsModelService)
        //             .pipe(concatMap((service: ICoreCrudService) =>
        //                 service.findAll({modelId: model.id}, null, null,
        //                     [{
        //                         model: _service._repository.models.field,
        //                         as: 'field'
        //                     }])));
        //     }))
        //     .pipe(concatMap((fieldsXrefs: any[]) => {
        //
        //         fieldsXrefs.forEach((fieldXref) => {
        //             const field = fieldXref.get();
        //             fields.push(field.field);
        //             delete field.field;
        //             fieldsModel.push(field);
        //         });
        //
        //         const outputArtifact = new NickProcessArtfact();
        //         outputArtifact.kind = ArtfactKind.ANY;
        //         outputArtifact.object = {
        //             info: {
        //                 filename: `${modelEntity.name.toLowerCase()}-entity-seed.json`,
        //                 contentType: 'application/json'
        //             }
        //         };
        //
        //         const entityOutput = {
        //             id: uuid(),
        //             author: 'Alysson Guimarães',
        //             data: [
        //                 {
        //                     systemId: '774bfaa5-fab2-4528-80f1-293afb8eb71d',
        //                     table: 'model',
        //                     rows: [modelEntity]
        //                 },
        //                 {
        //                     systemId: '774bfaa5-fab2-4528-80f1-293afb8eb71d',
        //                     table: 'field',
        //                     rows: fields
        //                 },
        //                 {
        //                     systemId: '774bfaa5-fab2-4528-80f1-293afb8eb71d',
        //                     table: 'field_model_xref',
        //                     rows: fieldsModel
        //                 },
        //                 {
        //                     table: 'model_db_xref',
        //                     service: 'ModelDbXrefService',
        //                     systemId: '774bfaa5-fab2-4528-80f1-293afb8eb71d',
        //                     rows: ['']
        //                 },
        //                 {
        //                     table: 'hook_model_xref',
        //                     systemId: '774bfaa5-fab2-4528-80f1-293afb8eb71d',
        //                     rows: ['']
        //                 }
        //             ]
        //         };
        //
        //         outputArtifact.object.buffer = JSON.stringify(entityOutput);
        //
        //         return of(outputArtifact);
        //     }));
    };
    EntityHook.prototype.sum = function (inputArtifact) {
        return this.crud(inputArtifact.object.model, inputArtifact.object.dbId)
            .pipe((0, operators_1.concatMap)(function (service) {
            var search = new nick_data_commons_1.Search(inputArtifact.object.data);
            return service.getMetadata()
                .pipe((0, operators_1.concatMap)(function (metadata) {
                search.setMetadata(metadata);
                return search.buildWhere()
                    .pipe((0, operators_1.concatMap)(function (_where) {
                    if (_where.length)
                        _where = { $or: nick_data_commons_1.Search.literalFn(_where) };
                    return service.sum(inputArtifact.object.config.column, _where);
                }));
            }))
                .pipe((0, operators_1.concatMap)(function (sum) {
                inputArtifact.object.data = sum;
                return (0, rxjs_1.of)(inputArtifact);
            }));
        }));
    };
    EntityHook.prototype.reindex = function (inputArtifact) {
        return this.crud(inputArtifact.object.model, inputArtifact.object.dbId)
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.reindex();
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result;
            return outputArtifact;
        }));
    };
    EntityHook.prototype.executeQuery = function (inputArtifact) {
        return this.crud(inputArtifact.object.model, inputArtifact.object.dbId)
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.executeQuery(inputArtifact.object.query, inputArtifact.object.options);
        }))
            .pipe((0, operators_1.map)(function (result) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = result;
            return outputArtifact;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('086edb82-9697-4522-875d-73001a1ee931')
    ], EntityHook.prototype, "createOrUpdate", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('6eb53c3c-b858-40cf-a116-33a40d28c088')
    ], EntityHook.prototype, "findOne", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('930d2caa-65d7-4ced-96b7-268ce6f69ba0')
    ], EntityHook.prototype, "findOneWhere", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('d3aaa6ff-9718-43a6-97b1-ee690c402d3d')
    ], EntityHook.prototype, "findAll", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('9bfed52b-28bb-4f2f-bd13-ee7f0ee3d37c')
    ], EntityHook.prototype, "page", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('1551b46b-1212-4f4d-8487-5e8a8d12a404')
    ], EntityHook.prototype, "count", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('2a9687f4-8eae-48d6-806e-bef204c6e841')
    ], EntityHook.prototype, "delete", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('6d753c44-6bc1-4b4c-87e3-31e28230bff9')
    ], EntityHook.prototype, "findMaxWhere", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('a74af8cc-d5b4-45bc-a80c-af42cb030c30')
    ], EntityHook.prototype, "empty", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('587d12d0-25ee-4b69-99cc-d5e779ee4fa7')
    ], EntityHook.prototype, "modelEntity", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('abf46626-06e9-43fa-ae06-9a14171881f0')
    ], EntityHook.prototype, "export", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('1029466b-02ec-4986-a51a-20ca2352a30d')
    ], EntityHook.prototype, "sum", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('c72323c2-6fa3-49a5-a618-1f478b77d6c4')
    ], EntityHook.prototype, "reindex", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('417d9aaa-7054-443c-86ac-58eed2f235de')
    ], EntityHook.prototype, "executeQuery", null);
    EntityHook = __decorate([
        (0, nick_process_commons_1.HookClass)('entity')
    ], EntityHook);
    return EntityHook;
}(nick_process_commons_1.BaseHook));
exports.EntityHook = EntityHook;
//# sourceMappingURL=entity.hook.js.map