"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var https = __importStar(require("https"));
var http = __importStar(require("http"));
var rxjs_1 = require("rxjs");
var fs_1 = __importDefault(require("fs"));
var uuid_1 = require("uuid");
var FileHook = /** @class */ (function (_super) {
    __extends(FileHook, _super);
    function FileHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FileHook.prototype.base64ToBuffer = function (inputArtifact) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = Buffer.from(inputArtifact.object.data
            .replace(new RegExp(/^data:image\/(png|gif|jpeg);base64,/, 'g'), ''), 'base64');
        return (0, rxjs_1.of)(outputArtifact);
    };
    FileHook.prototype.downloadFile = function (inputArtifact) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        var protocol = inputArtifact.object.url.startsWith('https://') ? https : http;
        return new rxjs_1.Observable(function (observer) {
            protocol.get(inputArtifact.object.url, { rejectUnauthorized: false }, function (response) {
                var chunks = [];
                response.on('data', function (chunk) {
                    chunks.push(chunk);
                });
                response.on('end', function () {
                    outputArtifact.object = Buffer.concat(chunks);
                    observer.next(outputArtifact);
                    observer.complete();
                });
            });
        });
    };
    FileHook.prototype.jsonToBuffer = function (inputArtifact) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = Buffer.from(JSON.stringify(inputArtifact.object.data));
        return (0, rxjs_1.of)(outputArtifact);
    };
    FileHook.prototype.stringToBuffer = function (inputArtifact) {
        var _a;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        if (((_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.output) == 'file') {
            if (inputArtifact.object.config.fileName)
                this.context.response.attachment(inputArtifact.object.config.fileName);
            if (inputArtifact.object.config.contentType)
                this.context.response.type(inputArtifact.object.config.contentType);
            outputArtifact.object = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.object.kind = 10;
            var filePath = "/tmp/".concat((0, uuid_1.v4)());
            fs_1.default.writeFileSync(filePath, Buffer.from(inputArtifact.object.data));
            outputArtifact.object.object = fs_1.default.readFileSync(filePath);
        }
        else
            outputArtifact.object = Buffer.from(inputArtifact.object.data);
        return (0, rxjs_1.of)(outputArtifact);
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('b6b067e6-f21d-4aa9-ac8a-a2f2367d10a2')
    ], FileHook.prototype, "base64ToBuffer", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('9d5463f5-549b-4c9e-b7f0-792d24930643')
    ], FileHook.prototype, "downloadFile", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('4b71ef79-2c4e-451a-b664-5719aaa9018c')
    ], FileHook.prototype, "jsonToBuffer", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('3c71fae3-d871-49c1-abe2-80a7d6f104d0')
    ], FileHook.prototype, "stringToBuffer", null);
    FileHook = __decorate([
        (0, nick_process_commons_1.HookClass)('file')
    ], FileHook);
    return FileHook;
}(nick_process_commons_1.BaseHook));
exports.FileHook = FileHook;
//# sourceMappingURL=file.hook.js.map