"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FlowHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var FlowHook = /** @class */ (function (_super) {
    __extends(FlowHook, _super);
    function FlowHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FlowHook.prototype.execute = function (inputArtifact) {
        var _this = this;
        return this.service('FlowService')
            .pipe((0, operators_1.concatMap)(function (service) {
            var _a, _b;
            var currentFlow = _this.context.getData('flowContext');
            if ((_b = (_a = inputArtifact.object) === null || _a === void 0 ? void 0 : _a.config) === null || _b === void 0 ? void 0 : _b.queue) {
                return _this.context.clone()
                    .pipe((0, operators_1.concatMap)(function (context) {
                    service.configureInstanceId(context.instanceId);
                    return service.startClientNewFlow(inputArtifact.object.processId, inputArtifact.object.data, inputArtifact.object.config);
                }));
            }
            return service.startNewFlow(inputArtifact.object.processId, inputArtifact.object.data, { _id: currentFlow._id, entity: currentFlow.entity });
        }))
            .pipe((0, operators_1.map)(function (result) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            artifact.object = result;
            return artifact;
        }));
    };
    FlowHook.prototype.forEach = function (inputArtifact) {
        var _a;
        if (!isNaN(inputArtifact.object.data))
            inputArtifact.object.data = new Array(parseInt(inputArtifact.object.data)).fill({}).map(function (i, index) { return ({ __index: index }); });
        if ((_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.parseArray) {
            if (inputArtifact.object.data != undefined && !(inputArtifact.object.data instanceof Array))
                inputArtifact.object.data = [inputArtifact.object.data];
        }
        if (!(inputArtifact.object.data instanceof Array))
            return (0, rxjs_1.of)([]);
        return (0, rxjs_1.from)(inputArtifact.object.data)
            .pipe((0, operators_1.map)(function (item, index) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            artifact.object = item;
            return artifact;
        }), (0, operators_1.toArray)())
            .pipe((0, operators_1.map)(function (items) {
            var _a, _b, _c;
            items.___async = ((_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.async) == true || ((_b = inputArtifact.object.config) === null || _b === void 0 ? void 0 : _b.async) == undefined;
            items.___batch = (_c = inputArtifact.object.config) === null || _c === void 0 ? void 0 : _c.batch;
            items.forEach(function (artifact, index) {
                if (artifact.object && !(typeof artifact.object == 'string') && !(typeof artifact.object == 'number') && !(typeof artifact.object == 'boolean'))
                    artifact.object.__index = index;
            });
            return items;
        }));
    };
    FlowHook.prototype.stop = function (inputArtifact) {
        var currentFlow = this.context.getData('flowContext');
        var parentFlow = currentFlow.parentFlow;
        parentFlow.stop(inputArtifact.object.config.pieceId, inputArtifact.object.__flowContext.currentPiece, inputArtifact.object.__flowContext.pieceId);
        currentFlow.endOn = this.context.getData('flowContext').pieceId;
        currentFlow.status = 3;
        currentFlow.end$.next(inputArtifact);
        currentFlow.end$.complete();
        return (0, rxjs_1.of)([]);
    };
    FlowHook.prototype.group = function (inputArtifact) {
        var _this = this;
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.map)(function () {
            var currentFlow = _this.context.getData('flowContext');
            var parentFlow = currentFlow.parentFlow;
            if (parentFlow && parentFlow.status != 2 && parentFlow.status == 1) {
                parentFlow.status = 2;
                parentFlow.continue(inputArtifact.object.config.pieceId, inputArtifact.object.__flowContext.currentPiece, inputArtifact.object.__flowContext.pieceId, inputArtifact.object.config);
            }
            currentFlow.endOn = _this.context.getData('flowContext').pieceId;
            currentFlow.status = 3;
            currentFlow.end$.next(inputArtifact);
            currentFlow.end$.complete();
            return [];
        }));
    };
    FlowHook.prototype.waitForOutputs = function (inputArtifact) {
        var currentFlow = this.context.getData('flowContext');
        if (!currentFlow.__doWaitPieces)
            currentFlow.__doWaitPieces = new Map();
        inputArtifact.object.timeout = inputArtifact.object.timeout ? inputArtifact.object.timeout : 28000;
        var waitOutputs = inputArtifact.object.outputs
            ? inputArtifact.object.outputs
            : currentFlow.piecesTo.get(inputArtifact.object.__flowContext.inputId);
        var allExecuted = function () {
            return waitOutputs.every(function (outputId) {
                return currentFlow.status == 3 || currentFlow.outputs.has(outputId);
            });
        };
        var timeout$ = (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.delay)(inputArtifact.object.timeout))
            .pipe((0, operators_1.concatMap)(function () {
            // if (!allExecuted()) {
            //     currentFlow.__doWaitPieces.set(inputArtifact.object.__flowContext.inputId, true);
            //     throw new Error('Wait Piece timeout');
            // }
            if (currentFlow.status == 3)
                return rxjs_1.EMPTY;
            if (!currentFlow.__doWaitPieces.has(inputArtifact.object.__flowContext.inputId)) {
                currentFlow.__doWaitPieces.set(inputArtifact.object.__flowContext.inputId, true);
                throw new Error('Wait Piece timeout');
            }
            return rxjs_1.EMPTY;
        }));
        if (!allExecuted())
            return timeout$;
        if (currentFlow.__doWaitPieces.has(inputArtifact.object.__flowContext.inputId))
            return rxjs_1.EMPTY;
        if (currentFlow.status == 3)
            return rxjs_1.EMPTY;
        currentFlow.__doWaitPieces.set(inputArtifact.object.__flowContext.inputId, true);
        var artifact = new nick_process_commons_1.NickProcessArtfact();
        artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        artifact.object = {
            pieces: waitOutputs
        };
        return (0, rxjs_1.of)(artifact);
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('ce1d71eb-7e4d-4987-af71-b482ef56b6ae')
    ], FlowHook.prototype, "execute", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('a98a4ca4-d94d-4378-8d52-8f6433fdec9f')
    ], FlowHook.prototype, "forEach", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('f43af2a5-8b98-4261-b579-6f03bd430400')
    ], FlowHook.prototype, "stop", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('e6219329-5d08-42cb-80fa-0293dafb09a6')
    ], FlowHook.prototype, "group", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('2eff1ad2-4810-48bb-bae1-c1d194fa8013')
    ], FlowHook.prototype, "waitForOutputs", null);
    FlowHook = __decorate([
        (0, nick_process_commons_1.HookClass)('flow')
    ], FlowHook);
    return FlowHook;
}(nick_process_commons_1.BaseHook));
exports.FlowHook = FlowHook;
//# sourceMappingURL=flow.hook.js.map