"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GeoHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var operators_1 = require("rxjs/operators");
var GeoHook = /** @class */ (function (_super) {
    __extends(GeoHook, _super);
    function GeoHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    GeoHook.prototype.findGeoLocation = function (inputArtifact) {
        return this.service('ModelDbXrefGeoService')
            .pipe((0, operators_1.concatMap)(function (service) {
            var modelQueryId = inputArtifact.object.modelQueryId;
            var lat = [inputArtifact.object.config.startLat, inputArtifact.object.config.endLat];
            var long = [inputArtifact.object.config.startLong, inputArtifact.object.config.endLong];
            var radius = inputArtifact.object.config.radius;
            var search = new nick_data_commons_1.Search(inputArtifact.object.data, '$and');
            return service.findNearbyArrayByQuery(modelQueryId, lat, long, radius, search);
        })).pipe((0, operators_1.map)(function (entities) {
            inputArtifact.object.data = entities.map(function (entity) { return entity && entity.toJSON ? entity.toJSON() : entity; });
            return inputArtifact;
        }));
    };
    GeoHook.prototype.nearbyByQuery = function (inputArtifact) {
        return this.service('ModelDbXrefGeoService')
            .pipe((0, operators_1.concatMap)(function (service) {
            var modelQueryId = inputArtifact.object.modelQueryId;
            var lat = inputArtifact.object.config.lat;
            var long = inputArtifact.object.config.long;
            var distance = inputArtifact.object.config.distance;
            var search = new nick_data_commons_1.Search(inputArtifact.object.data, '$and');
            return service.findNearbyByQuery(modelQueryId, lat, long, distance, search);
        })).pipe((0, operators_1.map)(function (entities) {
            inputArtifact.object.data = entities.map(function (entity) { return entity && entity.toJSON ? entity.toJSON() : entity; });
            return inputArtifact;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('659dfcab-fe3e-4e49-ba22-a208d3f9680b')
    ], GeoHook.prototype, "findGeoLocation", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('e3bc7219-5dcc-48db-807c-1c9fa0c7343c')
    ], GeoHook.prototype, "nearbyByQuery", null);
    GeoHook = __decorate([
        (0, nick_process_commons_1.HookClass)('geo')
    ], GeoHook);
    return GeoHook;
}(nick_process_commons_1.BaseHook));
exports.GeoHook = GeoHook;
//# sourceMappingURL=geo.hook.js.map