"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GoogleHook = void 0;
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var GoogleHook = /** @class */ (function (_super) {
    __extends(GoogleHook, _super);
    function GoogleHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    GoogleHook.prototype.getStepsFromDirectionsResponse = function (inputArtifact) {
        var response = inputArtifact.object.data.input;
        return (0, rxjs_1.of)(response)
            .pipe((0, operators_1.concatMap)(function (response) {
            if (!response ||
                !response.object ||
                !response.object.routes ||
                response.object.routes.length == 0 ||
                !response.object.routes[0].legs ||
                !response.object.routes[0].legs[0].steps ||
                response.object.routes[0].legs[0].steps.length == 0) {
                var resultArtifact = new nick_process_commons_1.NickProcessArtfact();
                resultArtifact.kind = nick_data_commons_1.ArtfactKind.ERROR;
                return (0, rxjs_1.of)(resultArtifact);
            }
            var steps = response.object.routes[0].legs[0].steps;
            return (0, rxjs_1.from)(steps)
                // cria um entity para cada elemento do response da API
                .pipe((0, operators_1.map)(function (step) {
                var model = new nick_data_commons_1.Entity();
                if (inputArtifact.object.data.parentField) {
                    model[inputArtifact.object.data.parentField] = inputArtifact.object.data.parentValue;
                }
                model[inputArtifact.object.data.startLocationField] = {
                    type: 'Point',
                    coordinates: [step.start_location.lat, step.start_location.lng]
                };
                model[inputArtifact.object.data.endLocationField] = {
                    type: 'Point',
                    coordinates: [step.end_location.lat, step.end_location.lng]
                };
                model[inputArtifact.object.data.distanceField] = step.distance.value;
                model[inputArtifact.object.data.durationField] = step.duration.value;
                return model;
            }), (0, operators_1.toArray)())
                .pipe((0, operators_1.concatMap)(function (entities) {
                var artfact = Object.create(nick_process_commons_1.NickProcessArtfact.prototype);
                artfact.kind = nick_data_commons_1.ArtfactKind.ARRAY;
                artfact.object = entities;
                return (0, rxjs_1.of)(artfact);
            }));
        }));
    };
    GoogleHook.prototype.formatAddressComponents = function (inputArtifact) {
        var data = inputArtifact.object.data;
        var addressComponents = data.addressComponents;
        var geometry = data.geometry;
        var addressNumber;
        var address1;
        var address = {
            address_1: '',
            address_2: '',
            zipcode: '',
            city: '',
            state: '',
            country: '',
            point: {}
        };
        for (var i = 0; i < addressComponents.length; i++) {
            var addressComponent = addressComponents[i];
            for (var j = 0; j < addressComponent.types.length; j++) {
                var type = addressComponent.types[j];
                if (type == 'street_number')
                    addressNumber = addressComponent.long_name;
                else if (type == 'route')
                    address1 = addressComponent.long_name;
                else if (type == 'sublocality_level_1')
                    address.address_2 = addressComponent.long_name;
                else if (type == 'postal_code')
                    address.zipcode = addressComponent.long_name;
                else if (type == 'administrative_area_level_2')
                    address.city = addressComponent.long_name;
                else if (type == 'administrative_area_level_1')
                    address.state = addressComponent.long_name;
                else if (type == 'country')
                    address.country = addressComponent.long_name;
            }
        }
        if (addressNumber && address1)
            address1 += ", ".concat(addressNumber);
        address.address_1 = address1;
        if (geometry && geometry.location && geometry.location.lat && geometry.location.lng) {
            address.point = {
                type: 'Point',
                coordinates: [geometry.location.lat, geometry.location.lng]
            };
        }
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = address;
        return (0, rxjs_1.of)(outputArtifact);
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('22e86284-cb6f-4621-a35e-ec444296edb1')
    ], GoogleHook.prototype, "getStepsFromDirectionsResponse", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('3b4d0ab5-51ad-4d11-bc52-9487b8dbdcdc')
    ], GoogleHook.prototype, "formatAddressComponents", null);
    GoogleHook = __decorate([
        (0, nick_process_commons_1.HookClass)('google')
    ], GoogleHook);
    return GoogleHook;
}(nick_process_commons_1.BaseHook));
exports.GoogleHook = GoogleHook;
//# sourceMappingURL=google.hook.js.map