"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var https_1 = __importDefault(require("https"));
var moment_1 = __importDefault(require("moment"));
// @ts-ignore
var request = __importStar(require("request"));
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var fs_1 = __importDefault(require("fs"));
var uuid_1 = require("uuid");
var HttpHook = /** @class */ (function (_super) {
    __extends(HttpHook, _super);
    function HttpHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HttpHook.prototype.get = function (inputArtifact) {
        var _this = this;
        var options = {
            url: "".concat(inputArtifact.object.config.url),
            headers: {}
        };
        return this.system.pipe((0, operators_1.concatMap)(function (system) {
            options.headers['nick-system'] = system.id;
            options.headers['authorization'] = _this.token;
            return _this._get(options, inputArtifact);
        }));
    };
    HttpHook.prototype.postExternal = function (inputArtifact) {
        var _a, _b, _c, _d, _e;
        var options = {
            url: "".concat(inputArtifact.object.config.url),
            headers: inputArtifact.object.config.headers ? inputArtifact.object.config.headers : {}
        };
        options.url = this.buildRoute(inputArtifact.object.config.url, inputArtifact.object.config.params);
        options.headers = this.buildAuthorization(inputArtifact.object.config.headers);
        options.rejectUnauthorized = (_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.rejectUnauthorized;
        options.requestCert = (_b = inputArtifact.object.config) === null || _b === void 0 ? void 0 : _b.requestCert;
        if (options.headers && options.headers['Content-Type'] == 'x-www-form-urlencoded') {
            options.form = inputArtifact.object.config.body;
            options.headers['Content-Type'] = 'application/x-www-form-urlencoded';
            options.method = 'POST';
        }
        else if (options.headers && options.headers['Content-Type'] == 'multipart/form-data') {
            options.formData = inputArtifact.object.config.body;
            options.formData[inputArtifact.object.config.fileKey] = {
                value: fs_1.default.createReadStream(inputArtifact.object.config.body[inputArtifact.object.config.fileKey].File.path),
                options: {
                    filename: inputArtifact.object.config.body[inputArtifact.object.config.fileKey].File.name,
                    contentType: inputArtifact.object.config.body[inputArtifact.object.config.fileKey].File.type
                }
            };
            options.method = 'POST';
        }
        else if (inputArtifact.object.config.body) {
            options.body = inputArtifact.object.config.body;
            options.json = (inputArtifact.object.config && inputArtifact.object.config.hasOwnProperty('json')) ? inputArtifact.object.config.json : true;
        }
        options.isDownload = (_c = inputArtifact.object.config) === null || _c === void 0 ? void 0 : _c.isDownload;
        options.gzip = (_d = inputArtifact.object.config) === null || _d === void 0 ? void 0 : _d.gzip;
        options.timeout = (_e = inputArtifact.object.config) === null || _e === void 0 ? void 0 : _e.timeout;
        return new rxjs_1.Observable(function (observer) {
            if (options.isDownload) {
                options.rejectUnauthorized = false;
                options.method = 'POST';
                var fileName_1 = "/tmp/".concat((0, uuid_1.v4)());
                var outputArtifact_1 = new nick_process_commons_1.NickProcessArtfact();
                request.post(options.url, options)
                    .on('error', function (err) {
                    observer.error(err);
                    observer.complete();
                })
                    .on('end', function (err) {
                    outputArtifact_1.object = fs_1.default.createReadStream(fileName_1);
                    observer.next(outputArtifact_1);
                    observer.complete();
                })
                    .pipe(fs_1.default.createWriteStream(fileName_1));
                return;
            }
            request.post(options, (function (error, response, body) {
                if (error) {
                    observer.error(error);
                    observer.complete();
                }
                else {
                    var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
                    if (body instanceof Object) {
                        outputArtifact.object = body;
                    }
                    else {
                        try {
                            outputArtifact.object = JSON.parse(body);
                        }
                        catch (e) {
                            outputArtifact.object = body;
                        }
                    }
                    if (inputArtifact.object.config.statusError instanceof Array && inputArtifact.object.config.statusError.indexOf(response.statusCode) >= 0) {
                        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ERROR;
                        outputArtifact.object = {
                            message: outputArtifact.object,
                            statusCode: response.statusCode,
                            statusMessage: response.statusMessage
                        };
                        observer.error(outputArtifact);
                    }
                    else {
                        if (response.statusCode >= 200 && response.statusCode <= 409)
                            observer.next(outputArtifact);
                        else {
                            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ERROR;
                            observer.error(outputArtifact);
                        }
                    }
                    observer.complete();
                }
            }));
        });
    };
    HttpHook.prototype.getExternal = function (inputArtifact) {
        var _a, _b, _c, _d, _e;
        var options = {
            url: "".concat(inputArtifact.object.config.url),
            headers: inputArtifact.object.config.headers ? inputArtifact.object.config.headers : {}
        };
        options.url = this.buildRoute(inputArtifact.object.config.url, inputArtifact.object.config.params);
        options.headers = this.buildAuthorization(inputArtifact.object.config.headers);
        options.gzip = (_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.gzip;
        options.encoding = (_b = inputArtifact.object.config) === null || _b === void 0 ? void 0 : _b.encoding;
        options.isDownload = (_c = inputArtifact.object.config) === null || _c === void 0 ? void 0 : _c.isDownload;
        options.rejectUnauthorized = (_d = inputArtifact.object.config) === null || _d === void 0 ? void 0 : _d.rejectUnauthorized;
        options.requestCert = (_e = inputArtifact.object.config) === null || _e === void 0 ? void 0 : _e.requestCert;
        return this._get(options, inputArtifact);
    };
    HttpHook.prototype.deleteExternal = function (inputArtifact) {
        var _a, _b, _c, _d;
        var options = {
            url: "".concat(inputArtifact.object.config.url),
            headers: inputArtifact.object.config.headers ? inputArtifact.object.config.headers : {}
        };
        options.url = this.buildRoute(inputArtifact.object.config.url, inputArtifact.object.config.params);
        options.headers = this.buildAuthorization(inputArtifact.object.config.headers);
        options.gzip = (_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.gzip;
        options.encoding = (_b = inputArtifact.object.config) === null || _b === void 0 ? void 0 : _b.encoding;
        options.rejectUnauthorized = (_c = inputArtifact.object.config) === null || _c === void 0 ? void 0 : _c.rejectUnauthorized;
        options.requestCert = (_d = inputArtifact.object.config) === null || _d === void 0 ? void 0 : _d.requestCert;
        return new rxjs_1.Observable(function (observer) {
            request.delete(options, (function (error, response, body) {
                if (error) {
                    observer.error(error);
                    observer.complete();
                }
                else {
                    if (body instanceof Object) {
                        inputArtifact.object = body;
                    }
                    else {
                        try {
                            inputArtifact.object = JSON.parse(body);
                        }
                        catch (e) {
                            inputArtifact.object = body;
                        }
                    }
                    observer.next(inputArtifact);
                    observer.complete();
                }
            }));
        });
    };
    HttpHook.prototype.patchExternal = function (inputArtifact) {
        var _a, _b;
        var options = {
            url: "".concat(inputArtifact.object.config.url),
            headers: inputArtifact.object.config.headers ? inputArtifact.object.config.headers : {}
        };
        options.url = this.buildRoute(inputArtifact.object.config.url, inputArtifact.object.config.params);
        options.headers = this.buildAuthorization(inputArtifact.object.config.headers);
        options.rejectUnauthorized = (_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.rejectUnauthorized;
        options.requestCert = (_b = inputArtifact.object.config) === null || _b === void 0 ? void 0 : _b.requestCert;
        if (options.headers && options.headers['Content-Type'] == 'x-www-form-urlencoded') {
            options.form = inputArtifact.object.config.body;
            options.headers['Content-Type'] = 'application/x-www-form-urlencoded';
            options.method = 'PATCH'; // Método PATCH
        }
        else if (inputArtifact.object.config.body) {
            options.body = inputArtifact.object.config.body;
            options.json = true;
            options.method = 'PATCH'; // Método PATCH
        }
        return new rxjs_1.Observable(function (observer) {
            request.patch(options, (function (error, response, body) {
                if (error) {
                    observer.error(error);
                    observer.complete();
                }
                else {
                    if (body instanceof Object) {
                        inputArtifact.object = body;
                    }
                    else {
                        try {
                            inputArtifact.object = JSON.parse(body);
                        }
                        catch (e) {
                            inputArtifact.object = body;
                        }
                    }
                    if (response.statusCode >= 200 && response.statusCode <= 409)
                        observer.next(inputArtifact);
                    else {
                        inputArtifact.kind = nick_data_commons_1.ArtfactKind.ERROR;
                        observer.error(inputArtifact);
                    }
                    observer.complete();
                }
            }));
        });
    };
    HttpHook.prototype.putExternal = function (inputArtifact) {
        var _a, _b;
        var options = {
            url: "".concat(inputArtifact.object.config.url),
            headers: inputArtifact.object.config.headers ? inputArtifact.object.config.headers : {}
        };
        options.url = this.buildRoute(inputArtifact.object.config.url, inputArtifact.object.config.params);
        options.headers = this.buildAuthorization(inputArtifact.object.config.headers);
        options.rejectUnauthorized = (_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.rejectUnauthorized;
        options.requestCert = (_b = inputArtifact.object.config) === null || _b === void 0 ? void 0 : _b.requestCert;
        if (options.headers && options.headers['Content-Type'] == 'x-www-form-urlencoded') {
            options.form = inputArtifact.object.config.body;
            options.headers['Content-Type'] = 'application/x-www-form-urlencoded';
            options.method = 'PUT';
        }
        else if (options.headers && options.headers['Content-Type'] == 'multipart/form-data') {
            options.formData = inputArtifact.object.config.body;
            options.formData[inputArtifact.object.config.fileKey] = {
                value: fs_1.default.createReadStream(inputArtifact.object.config.body[inputArtifact.object.config.fileKey].File.path),
                options: {
                    filename: inputArtifact.object.config.body[inputArtifact.object.config.fileKey].File.name,
                    contentType: inputArtifact.object.config.body[inputArtifact.object.config.fileKey].File.type
                }
            };
            options.method = 'PUT';
        }
        else if (inputArtifact.object.config.body) {
            options.body = inputArtifact.object.config.body;
            options.json = true;
        }
        return new rxjs_1.Observable(function (observer) {
            request.put(options, (function (error, response, body) {
                if (error) {
                    observer.error(error);
                    observer.complete();
                }
                else {
                    if (body instanceof Object) {
                        inputArtifact.object = body;
                    }
                    else {
                        try {
                            inputArtifact.object = JSON.parse(body);
                        }
                        catch (e) {
                            inputArtifact.object = body;
                        }
                    }
                    // inputArtifact.object.response = {
                    //     status: response.statusCode,
                    //     statusMessage: response.statusMessage,
                    //     headers: response.headers
                    // }
                    if (response.statusCode >= 200 && response.statusCode <= 409)
                        observer.next(inputArtifact);
                    else {
                        inputArtifact.kind = nick_data_commons_1.ArtfactKind.ERROR;
                        observer.error(inputArtifact);
                    }
                    observer.complete();
                }
            }));
        });
    };
    HttpHook.prototype.buildAuthorization = function (headers) {
        if (headers && (headers.hasOwnProperty('Authorization') || headers.hasOwnProperty('authorization'))) {
            var authorization = headers['Authorization'] || headers['authorization'];
            if (authorization && typeof authorization != 'string') {
                switch (authorization.type) {
                    case 'basic': {
                        var authHeader = Buffer.from("".concat(authorization.username, ":").concat(authorization.password)).toString('base64');
                        delete headers['Authorization'];
                        delete headers['authorization'];
                        headers['authorization'] = "Basic ".concat(authHeader);
                        break;
                    }
                    case 'bearer': {
                        delete headers['Authorization'];
                        delete headers['authorization'];
                        headers['authorization'] = "Bearer ".concat(authorization.token);
                        break;
                    }
                }
            }
        }
        return headers;
    };
    HttpHook.prototype.buildRoute = function (url, params) {
        var _url = new URL('https://dummy');
        if (params) {
            Object.keys(params).forEach(function (key) {
                if (url.indexOf("{{".concat(key, "}}")) > -1) {
                    url = url.replace("{{".concat(key, "}}"), params[key]);
                }
                else {
                    if (params[key] !== undefined && params[key] != null) {
                        var value_1 = params[key];
                        if (!(value_1 instanceof Array) && value_1 instanceof Object && Object.keys(value_1).length) {
                            Object.keys(value_1).forEach(function (insideKey) {
                                if (value_1[insideKey] !== undefined) {
                                    // todo: deal all properties, not only array...
                                    var skipAppend_1 = false;
                                    if (value_1[insideKey] instanceof Array) {
                                        value_1[insideKey] = value_1[insideKey].map(function (value) {
                                            if (value instanceof Date)
                                                return (0, moment_1.default)(value).parseZone().format();
                                            if (!isNaN(value))
                                                return value;
                                            if (typeof value === 'string')
                                                return value;
                                            if (value instanceof Object) {
                                                skipAppend_1 = true;
                                                _url.searchParams.append(insideKey, JSON.stringify(value));
                                            }
                                            return value;
                                        });
                                    }
                                    else if (value_1[insideKey] instanceof Object) {
                                        value_1[insideKey] = JSON.stringify(value_1[insideKey]);
                                    }
                                    if (!skipAppend_1)
                                        _url.searchParams.append(insideKey, value_1[insideKey]);
                                }
                            });
                        }
                        else {
                            _url.searchParams.append(key, params[key]);
                        }
                    }
                }
            });
        }
        var finalUrl = new URL(url);
        _url.searchParams.forEach(function (value, key) { return finalUrl.searchParams.append(key, value); });
        return finalUrl;
    };
    HttpHook.prototype._get = function (options, inputArtifact) {
        if (options.isDownload) {
            options.rejectUnauthorized = false;
        }
        return new rxjs_1.Observable(function (observer) {
            if (options.isDownload) {
                https_1.default.get(options.url, options, function (response) {
                    var chunks = [];
                    response.on('data', function (chunk) {
                        chunks.push(chunk);
                    });
                    response.on('end', function () {
                        inputArtifact.object = Buffer.concat(chunks);
                        observer.next(inputArtifact);
                        observer.complete();
                    });
                });
            }
            else {
                request.get(options, (function (error, response, body) {
                    if (error) {
                        observer.error(error);
                        observer.complete();
                    }
                    else {
                        if (body instanceof Object) {
                            inputArtifact.object = body;
                        }
                        else {
                            try {
                                inputArtifact.object = JSON.parse(body);
                            }
                            catch (e) {
                                inputArtifact.object = body;
                            }
                        }
                        observer.next(inputArtifact);
                        observer.complete();
                    }
                }));
            }
        });
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('73466be1-da61-4a4c-ae5f-1099ef021b85')
    ], HttpHook.prototype, "get", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('a575d026-2d3d-4cd8-aac3-9fbea1e4c45b')
    ], HttpHook.prototype, "postExternal", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('203842d9-28e3-4d6c-b808-5b2d31a17cf4')
    ], HttpHook.prototype, "getExternal", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('ebc78ebf-2523-4777-b4f0-e6112cd9e5a2')
    ], HttpHook.prototype, "deleteExternal", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('85be39b2-788c-48fe-9cea-e96b1753c1c0')
    ], HttpHook.prototype, "patchExternal", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('f1e75d44-c8ed-4695-aec1-1d41a888316e')
    ], HttpHook.prototype, "putExternal", null);
    HttpHook = __decorate([
        (0, nick_process_commons_1.HookClass)('http')
    ], HttpHook);
    return HttpHook;
}(nick_process_commons_1.BaseHook));
exports.HttpHook = HttpHook;
//# sourceMappingURL=http.hook.js.map