"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImageHook = void 0;
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var node_fs_1 = require("node:fs");
var operators_1 = require("rxjs/operators");
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var jimp_1 = __importDefault(require("jimp"));
var ImageHook = /** @class */ (function (_super) {
    __extends(ImageHook, _super);
    function ImageHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ImageHook.prototype.resize = function (inputArtifact) {
        var file = inputArtifact.object.buffer;
        var cachedJpegDecoder = jimp_1.default.decoders['image/jpeg'];
        jimp_1.default.decoders['image/jpeg'] = function (data) {
            var userOpts = { maxMemoryUsageInMB: 1024, maxResolutionInMP: 200 };
            return cachedJpegDecoder(data, userOpts);
        };
        return (0, rxjs_1.from)(inputArtifact.object.config.resize)
            .pipe((0, operators_1.concatMap)(function (size) {
            var width = size[0];
            var height = size[1];
            return (0, rxjs_1.from)(jimp_1.default.read(file.path))
                .pipe((0, operators_1.concatMap)(function (image) {
                return new rxjs_1.Observable(function (observer) {
                    image.resize(width, height).write("".concat(file.path, "@").concat(width, "x").concat(height), function (param) {
                        observer.next(param);
                        observer.complete();
                    });
                })
                    .pipe((0, operators_1.map)(function () {
                    var fileStream = (0, node_fs_1.createReadStream)("".concat(file.path, "@").concat(width, "x").concat(height));
                    return {
                        id: "".concat(inputArtifact.object.id, "@").concat(width, "x").concat(height),
                        buffer: fileStream,
                        contentType: inputArtifact.object.contentType,
                        dimension: "".concat(width, "x").concat(height)
                    };
                }));
            }));
        }), (0, operators_1.toArray)())
            .pipe((0, operators_1.map)(function (images) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = images.map(function (image) { return image && image.toJson ? image.toJson : image; });
            return outputArtifact;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('5442f5b4-3964-48e5-95c0-1c17963fb336')
    ], ImageHook.prototype, "resize", null);
    ImageHook = __decorate([
        (0, nick_process_commons_1.HookClass)('image')
    ], ImageHook);
    return ImageHook;
}(nick_process_commons_1.BaseHook));
exports.ImageHook = ImageHook;
//# sourceMappingURL=image.hook.js.map