"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.JSDomHook = void 0;
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var htmlparser2_1 = require("htmlparser2");
var domutils = __importStar(require("domutils"));
var uuid_1 = require("uuid");
var JSDomHook = /** @class */ (function (_super) {
    __extends(JSDomHook, _super);
    function JSDomHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    JSDomHook.prototype.parse = function (inputArtifact) {
        var $ = (0, htmlparser2_1.parseDocument)(Buffer.from(inputArtifact.object.data, 'utf-8').toString());
        var resultArtifact = new nick_process_commons_1.NickProcessArtfact();
        resultArtifact.object =
            {
                data: $,
                __ignoreParser: { data: true }
            };
        return (0, rxjs_1.of)(resultArtifact);
    };
    JSDomHook.prototype.search = function (inputArtifact) {
        var resultArtifact = new nick_process_commons_1.NickProcessArtfact();
        resultArtifact.object = domutils.getElementsByTagName((function (name) { return ['h1', 'h2', 'p'].indexOf(name) >= 0; }), inputArtifact.object.data);
        resultArtifact.object.forEach(function (e) {
            Object.defineProperty(e, 'innerText', {
                get: function () {
                    return domutils.textContent(e).trim();
                }
            });
        });
        resultArtifact.object = resultArtifact.object.map(function (e) {
            return { innerText: domutils.textContent(e).trim() };
        });
        // resultArtifact.object = resultArtifact.object.splice(1, 5000);
        return (0, rxjs_1.of)(resultArtifact);
    };
    JSDomHook.prototype.lawParse = function (inputArtifact) {
        var testTitle = function (el) {
            if (!el.closest('h1'))
                return false;
            var str = el.innerText;
            if (!str || !str.length)
                return false;
            str = str.trim();
            return /^(TÍTULO )(I|V|X|L|C|D|M)+$/.test(str);
        };
        var isArt = function (el) {
            if (!el.closest('p'))
                return false;
            var str = el.innerText;
            if (!str || !str.length)
                return false;
            str = str.trim();
            return /^(Art. )([0-9])+/.test(str);
        };
        var isCharpter = function (el) {
            if (!el.closest('h2'))
                return false;
            var str = el.innerText;
            if (!str || !str.length)
                return false;
            str = str.trim();
            return /^(CAPÍTULO )(I|V|X|L|C|D|M|ÚNICO)+$/.test(str);
        };
        var isSection = function (el) {
            if (!el.closest('h3') && !el.closest('p'))
                return false;
            var str = el.innerText;
            if (!str || !str.length)
                return false;
            str = str.trim();
            return /^(Seção )(I|V|X|L|C|D|M)+$/.test(str);
        };
        var isInciso = function (el) {
            if (!el.closest('p'))
                return false;
            var str = el.innerText;
            if (!str || !str.length)
                return false;
            str = str.trim();
            return /^(I|V|X|L|C|D|M)+ (–|-|)/.test(str) || /^(I|V|X|L|C|D|M)+(–|-|)/.test(str);
        };
        var isParagraph = function (el) {
            if (!el.closest('p'))
                return false;
            var str = el.innerText;
            if (!str || !str.length)
                return false;
            str = str.trim();
            return /^(§)(\s|)([0-9])(º|o)/.test(str) || /^(Parágrafo único.)/.test(str);
        };
        var isAlinea = function (el) {
            if (!el.closest('p'))
                return false;
            var str = el.innerText;
            if (!str || !str.length)
                return false;
            str = str.trim();
            return /^([a-z])(\))/.test(str);
        };
        var isItem = function (el) {
            if (!el.closest('p'))
                return false;
            var str = el.innerText;
            if (!str || !str.length)
                return false;
            str = str.trim();
            return /^([0-9])(\.)/.test(str);
        };
        var isPreviewRedaction = function (el) {
            if (!el.closest('p'))
                return false;
            var str = el.innerText;
            if (!str || !str.length)
                return false;
            return str.startsWith('Redação Anterior');
        };
        var trim = function (str) {
            if (!str || !str.length)
                return null;
            return str.replace('\r\n', ' ').replace('  ', ' ').replace(' ', ' ').replace('', ' ').trim();
        };
        var syncId = inputArtifact.object.syncId;
        var resultArtifact = new nick_process_commons_1.NickProcessArtfact();
        resultArtifact.object = domutils.getElementsByTagName((function (name) { return ['h1', 'h2', 'h3', 'p'].indexOf(name) >= 0; }), inputArtifact.object.data);
        resultArtifact.object.forEach(function (e) {
            Object.defineProperty(e, 'innerText', {
                get: function () {
                    return domutils.textContent(e).trim().replace('\r\n', ' ');
                }
            });
            e.closest = function (el) {
                var parent = e;
                do {
                    if ((parent === null || parent === void 0 ? void 0 : parent.name) == el)
                        return parent;
                    parent = parent.parent;
                } while (parent != null);
                return null;
            };
        });
        var laws = [];
        /*
         * 0: titúlo
         * 1: capítulo
         * 2: section
         * 3: article
         * 4: isParagraph
         * 5: inciso
         * 6: alinea
         * 7: item
         */
        var currentTitleId;
        var currentChapterId;
        var currentSectionId;
        var currentArtId;
        var currentParagraphId;
        var currentIncisoId;
        var currentAlineaId;
        var currentItemId;
        var currentTitleName = null;
        var currentCharpterName = null;
        var currentSectionName = null;
        var nextLineIsOldRedaction = null;
        var index = 0;
        resultArtifact.object.filter(function (a) {
            return a.innerText;
        })
            .forEach(function (el) {
            var value = el.innerText ? el.innerText.trim() : null;
            if (!value || !value.length)
                return;
            if (testTitle(el)) {
                currentTitleId = null;
                currentTitleName = null;
                currentChapterId = null;
                currentSectionId = null;
                currentArtId = null;
                currentParagraphId = null;
                currentIncisoId = null;
                currentAlineaId = null;
                currentTitleId = (0, uuid_1.v4)();
                laws.push({
                    id: currentTitleId,
                    kind: 0,
                    text: "".concat(el.innerText),
                    source: 0,
                    index: index,
                    syncId: syncId
                });
                index++;
            }
            else if (currentTitleId && !currentTitleName && el.closest('h1')) {
                currentTitleName = el.innerText;
                laws[laws.length - 1].text = "".concat(laws[laws.length - 1].text, " ").concat(el.innerText);
            }
            else if (currentTitleId && currentTitleName) {
                if (isCharpter(el)) {
                    // clear chapters
                    currentCharpterName = null;
                    nextLineIsOldRedaction = null;
                    currentSectionId = null;
                    currentArtId = null;
                    currentParagraphId = null;
                    currentIncisoId = null;
                    currentAlineaId = null;
                    currentItemId = null;
                    currentChapterId = (0, uuid_1.v4)();
                    laws.push({
                        id: currentChapterId,
                        kind: 1,
                        text: trim("".concat(el.innerText)),
                        parentId: currentTitleId,
                        source: 0,
                        index: index,
                        syncId: syncId
                    });
                    index++;
                }
                else if (currentChapterId && !currentCharpterName && el.closest('h2')) {
                    laws[laws.length - 1].text = "".concat(laws[laws.length - 1].text, " ").concat(el.innerText);
                }
                else if (isSection(el)) {
                    // clear chapters
                    currentSectionName = null;
                    nextLineIsOldRedaction = null;
                    currentArtId = null;
                    currentParagraphId = null;
                    currentIncisoId = null;
                    currentAlineaId = null;
                    currentItemId = null;
                    currentSectionId = (0, uuid_1.v4)();
                    laws.push({
                        id: currentSectionId,
                        kind: 2,
                        text: trim("".concat(el.innerText)),
                        parentId: currentChapterId,
                        source: 0,
                        index: index,
                        syncId: syncId
                    });
                    index++;
                }
                else if (currentSectionId && !currentSectionName && el.closest('h3')) {
                    currentSectionName = el.innerText;
                    laws[laws.length - 1].text = "".concat(laws[laws.length - 1].text, " ").concat(el.innerText);
                }
                else if (currentTitleId || currentChapterId || currentSectionId) {
                    if (isArt(el)) {
                        currentArtId = (0, uuid_1.v4)();
                        currentParagraphId = null;
                        currentIncisoId = null;
                        currentAlineaId = null;
                        currentItemId = null;
                        laws.push({
                            id: currentArtId,
                            parentId: currentSectionId ? currentSectionId : (currentChapterId ? currentChapterId : currentTitleId),
                            kind: nextLineIsOldRedaction ? 3.1 : 3,
                            text: trim("".concat(el.innerText)),
                            agregation: trim(nextLineIsOldRedaction),
                            source: 0,
                            index: index,
                            syncId: syncId
                        });
                        index++;
                        nextLineIsOldRedaction = null;
                    }
                    else if (isPreviewRedaction(el)) {
                        nextLineIsOldRedaction = el.innerText;
                    }
                    else if (isParagraph(el)) {
                        currentParagraphId = (0, uuid_1.v4)();
                        currentIncisoId = null;
                        currentAlineaId = null;
                        currentItemId = null;
                        laws.push({
                            id: currentParagraphId,
                            parentId: currentArtId,
                            kind: nextLineIsOldRedaction ? 4.1 : 4,
                            text: trim("".concat(el.innerText)),
                            agregation: trim(nextLineIsOldRedaction),
                            source: 0,
                            index: index,
                            syncId: syncId
                        });
                        index++;
                        nextLineIsOldRedaction = null;
                    }
                    else if (isInciso(el)) {
                        currentIncisoId = (0, uuid_1.v4)();
                        currentAlineaId = null;
                        currentItemId = null;
                        laws.push({
                            id: currentIncisoId,
                            parentId: currentParagraphId ? currentParagraphId : currentArtId,
                            kind: nextLineIsOldRedaction ? 5.1 : 5,
                            text: trim("".concat(el.innerText)),
                            agregation: trim(nextLineIsOldRedaction),
                            source: 0,
                            index: index,
                            syncId: syncId
                        });
                        index++;
                        nextLineIsOldRedaction = null;
                    }
                    else if (isAlinea(el)) {
                        currentAlineaId = (0, uuid_1.v4)();
                        currentItemId = null;
                        laws.push({
                            id: currentAlineaId,
                            parentId: currentIncisoId,
                            kind: nextLineIsOldRedaction ? 6.1 : 6,
                            text: trim("".concat(el.innerText)),
                            agregation: trim(nextLineIsOldRedaction),
                            source: 0,
                            index: index,
                            syncId: syncId
                        });
                        index++;
                        nextLineIsOldRedaction = null;
                    }
                    else if (isItem(el)) {
                        currentItemId = (0, uuid_1.v4)();
                        laws.push({
                            id: currentItemId,
                            parentId: currentAlineaId,
                            kind: nextLineIsOldRedaction ? 7.1 : 7,
                            text: trim("".concat(el.innerText)),
                            agregation: trim(nextLineIsOldRedaction),
                            source: 0,
                            index: index,
                            syncId: syncId
                        });
                        index++;
                        nextLineIsOldRedaction = null;
                    }
                }
            }
        });
        // melhorar: contribuinte deverá manter pelo | redação anterior ficou errada
        resultArtifact.object = laws;
        return (0, rxjs_1.of)(resultArtifact);
    };
    JSDomHook.prototype.decreeParse = function (inputArtifact) {
        var isDecreeNumber = function (el) {
            var str = el.innerText;
            if (!str || !str.length)
                return false;
            str = str.trim();
            return /^(([0-9]|\.|[0-9])+), de ([0-9]+(\.[0-9]+)+)$/.test(str.split('      ')[0]);
        };
        var trim = function (str) {
            if (!str || !str.length)
                return null;
            return str.replace('\r\n', ' ').replace('  ', ' ').replace(' ', ' ').replace('', ' ').trim();
        };
        var syncId = inputArtifact.object.syncId;
        var resultArtifact = new nick_process_commons_1.NickProcessArtfact();
        resultArtifact.object = domutils.getElementsByTagName((function (name) { return ['td'].indexOf(name) >= 0; }), inputArtifact.object.data);
        resultArtifact.object.forEach(function (e) {
            Object.defineProperty(e, 'innerText', {
                get: function () {
                    return domutils.textContent(e).trim().replace('\r\n', ' ');
                }
            });
            e.closest = function (el) {
                var parent = e;
                do {
                    if ((parent === null || parent === void 0 ? void 0 : parent.name) == el)
                        return parent;
                    parent = parent.parent;
                } while (parent != null);
                return null;
            };
        });
        var laws = [];
        /*
         * 0: titúlo
         * 1: capítulo
         * 2: section
         * 3: article
         * 4: isParagraph
         * 5: inciso
         * 6: alinea
         * 7: item
         */
        var currentNumber = null;
        var currentLink = null;
        var index = 0;
        resultArtifact.object.filter(function (a) {
            return a.innerText;
        })
            .forEach(function (el) {
            var value = el.innerText ? el.innerText.trim() : null;
            if (!value || !value.length)
                return;
            if (!currentNumber && isDecreeNumber(el)) {
                currentNumber = el.innerText;
            }
            else if (currentNumber) {
                laws.push({
                    agregation: trim(currentNumber),
                    text: trim(el.innerText),
                    index: index,
                    source: 1,
                    syncId: syncId
                });
                index++;
                currentNumber = null;
            }
        });
        resultArtifact.object = laws;
        return (0, rxjs_1.of)(resultArtifact);
    };
    JSDomHook.prototype.ordinanceYearParse = function (inputArtifact) {
        var isYearNumber = function (el) {
            var str = el.innerText;
            if (!str || !str.length)
                return false;
            str = str.trim();
            return /^([0-9][0-9][0-9][0-9])$/.test(str);
        };
        var resultArtifact = new nick_process_commons_1.NickProcessArtfact();
        resultArtifact.object = domutils.getElementsByTagName((function (name) { return ['td'].indexOf(name) >= 0; }), inputArtifact.object.data);
        resultArtifact.object.forEach(function (e) {
            Object.defineProperty(e, 'innerText', {
                get: function () {
                    return domutils.textContent(e).trim().replace('\r\n', ' ');
                }
            });
            e.closest = function (el) {
                var parent = e;
                do {
                    if ((parent === null || parent === void 0 ? void 0 : parent.name) == el)
                        return parent;
                    parent = parent.parent;
                } while (parent != null);
                return null;
            };
        });
        var laws = [];
        /*
         * 0: titúlo
         * 1: capítulo
         * 2: section
         * 3: article
         * 4: isParagraph
         * 5: inciso
         * 6: alinea
         * 7: item
         */
        var currentNumber = null;
        var currentLink = null;
        resultArtifact.object.filter(function (a) {
            return a.innerText;
        })
            .forEach(function (el) {
            var value = el.innerText ? el.innerText.trim() : null;
            if (!value || !value.length)
                return;
            if (isYearNumber(el)) {
                currentNumber = el.innerText;
                currentLink = el.children[0].attributes[0].value;
                if (currentLink.endsWith('.htm'))
                    laws.push({
                        link: currentLink,
                        year: el.innerText
                    });
            }
        });
        resultArtifact.object = laws;
        return (0, rxjs_1.of)(resultArtifact);
    };
    JSDomHook.prototype.ordinanceParse = function (inputArtifact) {
        var isOrdinanceNumber = function (el) {
            var str = el.innerText;
            if (!str || !str.length)
                return false;
            str = str.trim();
            return /^[a-zA-Z]+ n/.test(str.split('      ')[0]);
        };
        var isDecreeNumber = function (el) {
            var str = el.innerText;
            if (!str || !str.length)
                return false;
            str = str.trim();
            return /^(([0-9]|\.|[0-9])+), de ([0-9]+(\.[0-9]+)+)$/.test(str.split('      ')[0]);
        };
        var isDecreeNumberNoDots = function (el) {
            var str = el.innerText;
            if (!str || !str.length)
                return false;
            str = str.trim();
            return /^(([0-9]|\.|[0-9])+)|(([0-9])+), de ([0-9]+(\.[0-9]+)+)$/.test(str.split('      ')[0]);
        };
        var trim = function (str) {
            if (!str || !str.length)
                return null;
            return str.replace('\r\n', ' ').replace('  ', ' ').replace(' ', ' ').replace('', ' ').trim();
        };
        var resultArtifact = new nick_process_commons_1.NickProcessArtfact();
        resultArtifact.object = domutils.getElementsByTagName((function (name) { return ['td'].indexOf(name) >= 0; }), inputArtifact.object.data);
        resultArtifact.object.forEach(function (e) {
            Object.defineProperty(e, 'innerText', {
                get: function () {
                    return domutils.textContent(e).trim().replace('\r\n', ' ');
                }
            });
            e.closest = function (el) {
                var parent = e;
                do {
                    if ((parent === null || parent === void 0 ? void 0 : parent.name) == el)
                        return parent;
                    parent = parent.parent;
                } while (parent != null);
                return null;
            };
        });
        var syncId = inputArtifact.object.syncId;
        var laws = [];
        /*
         * 0: titúlo
         * 1: capítulo
         * 2: section
         * 3: article
         * 4: isParagraph
         * 5: inciso
         * 6: alinea
         * 7: item
         */
        var currentNumber = null;
        var currentLink = null;
        var index = parseInt(inputArtifact.object.index + '0000');
        resultArtifact.object.filter(function (a) {
            return a.innerText;
        })
            .forEach(function (el) {
            var value = el.innerText ? el.innerText.trim() : null;
            if (!value || !value.length)
                return;
            if (!currentNumber && (isOrdinanceNumber(el) || isDecreeNumber(el) || isDecreeNumberNoDots(el))) {
                currentNumber = el.innerText;
            }
            else if (currentNumber) {
                laws.push({
                    agregation: trim(currentNumber),
                    text: trim(el.innerText),
                    index: index,
                    source: 2,
                    syncId: syncId
                });
                index++;
                currentNumber = null;
            }
        });
        resultArtifact.object = laws;
        return (0, rxjs_1.of)(resultArtifact);
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('421b6afa-d15a-4e92-b554-8aff9a913335')
    ], JSDomHook.prototype, "parse", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('1e6a5d0e-9f9f-43cd-988e-263d92471db3')
    ], JSDomHook.prototype, "search", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('8b6482cd-2f4b-438c-8fbc-69f644442e3d')
    ], JSDomHook.prototype, "lawParse", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('c071d89f-15ea-4347-bc41-1bd7b932d4b4')
    ], JSDomHook.prototype, "decreeParse", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('a127c02d-00c4-43d3-8c30-eb88a71bc9a1')
    ], JSDomHook.prototype, "ordinanceYearParse", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('67db3073-6065-48c1-9f45-c4a12cec7eb8')
    ], JSDomHook.prototype, "ordinanceParse", null);
    JSDomHook = __decorate([
        (0, nick_process_commons_1.HookClass)('jsdom')
    ], JSDomHook);
    return JSDomHook;
}(nick_process_commons_1.BaseHook));
exports.JSDomHook = JSDomHook;
//# sourceMappingURL=jsdom.hook.js.map