"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MathHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var OperationKind;
(function (OperationKind) {
    OperationKind[OperationKind["SUM"] = 0] = "SUM";
    OperationKind[OperationKind["SUB"] = 1] = "SUB";
    OperationKind[OperationKind["MULTI"] = 2] = "MULTI";
    OperationKind[OperationKind["DIV"] = 3] = "DIV";
    OperationKind[OperationKind["PERCENT"] = 4] = "PERCENT";
    OperationKind[OperationKind["MOD"] = 5] = "MOD";
    OperationKind[OperationKind["WAVG"] = 6] = "WAVG";
})(OperationKind || (OperationKind = {}));
var MathHook = /** @class */ (function (_super) {
    __extends(MathHook, _super);
    function MathHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MathHook.prototype.operations = function (inputArtifact) {
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = {};
            var accessField$ = function (field, value) {
                var fields = field.split('.');
                return fields.reduce(function (o, i) { return (o ? o[i] : o); }, value);
            };
            if (!(inputArtifact.object.operations instanceof Array))
                throw new Error('Operations must be a Array.');
            return (0, rxjs_1.from)(inputArtifact.object.operations)
                .pipe((0, operators_1.map)(function (operation) {
                if (!operation.values)
                    operation.values = [];
                if (operation.values.length) {
                    switch (operation.kind) {
                        case OperationKind.SUM: {
                            if (operation.field)
                                operation.values = operation.values.map(function (value) { return accessField$(operation.field, value); });
                            outputArtifact.object[operation.as] = operation.values.filter(function (v) { return v != undefined; }).reduce(function (item, result) {
                                if (item == null)
                                    return parseFloat(result);
                                if (item.startsWith && item.startsWith('...'))
                                    item = outputArtifact.object[item.replace('...', '')];
                                if ((result === null || result === void 0 ? void 0 : result.startsWith) && result.startsWith('...'))
                                    result = outputArtifact.object[result.replace('...', '')];
                                if (result == null) {
                                    return parseFloat(item);
                                }
                                return parseFloat(item) + parseFloat(result);
                            });
                            break;
                        }
                        case OperationKind.SUB: {
                            if (operation.field)
                                operation.values = operation.values.map(function (value) { return accessField$(operation.field, value); });
                            outputArtifact.object[operation.as] = operation.values.filter(function (v) { return v != undefined; }).reduce(function (item, result) {
                                if (item == null)
                                    return parseFloat(result);
                                if ((item === null || item === void 0 ? void 0 : item.startsWith) && item.startsWith('...'))
                                    item = outputArtifact.object[item.replace('...', '')];
                                if ((result === null || result === void 0 ? void 0 : result.startsWith) && result.startsWith('...'))
                                    result = outputArtifact.object[result.replace('...', '')];
                                if (item == null)
                                    return 0;
                                return parseFloat(item) - parseFloat(result);
                            });
                            break;
                        }
                        case OperationKind.MULTI:
                            if (operation.field)
                                operation.values = operation.values.map(function (value) { return accessField$(operation.field, value); });
                            outputArtifact.object[operation.as] = operation.values.filter(function (v) { return v != undefined; }).reduce(function (item, result) {
                                if (result == null || item == null)
                                    return 0;
                                if (item.startsWith && item.startsWith('...'))
                                    item = outputArtifact.object[item.replace('...', '')];
                                if ((result === null || result === void 0 ? void 0 : result.startsWith) && result.startsWith('...'))
                                    result = outputArtifact.object[result.replace('...', '')];
                                return parseFloat(item) * parseFloat(result);
                            });
                            break;
                        case OperationKind.DIV:
                            if (operation.field)
                                operation.values = operation.values.map(function (value) { return accessField$(operation.field, value); });
                            outputArtifact.object[operation.as] = operation.values.filter(function (v) { return v != undefined; }).reduce(function (item, result) {
                                if (item == null)
                                    return 0;
                                if (item.startsWith && item.startsWith('...'))
                                    item = outputArtifact.object[item.replace('...', '')];
                                if ((result === null || result === void 0 ? void 0 : result.startsWith) && result.startsWith('...'))
                                    result = outputArtifact.object[result.replace('...', '')];
                                return parseFloat(item) / parseFloat(result);
                            });
                            break;
                        case OperationKind.PERCENT: {
                            if (operation.field)
                                operation.values = operation.values.map(function (value) { return accessField$(operation.field, value); });
                            outputArtifact.object[operation.as] = operation.values.filter(function (v) { return v != undefined; }).reduce(function (item, result) {
                                if (item == null)
                                    return parseFloat(result);
                                if (item.startsWith && item.startsWith('...'))
                                    item = outputArtifact.object[item.replace('...', '')];
                                if ((result === null || result === void 0 ? void 0 : result.startsWith) && result.startsWith('...'))
                                    result = outputArtifact.object[result.replace('...', '')];
                                if (item == null)
                                    return 0;
                                return (parseFloat(item) / 100) * (parseFloat(result));
                            });
                            break;
                        }
                        case OperationKind.MOD: {
                            if (operation.field)
                                operation.values = operation.values.map(function (value) { return accessField$(operation.field, value); });
                            outputArtifact.object[operation.as] = operation.values.filter(function (v) { return v != undefined; }).reduce(function (item, result) {
                                if (item == null)
                                    return parseFloat(result);
                                if (item.startsWith && item.startsWith('...'))
                                    item = outputArtifact.object[item.replace('...', '')];
                                if ((result === null || result === void 0 ? void 0 : result.startsWith) && result.startsWith('...'))
                                    result = outputArtifact.object[result.replace('...', '')];
                                if (item == null)
                                    return 0;
                                return (parseFloat(item)) % (parseFloat(result));
                            });
                            break;
                        }
                        case OperationKind.WAVG: {
                            var init = 0;
                            if (operation.field) {
                                operation.values = operation.values.map(function (value) { return accessField$(operation.field, value); });
                                operation.weights = operation.weights.map(function (weights) { return accessField$(operation.field, weights); });
                            }
                            if (operation.values.length != operation.weights.length) {
                                outputArtifact.object = { 'Error': 'Arrays With Different Sizes' };
                                break;
                            }
                            var weightValues = operation.values.filter(function (v) { return v != undefined; }).reduce(function (accumulator, item, index) {
                                if (accumulator == null)
                                    return parseFloat(item);
                                if (accumulator.startsWith && accumulator.startsWith('...'))
                                    accumulator = outputArtifact.object[accumulator.replace('...', '')];
                                if ((item === null || item === void 0 ? void 0 : item.startsWith) && item.startsWith('...'))
                                    item = outputArtifact.object[item.replace('...', '')];
                                if (accumulator == null)
                                    return 0;
                                return parseFloat(item) * operation.weights[index] + parseFloat(accumulator);
                            }, init);
                            var sumWeights = operation.weights.filter(function (w) { return w != undefined; }).reduce(function (accumulator, item) {
                                if (accumulator == null)
                                    return parseFloat(item);
                                if (accumulator.startsWith && accumulator.startsWith('...'))
                                    accumulator = outputArtifact.object[accumulator.replace('...', '')];
                                if ((item === null || item === void 0 ? void 0 : item.startsWith) && item.startsWith('...'))
                                    item = outputArtifact.object[item.replace('...', '')];
                                if (accumulator == null)
                                    return 0;
                                return (parseFloat(accumulator)) + (parseFloat(item));
                            });
                            outputArtifact.object[operation.as] = weightValues / sumWeights;
                            break;
                        }
                    }
                }
                if (isNaN(outputArtifact.object[operation.as]))
                    outputArtifact.object[operation.as] = 0;
            }), (0, operators_1.toArray)())
                .pipe((0, operators_1.concatMap)(function () {
                return (0, rxjs_1.of)(outputArtifact);
            }));
        }));
    };
    MathHook.prototype.randomNumber = function (inputArtifact) {
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.map)(function (length) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = Math.floor(100000 + Math.random() * 900000).toString();
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    MathHook.prototype.randomNumberWithLength = function (inputArtifact) {
        var artifact = new nick_process_commons_1.NickProcessArtfact();
        artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        var x = '';
        for (var i = 0; i < inputArtifact.object.config.length; i++) {
            x += Math.floor(Math.random() * 10);
        }
        artifact.object = x;
        return (0, rxjs_1.of)(artifact);
    };
    MathHook.prototype.toFixed = function (inputArtifact) {
        var artifact = new nick_process_commons_1.NickProcessArtfact();
        artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        artifact.object = parseFloat(inputArtifact.object.data).toFixed(inputArtifact.object.decimalPlaces);
        return (0, rxjs_1.of)(artifact);
    };
    MathHook.prototype.mathApply = function (inputArtifact) {
        var data = inputArtifact.object.data;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        // @ts-ignore
        if (data instanceof Array) {
            // @ts-ignore
            outputArtifact.object = Math[inputArtifact.object.config.name].apply(Math, __spreadArray([], __read(data), false));
        }
        else {
            // @ts-ignore
            outputArtifact.object = Math[inputArtifact.object.config.name](data);
        }
        return (0, rxjs_1.of)(outputArtifact);
    };
    MathHook.prototype.numberApply = function (inputArtifact) {
        var data = inputArtifact.object.data;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        // @ts-ignore
        if (data instanceof Array) {
            // @ts-ignore
            outputArtifact.object = Number[inputArtifact.object.config.name].apply(Number, __spreadArray([], __read(data), false));
        }
        else {
            // @ts-ignore
            outputArtifact.object = Number[inputArtifact.object.config.name](data);
        }
        return (0, rxjs_1.of)(outputArtifact);
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('75906b41-c9ad-492f-aab3-6f7fec34a7d4')
    ], MathHook.prototype, "operations", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('5810a282-dc7d-4b58-9466-d567783871dd')
    ], MathHook.prototype, "randomNumber", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('e20ee773-71f2-44a7-8f3f-3717565a5c89')
    ], MathHook.prototype, "randomNumberWithLength", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('50712a44-e4c8-42f7-8f68-47083e9ce787')
    ], MathHook.prototype, "toFixed", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('faf24cc2-68b4-4291-ba85-b5f2aee608af')
    ], MathHook.prototype, "mathApply", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('d027d1e2-30e8-41ba-bb4e-a55d32880dd7')
    ], MathHook.prototype, "numberApply", null);
    MathHook = __decorate([
        (0, nick_process_commons_1.HookClass)('math')
    ], MathHook);
    return MathHook;
}(nick_process_commons_1.BaseHook));
exports.MathHook = MathHook;
//# sourceMappingURL=math.hook.js.map