"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MindHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var operators_1 = require("rxjs/operators");
var http_hook_1 = require("../http/http.hook");
var MindHook = /** @class */ (function (_super) {
    __extends(MindHook, _super);
    function MindHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MindHook.prototype.startCompleteMind = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://mind.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://mind.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/77cce4d6-0b15-425e-b8d6-90c3961a9e37"),
                        params: {},
                        headers: {
                            'nick-system': '5812687f-65f8-4c95-9b5e-277eb5337bca',
                            'authorization': _this.context.token
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    MindHook.prototype.completeMind = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://mind.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://mind.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/dd6fc487-d0b8-4376-a6da-6c9829be18dc"),
                        params: {},
                        headers: {
                            'nick-system': '5812687f-65f8-4c95-9b5e-277eb5337bca',
                            'authorization': _this.context.token
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    MindHook.prototype.readDocument = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://mind.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://mind.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/8c6e4b60-4a3f-48a2-88d8-73b08cf6171c"),
                        params: {},
                        headers: {
                            'nick-system': '5812687f-65f8-4c95-9b5e-277eb5337bca',
                            'authorization': _this.context.token
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    MindHook.prototype.processAttributes = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://mind.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://mind.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/8c6e4b60-4a3f-48a2-88d8-73b08cf6171c"),
                        params: {},
                        headers: {
                            'nick-system': '5812687f-65f8-4c95-9b5e-277eb5337bca',
                            'authorization': _this.context.token
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    MindHook.prototype.uploadDocument = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://mind.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://mind.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/d5bd043c-2961-49cd-8e0e-07c5499e8161"),
                        params: {},
                        headers: {
                            'nick-system': '5812687f-65f8-4c95-9b5e-277eb5337bca',
                            'authorization': _this.context.token
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('77cce4d6-0b15-425e-b8d6-90c3961a9e37')
    ], MindHook.prototype, "startCompleteMind", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('7af46982-e441-41a8-97ef-2962d1f0c84e')
    ], MindHook.prototype, "completeMind", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('8c6e4b60-4a3f-48a2-88d8-73b08cf6171c')
    ], MindHook.prototype, "readDocument", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('4a62eb7b-6a6d-4c4b-b654-2ef43e6e131d')
    ], MindHook.prototype, "processAttributes", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('d5bd043c-2961-49cd-8e0e-07c5499e8161')
    ], MindHook.prototype, "uploadDocument", null);
    MindHook = __decorate([
        (0, nick_process_commons_1.HookClass)('mind')
    ], MindHook);
    return MindHook;
}(nick_process_commons_1.BaseHook));
exports.MindHook = MindHook;
//# sourceMappingURL=mind.hook.js.map