"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PayFiscalHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var operators_1 = require("rxjs/operators");
var http_hook_1 = require("../http/http.hook");
var PayFiscalHook = /** @class */ (function (_super) {
    __extends(PayFiscalHook, _super);
    function PayFiscalHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PayFiscalHook.prototype.createCert = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://app.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://pay.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/2c45add2-78c3-427f-a9b2-88c3b6107e05"),
                        params: {},
                        headers: {
                            'nick-system': 'c45606f4-a9c9-48cd-b63f-8c1ddca7c2f8'
                        },
                        body: {
                            certificate: inputArtifact.object.certificate,
                            password: inputArtifact.object.password,
                            establishmentId: inputArtifact.object.establishmentId
                        }
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    PayFiscalHook.prototype.createEnterprise = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://app.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://pay.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/2a187a6f-a9b0-43c7-9bf2-26b2db68f5d4"),
                        params: {},
                        headers: {
                            'nick-system': 'c45606f4-a9c9-48cd-b63f-8c1ddca7c2f8'
                        },
                        body: {
                            cpfCnpj: inputArtifact.object.cpfCnpj,
                            inscricaoMunicipal: inputArtifact.object.inscricaoMunicipal,
                            inscricaoEstadual: inputArtifact.object.inscricaoEstadual,
                            razaoSocial: inputArtifact.object.razaoSocial,
                            nomeFantasia: inputArtifact.object.nomeFantasia,
                            certificado: inputArtifact.object.certificado,
                            simplesNacional: inputArtifact.object.simplesNacional,
                            regimeTributario: inputArtifact.object.regimeTributario,
                            incentivoFiscal: inputArtifact.object.incentivoFiscal,
                            incentivadorCultural: inputArtifact.object.incentivadorCultural,
                            regimeTributarioEspecial: inputArtifact.object.regimeTributarioEspecial,
                            endereco: {
                                tipoLogradouro: inputArtifact.object.endereco.tipoLogradouro,
                                logradouro: inputArtifact.object.endereco.logradouro,
                                numero: inputArtifact.object.endereco.numero,
                                complemento: inputArtifact.object.endereco.complemento,
                                tipoBairro: inputArtifact.object.endereco.tipoBairro,
                                bairro: inputArtifact.object.endereco.bairro,
                                codigoPais: inputArtifact.object.endereco.codigoPais,
                                descricaoPais: inputArtifact.object.endereco.descricaoPais,
                                codigoCidade: inputArtifact.object.endereco.codigoCidade,
                                descricaoCidade: inputArtifact.object.endereco.descricaoCidade,
                                estado: inputArtifact.object.endereco.estado,
                                cep: inputArtifact.object.endereco.cep
                            },
                            telefone: {
                                ddd: inputArtifact.object.telefone.ddd,
                                numero: inputArtifact.object.telefone.numero
                            },
                            email: inputArtifact.object.email,
                            nfe: {
                                ativo: inputArtifact.object.nfe.ativo,
                                tipoContrato: inputArtifact.object.nfe.tipoContrato,
                                config: {
                                    producao: inputArtifact.object.nfe.config.producao,
                                    impressaoFcp: inputArtifact.object.nfe.config.impressaoFcp,
                                    impressaoPartilha: inputArtifact.object.nfe.config.impressaoPartilha,
                                    serie: inputArtifact.object.nfe.config.serie,
                                    numero: inputArtifact.object.nfe.config.numero
                                }
                            },
                            establishmentId: inputArtifact.object.establishmentId
                        }
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    PayFiscalHook.prototype.createNFe = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://app.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://pay.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/ef55792b-43f4-4d06-90ff-81c4ba8b27b6"),
                        params: {},
                        headers: {
                            'nick-system': 'c45606f4-a9c9-48cd-b63f-8c1ddca7c2f8'
                        },
                        body: {
                            notas: inputArtifact.object.notas,
                            establishmentId: inputArtifact.object.establishmentId
                        }
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('b7ecf933-fce3-4d7d-b3a1-258574983100')
    ], PayFiscalHook.prototype, "createCert", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('38525fec-351b-47bf-aa11-4780f132713b')
    ], PayFiscalHook.prototype, "createEnterprise", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('ccc8fce8-b938-4a34-91b1-e696f78274bb')
    ], PayFiscalHook.prototype, "createNFe", null);
    PayFiscalHook = __decorate([
        (0, nick_process_commons_1.HookClass)('payFiscal')
    ], PayFiscalHook);
    return PayFiscalHook;
}(nick_process_commons_1.BaseHook));
exports.PayFiscalHook = PayFiscalHook;
//# sourceMappingURL=pay.fiscal.hook.js.map