"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PayHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var http_hook_1 = require("../http/http.hook");
var moment_1 = __importDefault(require("moment"));
var PayHook = /** @class */ (function (_super) {
    __extends(PayHook, _super);
    function PayHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PayHook.prototype.creditCard = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://app.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://pay.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/a4d80104-2ee4-4add-af39-50b0a8330ef3"),
                        params: {},
                        headers: {
                            'nick-system': 'c45606f4-a9c9-48cd-b63f-8c1ddca7c2f8'
                        },
                        body: inputArtifact.object.data
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    PayHook.prototype.bankSlip = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://app.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://pay.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/2daa1639-622a-46db-9b2b-a9f871149b40"),
                        params: {},
                        headers: {
                            'nick-system': 'c45606f4-a9c9-48cd-b63f-8c1ddca7c2f8'
                        },
                        body: {
                            serviceData: inputArtifact.object.serviceData,
                            id: inputArtifact.object.id,
                            amount: inputArtifact.object.amount,
                            expireAt: inputArtifact.object.expireAt,
                            paymentLimitDate: inputArtifact.object.paymentLimitDate,
                            description: inputArtifact.object.description,
                            instructions: inputArtifact.object.instructions,
                            lateFee: inputArtifact.object.lateFee,
                            fineFee: inputArtifact.object.fineFee,
                            establishmentId: inputArtifact.object.establishmentId,
                            ourNumber: inputArtifact.object.ourNumber,
                            customer: {
                                firstName: inputArtifact.object.customer.firstName,
                                lastName: inputArtifact.object.customer.lastName,
                                email: inputArtifact.object.customer.email,
                                phone: inputArtifact.object.customer.phone,
                                document: inputArtifact.object.customer.document,
                                birthday: inputArtifact.object.customer.birthday,
                                address: {
                                    line1: inputArtifact.object.customer.address.line1,
                                    line2: inputArtifact.object.customer.address.line2,
                                    line3: inputArtifact.object.customer.address.line3,
                                    neighborhood: inputArtifact.object.customer.address.neighborhood,
                                    city: inputArtifact.object.customer.address.city,
                                    state: inputArtifact.object.customer.address.state,
                                    postalCode: inputArtifact.object.customer.address.postalCode,
                                    countryCode: inputArtifact.object.customer.address.countryCode
                                }
                            }
                        }
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    PayHook.prototype.cardToken = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://app.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://pay.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/7ca4d1d5-e479-4126-aef1-2ea994fe5300"),
                        params: {},
                        headers: {
                            'nick-system': 'c45606f4-a9c9-48cd-b63f-8c1ddca7c2f8'
                        },
                        body: {
                            serviceData: inputArtifact.object.serviceData,
                            establishmentId: inputArtifact.object.establishmentId,
                            card: {
                                number: inputArtifact.object.card.number,
                                holderName: inputArtifact.object.card.holderName,
                                securityCode: inputArtifact.object.card.securityCode,
                                expirationYear: inputArtifact.object.card.expirationYear,
                                expirationMonth: inputArtifact.object.card.expirationMonth
                            },
                            customer: {
                                firstName: inputArtifact.object.customer.firstName,
                                lastName: inputArtifact.object.customer.lastName,
                                email: inputArtifact.object.customer.email,
                                phone: inputArtifact.object.customer.phone,
                                document: inputArtifact.object.customer.document,
                                birthday: inputArtifact.object.customer.birthday,
                                address: {
                                    line1: inputArtifact.object.customer.address.line1,
                                    line2: inputArtifact.object.customer.address.line2,
                                    line3: inputArtifact.object.customer.address.line3,
                                    neighborhood: inputArtifact.object.customer.address.neighborhood,
                                    city: inputArtifact.object.customer.address.city,
                                    state: inputArtifact.object.customer.address.state,
                                    postalCode: inputArtifact.object.customer.address.postalCode,
                                    countryCode: inputArtifact.object.customer.address.countryCode
                                }
                            }
                        }
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    PayHook.prototype.getBankSlip = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://app.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://pay.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/c9227de0-8b27-4a59-aab8-abb8451d14be"),
                        params: {},
                        headers: {
                            'nick-system': 'c45606f4-a9c9-48cd-b63f-8c1ddca7c2f8'
                        },
                        body: {
                            establishmentId: inputArtifact.object.establishmentId,
                            serviceData: inputArtifact.object.serviceData,
                            ourNumber: inputArtifact.object.ourNumber
                        }
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    PayHook.prototype.createPix = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://app.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://pay.fluna.io/api/process/start/new';
                var customer = inputArtifact.object.customer ? {
                    firstName: inputArtifact.object.customer.firstName,
                    lastName: inputArtifact.object.customer.lastName,
                    email: inputArtifact.object.customer.email,
                    phone: inputArtifact.object.customer.phone,
                    document: inputArtifact.object.customer.document,
                    birthday: inputArtifact.object.customer.birthday,
                    address: {
                        line1: inputArtifact.object.customer.address.line1,
                        line2: inputArtifact.object.customer.address.line2,
                        line3: inputArtifact.object.customer.address.line3,
                        neighborhood: inputArtifact.object.customer.address.neighborhood,
                        city: inputArtifact.object.customer.address.city,
                        state: inputArtifact.object.customer.address.state,
                        postalCode: inputArtifact.object.customer.address.postalCode,
                        countryCode: inputArtifact.object.customer.address.countryCode
                    }
                } : null;
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/8384fbb6-95fa-4ef3-b30d-64c0ddc02c82"),
                        params: {},
                        headers: {
                            'nick-system': 'c45606f4-a9c9-48cd-b63f-8c1ddca7c2f8'
                        },
                        body: {
                            customer: customer,
                            establishmentId: inputArtifact.object.establishmentId,
                            expireAt: inputArtifact.object.expireAt,
                            description: inputArtifact.object.description,
                            amount: inputArtifact.object.amount
                        }
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    PayHook.prototype.getInstallmentValues = function (artifact) {
        var totalAmount = artifact.object.data.totalAmount;
        var installmentCount = artifact.object.data.installmentCount;
        var installmentAmount = parseFloat((totalAmount / installmentCount).toFixed(2));
        var residualInstallmentAmount = parseFloat((totalAmount - (installmentAmount * (installmentCount - 1))).toFixed(2));
        var residualAmount = parseFloat((residualInstallmentAmount - installmentAmount).toFixed(2));
        artifact.object.installmentAmount = installmentAmount;
        artifact.object.residualInstallmentAmount = residualInstallmentAmount;
        artifact.object.residualAmount = residualAmount;
        return (0, rxjs_1.of)(artifact);
    };
    PayHook.prototype.temp_generateBillList = function (artifact) {
        // this hook should be deprecated when flow supports these operations
        var billList = [];
        var competenceAt = artifact.object.config.competenceAt;
        var dueAt = artifact.object.config.dueAt;
        for (var i = 0; i < Object.keys(artifact.object.config.installmentList).length; i++) {
            var key = Object.keys(artifact.object.config.installmentList)[i];
            for (var j = 0; j < artifact.object.config.installmentList[key].length; j++) {
                var item = artifact.object.config.installmentList[key][j];
                if (billList[j]) {
                    var bill = billList[j];
                    bill.discount = parseFloat((bill.discount + item.discount + item.discountSale + item.discountIndication).toFixed(2));
                    bill.amount = parseFloat((bill.amount + item.amount).toFixed(2));
                    bill.item.push({
                        'name': item.name,
                        'amount': parseFloat(item.amount.toFixed(2)),
                        'discount': parseFloat(item.discount.toFixed(2)),
                        'discountIndication': parseFloat(item.discountIndication.toFixed(2)),
                        'discountSale': parseFloat(item.discountSale.toFixed(2)),
                        'kind': item.kind,
                        'index': item.index
                    });
                    billList[j] = bill;
                }
                else {
                    billList.push({
                        'amount': parseFloat(item.amount.toFixed(2)),
                        'discount': parseFloat((item.discount + item.discountSale + item.discountIndication).toFixed(2)),
                        'competenceAt': competenceAt,
                        'dueAt': dueAt,
                        'item': [{
                                'name': item.name,
                                'amount': parseFloat(item.amount.toFixed(2)),
                                'discount': parseFloat(item.discount.toFixed(2)),
                                'discountSale': parseFloat(item.discountSale.toFixed(2)),
                                'discountIndication': parseFloat(item.discountIndication.toFixed(2)),
                                'kind': item.kind,
                                'index': item.index
                            }]
                    });
                    competenceAt = (0, moment_1.default)(competenceAt).add(1, 'months').toDate();
                    dueAt = (0, moment_1.default)(dueAt).add(1, 'months').toDate();
                }
            }
        }
        artifact.object.data = billList;
        return (0, rxjs_1.of)(artifact);
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('95866102-0f69-40ef-acbe-1ec9b6fb7b14')
    ], PayHook.prototype, "creditCard", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('0ba35205-a357-46f1-ac19-141220ea59c5')
    ], PayHook.prototype, "bankSlip", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('19821f19-b3c1-48a5-b1d2-25d8fdca2238')
    ], PayHook.prototype, "cardToken", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('c53cdfaa-b96f-4674-8221-a57af3d8ae7c')
    ], PayHook.prototype, "getBankSlip", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('f0bb52f4-1017-4d03-aa80-fb2460bd0961')
    ], PayHook.prototype, "createPix", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('680204b9-9958-4cd1-9c72-a776e240e2d4')
    ], PayHook.prototype, "getInstallmentValues", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('be07ec20-22ab-4e5f-9353-5380000c730f')
    ], PayHook.prototype, "temp_generateBillList", null);
    PayHook = __decorate([
        (0, nick_process_commons_1.HookClass)('pay')
    ], PayHook);
    return PayHook;
}(nick_process_commons_1.BaseHook));
exports.PayHook = PayHook;
//# sourceMappingURL=pay.hook.js.map