"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PersonHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var operators_1 = require("rxjs/operators");
var http_hook_1 = require("../http/http.hook");
var PersonHook = /** @class */ (function (_super) {
    __extends(PersonHook, _super);
    function PersonHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PersonHook.prototype.checkIfPersonExists = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://api.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://api.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/1e036dd2-5a8a-4631-98cb-acf1a94788a9"),
                        params: {},
                        headers: {
                            'nick-system': '774bfaa5-fab2-4528-80f1-293afb8eb71d'
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    PersonHook.prototype.createPersonBySystemId = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://api.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://api.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/19d2c4d0-141e-450f-a72f-5010892c03a0"),
                        params: {},
                        headers: {
                            'nick-system': '774bfaa5-fab2-4528-80f1-293afb8eb71d'
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    PersonHook.prototype.getPersonByDocumentAndSystemId = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://api.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://api.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/b780d11e-568f-40f1-aba5-e182b97e2b39"),
                        params: {},
                        headers: {
                            'nick-system': '774bfaa5-fab2-4528-80f1-293afb8eb71d'
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('034aeabb-d168-46c0-ba73-5cb0887593af')
    ], PersonHook.prototype, "checkIfPersonExists", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('95d7e5d9-1d74-4048-9ddd-0dea613d518c')
    ], PersonHook.prototype, "createPersonBySystemId", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('429a4bf7-de06-435f-befa-cdf171a9f065')
    ], PersonHook.prototype, "getPersonByDocumentAndSystemId", null);
    PersonHook = __decorate([
        (0, nick_process_commons_1.HookClass)('perosn')
    ], PersonHook);
    return PersonHook;
}(nick_process_commons_1.BaseHook));
exports.PersonHook = PersonHook;
//# sourceMappingURL=person.hook.js.map