"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReportHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var operators_1 = require("rxjs/operators");
var http_hook_1 = require("../http/http.hook");
var ReportHook = /** @class */ (function (_super) {
    __extends(ReportHook, _super);
    function ReportHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ReportHook.prototype.report = function (inputArtifact) {
        return this.service('ReportService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.build(inputArtifact.object.config.reportId, inputArtifact.object.data);
        }));
    };
    ReportHook.prototype.report2 = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://app.local.nickbuilder.com.br/api/process/start/new/client/default'
                    : 'https://report.fluna.io/api/process/start/new/client/default';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/809dfd52-fe32-4717-8636-201799b45f46"),
                        params: {},
                        headers: {
                            'nick-system': 'ca28f8c0-76db-4be0-b446-bb93f6d63028',
                            'authorization': _this.context.token,
                            'nick-expire': 6000
                        },
                        body: inputArtifact.object.data
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('08ba4438-b185-4541-bd3f-b9abd54218e4')
    ], ReportHook.prototype, "report", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('23c36dc3-bbb4-4057-a246-7a382a1ebebf')
    ], ReportHook.prototype, "report2", null);
    ReportHook = __decorate([
        (0, nick_process_commons_1.HookClass)('report')
    ], ReportHook);
    return ReportHook;
}(nick_process_commons_1.BaseHook));
exports.ReportHook = ReportHook;
//# sourceMappingURL=report.hook.js.map