"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequestHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var RequestHook = /** @class */ (function (_super) {
    __extends(RequestHook, _super);
    function RequestHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RequestHook.prototype.getHeaders = function (inputArtifact) {
        var _a;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = (_a = this.context.request) === null || _a === void 0 ? void 0 : _a.headers[inputArtifact.object.data];
        return (0, rxjs_1.of)(outputArtifact);
    };
    RequestHook.prototype.origin = function (inputArtifact) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        if (this.context.request.headers['origin'] == null || this.context.request.headers['origin'] == 'null')
            outputArtifact.object = new URL("https://".concat(this.context.request.headers['host']));
        else
            outputArtifact.object = new URL(this.context.request.headers['origin']);
        return (0, rxjs_1.of)(outputArtifact);
    };
    RequestHook.prototype.getAuthorizationToken = function (inputArtifact) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = this.context.literalToken;
        return (0, rxjs_1.of)(outputArtifact);
    };
    RequestHook.prototype.userAgent = function (inputArtifact) {
        var _a;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = (_a = this.context.request) === null || _a === void 0 ? void 0 : _a.headers['user-agent'];
        return (0, rxjs_1.of)(outputArtifact);
    };
    RequestHook.prototype.remoteAddress = function (inputArtifact) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = this.context.request.connection.remoteAddress;
        return (0, rxjs_1.of)(outputArtifact);
    };
    RequestHook.prototype.redirect = function (inputArtifact) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = 12;
        var params = inputArtifact.object.params ? new URLSearchParams(inputArtifact.object.params) : null;
        var format$ = function (value, key) {
            if (typeof value == 'string') {
                return value.replace(new RegExp("{{".concat(key, "}}"), 'g'), inputArtifact.object.data[key]);
            }
            else if (value instanceof Array)
                value.forEach(function (templateItem) { return templateItem = format$(templateItem, key); });
            else if (value instanceof Object)
                Object.keys(value).forEach(function (property) { return value[property] = format$(value[property], key); });
            return value;
        };
        var url;
        if (inputArtifact.object.url) {
            if (inputArtifact.object.data)
                Object.keys(inputArtifact.object.data).forEach(function (key) {
                    inputArtifact.object.url = format$(inputArtifact.object.url, key);
                });
            url = new URL("".concat(inputArtifact.object.url).concat(params ? '?' + params.toString() : ''));
        }
        else if (inputArtifact.object.path) {
            if (inputArtifact.object.data)
                Object.keys(inputArtifact.object.data).forEach(function (key) {
                    inputArtifact.object.path = format$(inputArtifact.object.path, key);
                });
            url = new URL("".concat(this.context.request.headers['origin']).concat(inputArtifact.object.path));
        }
        outputArtifact.object = {
            kind: 12,
            url: url.toString()
        };
        if (inputArtifact.object.redirect)
            this.context.response.redirect(inputArtifact.object.status ? inputArtifact.object.status : 302, url.toString());
        return (0, rxjs_1.of)(outputArtifact);
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('ec378832-63b2-4363-873d-a10f961884c4')
    ], RequestHook.prototype, "getHeaders", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('c50476fd-5e0d-4c1c-9acc-e023d0775207')
    ], RequestHook.prototype, "origin", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('6908be1c-caf6-4064-9c7d-192792a9a12b')
    ], RequestHook.prototype, "getAuthorizationToken", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('4a0e7a59-e8ef-44be-bb9c-3ea5fb6f7b38')
    ], RequestHook.prototype, "userAgent", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('655a6325-a41d-44b1-baa7-8eb8ff82e5cb')
    ], RequestHook.prototype, "remoteAddress", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('bd4ccea7-f752-497d-8edf-f6df5ca2c6ff')
    ], RequestHook.prototype, "redirect", null);
    RequestHook = __decorate([
        (0, nick_process_commons_1.HookClass)('request')
    ], RequestHook);
    return RequestHook;
}(nick_process_commons_1.BaseHook));
exports.RequestHook = RequestHook;
//# sourceMappingURL=request.hook.js.map