"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SheetHook = void 0;
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var xlsx_1 = __importDefault(require("xlsx"));
var rxjs_1 = require("rxjs");
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var SheetHook = /** @class */ (function (_super) {
    __extends(SheetHook, _super);
    function SheetHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SheetHook.prototype.getSheet = function (input) {
        var workbook = xlsx_1.default.readFile(input.object.file);
        var output = new nick_process_commons_1.NickProcessArtfact();
        output.kind = nick_data_commons_1.ArtfactKind.ANY;
        output.object = workbook;
        return (0, rxjs_1.of)(output);
    };
    SheetHook.prototype.getBufferSheetToJSON = function (input) {
        var workbook = xlsx_1.default.read(input.object.buffer);
        var output = new nick_process_commons_1.NickProcessArtfact();
        output.kind = nick_data_commons_1.ArtfactKind.ANY;
        output.object = { sheetNames: workbook.SheetNames, sheets: {} };
        workbook.SheetNames.forEach(function (sheetName) {
            var data = xlsx_1.default.utils.sheet_to_json(workbook.Sheets[sheetName]);
            output.object.sheets[sheetName] = {
                columns: data.length ? Object.keys(data[0]) : [],
                data: data
            };
        });
        return (0, rxjs_1.of)(output);
    };
    SheetHook.prototype.getSheetToJSON = function (input) {
        var workbook = xlsx_1.default.readFile(input.object.file);
        var output = new nick_process_commons_1.NickProcessArtfact();
        output.kind = nick_data_commons_1.ArtfactKind.ANY;
        output.object = { sheetNames: workbook.SheetNames, sheets: {} };
        workbook.SheetNames.forEach(function (sheetName) {
            var data = xlsx_1.default.utils.sheet_to_json(workbook.Sheets[sheetName]);
            output.object.sheets[sheetName] = {
                columns: data.length ? Object.keys(data[0]) : [],
                data: data
            };
        });
        return (0, rxjs_1.of)(output);
    };
    SheetHook.prototype.JSONtoSheet = function (input) {
        var columns = input.object.config.columnsNames;
        var _headers = [];
        var ws = xlsx_1.default.utils.aoa_to_sheet([columns]);
        var enums = {};
        if (input.object.config.enums) {
            Object.keys(input.object.config.enums).forEach(function (key) {
                var enumMap = new Map();
                input.object.config.enums[key].forEach(function (item) {
                    enumMap.set(item.key, item.value);
                });
                enums[key] = enumMap;
            });
        }
        var data = input.object.data;
        if (!input.object.config.skipAttributes) {
            data = input.object.data.map(function (item) {
                var value = {};
                input.object.config.columnsAttributes.forEach(function (attr) {
                    var ops = [];
                    if (attr.split('|').length > 1) {
                        ops = attr.split('|');
                        attr = ops.shift();
                    }
                    _headers.push(attr);
                    if (attr.indexOf('.') >= 0)
                        value[attr] = attr.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, item);
                    else
                        value[attr] = item[attr];
                    ops.forEach(function (op) {
                        var _a, _b;
                        if (op.startsWith('enum:')) {
                            var enumId = op.replace('enum:', '');
                            value[attr] = enums[enumId]
                                ? (enums[enumId].has(value[attr]) ? enums[enumId].get(value[attr]) : value[attr])
                                : value[attr];
                        }
                        else if (op.startsWith('money:')) {
                            value[attr] = (((_a = value[attr]) === null || _a === void 0 ? void 0 : _a.toFixed) ? (_b = value[attr]) === null || _b === void 0 ? void 0 : _b.toFixed(2).toString().replace('.', ',') : value[attr]);
                        }
                    });
                });
                return value;
            });
        }
        xlsx_1.default.utils.sheet_add_json(ws, data, {
            header: _headers,
            skipHeader: true,
            origin: 1
        });
        var wb = xlsx_1.default.utils.book_new();
        xlsx_1.default.utils.book_append_sheet(wb, ws, input.object.config.title);
        var buffer = xlsx_1.default.write(wb, { type: 'buffer', bookType: 'xlsx' });
        var uploadArtifact = new nick_process_commons_1.NickProcessArtfact();
        uploadArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        uploadArtifact.object = {
            buffer: buffer,
            contentType: 'application/excel'
        };
        return (0, rxjs_1.of)(uploadArtifact);
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('b35a4aad-42de-487c-886d-d0b93becbb48')
    ], SheetHook.prototype, "getSheet", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('2a745b49-a35b-49af-9d54-c45eee84c80b')
    ], SheetHook.prototype, "getBufferSheetToJSON", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('02c925cd-0d39-4fd3-a668-04fba5a281a6')
    ], SheetHook.prototype, "getSheetToJSON", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('253fed6b-87ec-4ac0-8601-0e6b50bd2280')
    ], SheetHook.prototype, "JSONtoSheet", null);
    SheetHook = __decorate([
        (0, nick_process_commons_1.HookClass)('sheet')
    ], SheetHook);
    return SheetHook;
}(nick_process_commons_1.BaseHook));
exports.SheetHook = SheetHook;
//# sourceMappingURL=sheet.hook.js.map