"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SocketHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var operators_1 = require("rxjs/operators");
var SocketHook = /** @class */ (function (_super) {
    __extends(SocketHook, _super);
    function SocketHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SocketHook.prototype.emit = function (inputArtifact) {
        return this.service('SocketService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.emit(inputArtifact.object.config.roomId, inputArtifact.object.config.event, inputArtifact.object.data, inputArtifact.object.config.broadcast);
        }))
            .pipe((0, operators_1.map)(function () {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = inputArtifact.object.data;
            return outputArtifact;
        }));
    };
    SocketHook.prototype.connect = function (inputArtifact) {
        return this.service('SocketService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.connect(inputArtifact.object.config.wss, inputArtifact.object.config.onMessageFlowId, inputArtifact.object.config.onDisconnectFlowId, inputArtifact.object.config.queueName, inputArtifact.object.config.socketId);
        }))
            .pipe((0, operators_1.map)(function (id) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = id;
            return outputArtifact;
        }));
    };
    SocketHook.prototype.send = function (inputArtifact) {
        return this.service('SocketService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.send(inputArtifact.object.config.id, inputArtifact.object.data);
        }))
            .pipe((0, operators_1.map)(function (data) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = data;
            return outputArtifact;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('fccb1377-15d5-4320-82fa-13fecce01dc7')
    ], SocketHook.prototype, "emit", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('3b04ee0c-9049-4e16-b140-16fac6b22804')
    ], SocketHook.prototype, "connect", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('6ebe190e-abd7-48b6-b0b9-83cb1db7266f')
    ], SocketHook.prototype, "send", null);
    SocketHook = __decorate([
        (0, nick_process_commons_1.HookClass)('socket')
    ], SocketHook);
    return SocketHook;
}(nick_process_commons_1.BaseHook));
exports.SocketHook = SocketHook;
//# sourceMappingURL=socket.hook.js.map