"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SystemHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var uuid_1 = require("uuid");
var SystemHook = /** @class */ (function (_super) {
    __extends(SystemHook, _super);
    function SystemHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SystemHook.prototype.cloneSystem = function (inputArtifact) {
        var fromTo = new Map();
        var fromToLayers = new Map();
        var oldSystemId = inputArtifact.object.oldSystemId;
        var newSystemId = inputArtifact.object.targetSystemId;
        var layouts = inputArtifact.object.layouts;
        var layers = inputArtifact.object.layers;
        var folders = inputArtifact.object.folders;
        var routes = inputArtifact.object.routes;
        var newLayouts = [];
        var newLayoutLayersXrefs = [];
        var newLayoutsSystemXrefs = [];
        var newLayers = [];
        var newLayerSystemXrefs = [];
        var newFolders = [];
        var newRoutes = [];
        var clearAudit = function (item) {
            delete item.createdAt;
            delete item.createdBy;
            delete item.updatedAt;
            delete item.updatedBy;
            delete item.active;
        };
        // generate new layouts
        layouts.forEach(function (layout) {
            var _a;
            // clone layout
            var newId = (0, uuid_1.v4)();
            fromTo.set(layout.aliasId, newId);
            layout.aliasId = newId;
            layout.id = (0, uuid_1.v4)();
            clearAudit(layout);
            // clone layout system xref
            newId = (0, uuid_1.v4)();
            fromTo.set(layout.layoutSystemXref.aliasId, newId);
            layout.layoutSystemXref.aliasId = newId;
            layout.layoutSystemXref.id = (0, uuid_1.v4)();
            clearAudit(layout.layoutSystemXref);
            newLayoutsSystemXrefs.push(Object.assign({}, layout.layoutSystemXref));
            // clone layers
            (_a = layout.layoutLayerXrefs) === null || _a === void 0 ? void 0 : _a.forEach(function (layoutLayerXref) {
                // clone layout layer  xref
                newId = (0, uuid_1.v4)();
                fromTo.set(layoutLayerXref.aliasId, newId);
                layoutLayerXref.aliasId = newId;
                layoutLayerXref.id = (0, uuid_1.v4)();
                clearAudit(layoutLayerXref);
                newLayoutLayersXrefs.push(Object.assign({}, layoutLayerXref));
            });
            delete layout.layoutSystemXref;
            delete layout.layoutLayerXrefs;
            newLayouts.push(Object.assign({}, layout));
        });
        // generate new layers
        layers.forEach(function (layer) {
            // clone layout
            var newId = (0, uuid_1.v4)();
            fromTo.set(layer.aliasId, newId);
            fromToLayers.set(layer.aliasId, newId);
            layer.aliasId = newId;
            layer.id = (0, uuid_1.v4)();
            clearAudit(layer);
            // clone layout system xref
            newId = (0, uuid_1.v4)();
            fromTo.set(layer.layerSystemXref.aliasId, newId);
            layer.layerSystemXref.aliasId = newId;
            layer.layerSystemXref.id = (0, uuid_1.v4)();
            clearAudit(layer.layerSystemXref);
            newLayerSystemXrefs.push(Object.assign({}, layer.layerSystemXref));
            delete layer.layerSystemXref;
            newLayers.push(Object.assign({}, layer));
        });
        // generate new folders
        folders === null || folders === void 0 ? void 0 : folders.forEach(function (folder) {
            // clone layout
            var newId = (0, uuid_1.v4)();
            fromTo.set(folder.aliasId, newId);
            folder.aliasId = newId;
            folder.id = (0, uuid_1.v4)();
            clearAudit(folder);
            newFolders.push(Object.assign({}, folder));
        });
        // generate new routes
        routes === null || routes === void 0 ? void 0 : routes.forEach(function (route) {
            // clone layout
            var newId = (0, uuid_1.v4)();
            fromTo.set(route.aliasId, newId);
            route.aliasId = newId;
            route.id = (0, uuid_1.v4)();
            clearAudit(route);
            newRoutes.push(Object.assign({}, route));
        });
        // adjusts layoutsSystemXrefs
        newLayoutsSystemXrefs.forEach(function (layoutSystemXref) {
            layoutSystemXref.systemId = newSystemId;
            layoutSystemXref.layoutId = fromTo.get(layoutSystemXref.layoutId);
        });
        // adjusts layerSystemXref
        newLayerSystemXrefs.forEach(function (layerSystemXref) {
            layerSystemXref.systemId = newSystemId;
            layerSystemXref.layerId = fromTo.get(layerSystemXref.layerId);
        });
        // adjusts layoutLayersXref
        newLayoutLayersXrefs.forEach(function (layoutLayerXref) {
            layoutLayerXref.systemId = newSystemId;
            layoutLayerXref.layerId = fromTo.get(layoutLayerXref.layerId);
            layoutLayerXref.layoutId = fromTo.get(layoutLayerXref.layoutId);
        });
        // adjusts routes
        newRoutes.forEach(function (route) {
            route.systemId = newSystemId;
            route.redirectId = route.redirectId ? fromTo.get(route.layoutSystemId) : null;
            route.layoutSystemId = fromTo.get(route.layoutSystemId);
            route.layerSystemId = fromTo.get(route.layerSystemId);
        });
        // adjusts folders
        newFolders.forEach(function (folder) {
            folder.systemId = newSystemId;
            folder.parentFolderId = folder.parentFolderId ? fromTo.get(folder.parentFolderId) : null;
        });
        // adjust layouts
        newLayouts.forEach(function (layout) {
            if (layout.html) {
                Array.from(fromToLayers.keys()).forEach(function (oldId) {
                    layout.html = layout.html.replace(new RegExp(oldId, 'g'), fromToLayers.get(oldId));
                });
            }
        });
        // adjust layers
        newLayers.forEach(function (layer) {
            layer.folderId = layer.folderId ? fromTo.get(layer.folderId) : null;
            if (layer.html) {
                Array.from(fromToLayers.keys()).forEach(function (oldId) {
                    layer.html = layer.html.replace(new RegExp(oldId, 'g'), fromToLayers.get(oldId));
                });
            }
        });
        var artifact = new nick_process_commons_1.NickProcessArtfact();
        artifact.object = {
            layouts: newLayouts,
            layoutLayerXrefs: newLayoutLayersXrefs,
            layoutSystemXrefs: newLayoutsSystemXrefs,
            layers: newLayers,
            layerSystemXrefs: newLayerSystemXrefs,
            folders: newFolders,
            routes: newRoutes
        };
        artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        return (0, rxjs_1.of)(artifact);
    };
    SystemHook.prototype.getEnvironment = function (inputArtifact) {
        return this.service('SystemService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.getEnvironment(inputArtifact.object.systemId);
        }))
            .pipe((0, operators_1.map)(function (environment) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.object = environment;
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return outputArtifact;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('fbb54315-8d53-4597-9ff4-c599f291e312')
    ], SystemHook.prototype, "cloneSystem", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('186093e5-4fdd-42cd-aa7c-57d521dfd86a')
    ], SystemHook.prototype, "getEnvironment", null);
    SystemHook = __decorate([
        (0, nick_process_commons_1.HookClass)('SystemHook')
    ], SystemHook);
    return SystemHook;
}(nick_process_commons_1.BaseHook));
exports.SystemHook = SystemHook;
//# sourceMappingURL=system.hook.js.map