"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var TextHook = /** @class */ (function () {
    function TextHook() {
    }
    TextHook.prototype.templateReplace = function (input) {
        var template = input.object.config.template;
        var format$ = function (value, key) {
            if (typeof value == 'string') {
                return value.replace(new RegExp("{{".concat(key, "}}"), 'g'), input.object.data[key]);
            }
            else if (value instanceof Array)
                value.forEach(function (templateItem) { return templateItem = format$(templateItem, key); });
            else if (value instanceof Object)
                Object.keys(value).forEach(function (property) { return value[property] = format$(value[property], key); });
            return value;
        };
        Object.keys(input.object.data).forEach(function (key) {
            template = format$(template, key);
        });
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = template;
        return (0, rxjs_1.of)(outputArtifact);
    };
    TextHook.prototype.regexReplace = function (input) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = input.object.data.replace(new RegExp(input.object.regex, 'g'), input.object.replace);
        return (0, rxjs_1.of)(outputArtifact);
    };
    TextHook.prototype.split = function (input) {
        var _a;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        if ((_a = input.object.data.value) === null || _a === void 0 ? void 0 : _a.split)
            outputArtifact.object = input.object.data.value.split("".concat(input.object.config.separator));
        return (0, rxjs_1.of)(outputArtifact);
    };
    TextHook.prototype.fromBase64 = function (input) {
        var _a;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        if ((_a = input.object.config) === null || _a === void 0 ? void 0 : _a.toString)
            outputArtifact.object = Buffer.from(input.object.data, 'base64').toString();
        else
            outputArtifact.object = Buffer.from(input.object.data, 'base64');
        return (0, rxjs_1.of)(outputArtifact);
    };
    TextHook.prototype.join = function (input) {
        var _a, _b, _c;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = null;
        var value = input.object.data;
        if ((_b = (_a = input.object.config) === null || _a === void 0 ? void 0 : _a.field) === null || _b === void 0 ? void 0 : _b.split)
            value = input.object.data
                .map(function (_value) {
                var _a;
                return (_a = input.object.config) === null || _a === void 0 ? void 0 : _a.field.split('.').reduce(function (o, i) { return (o ? o[i] : o); }, _value);
            });
        if (value === null || value === void 0 ? void 0 : value.join)
            outputArtifact.object = value.join("".concat((_c = input.object.config) === null || _c === void 0 ? void 0 : _c.separator));
        return (0, rxjs_1.of)(outputArtifact);
    };
    TextHook.prototype.formatMoney = function (input) {
        var _a, _b, _c, _d;
        var template;
        var toBd;
        if (((_b = (_a = input === null || input === void 0 ? void 0 : input.object) === null || _a === void 0 ? void 0 : _a.config) === null || _b === void 0 ? void 0 : _b.toBD) == undefined || ((_d = (_c = input === null || input === void 0 ? void 0 : input.object) === null || _c === void 0 ? void 0 : _c.config) === null || _d === void 0 ? void 0 : _d.toBD) == 'false')
            toBd = false;
        else
            toBd = true;
        switch (input.object.config.currency) {
            case 'BRL':
                template = 'R$ ';
                break;
            case 'USD':
                template = 'US$ ';
                break;
            case 'NONE':
                template = '';
                break;
        }
        return (0, rxjs_1.from)(Object.keys(input.object.data))
            .pipe((0, operators_1.map)(function (key) {
            if (toBd) {
                if (input.object.data[key] != undefined)
                    input.object.data[key] = (parseFloat((input.object.data[key]).toString().replace(new RegExp(/\./, 'g'), '').replace(',', '.')).toFixed(3)).toString();
                else
                    input.object.data[key] = null;
            }
            else {
                input.object.data[key] = (parseFloat(input.object.data[key]).toFixed(2).toString().replace(new RegExp(/\./, 'g'), ','));
                input.object.data[key] = template.concat(input.object.data[key]);
            }
        }), (0, operators_1.toArray)())
            .pipe((0, operators_1.concatMap)(function () {
            return (0, rxjs_1.of)(input);
        }));
    };
    TextHook.prototype.validateRegex = function (input) {
        var regex = new RegExp(input.object.config.regex);
        var value = input.object.data;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = {};
        outputArtifact.object.isValid = regex.test(value);
        return (0, rxjs_1.of)(outputArtifact);
    };
    TextHook.prototype.parseByReference = function (input) {
        var _a, _b, _c, _d;
        var source = input.object.data;
        if (((_b = (_a = input.object) === null || _a === void 0 ? void 0 : _a.config) === null || _b === void 0 ? void 0 : _b.split) && ((_d = (_c = input.object) === null || _c === void 0 ? void 0 : _c.data) === null || _d === void 0 ? void 0 : _d.split))
            source = input.object.data.split(input.object.config.splitChar);
        var parse$ = function (value) {
            if (value instanceof Array)
                value = value.map(function (templateItem) { return parse$(templateItem); });
            else if (value instanceof Object)
                Object.keys(value).forEach(function (property) { return value[property] = parse$(value[property]); });
            else
                return value = input.object.config.terms[value];
            return value;
        };
        if (source != undefined)
            source = parse$(source);
        else
            source = input.object.config.default;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = source;
        return (0, rxjs_1.of)(outputArtifact);
    };
    TextHook.prototype.stringToJson = function (inputArtifact) {
        var dataToParse = inputArtifact.object.data;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = JSON.parse(dataToParse);
        return (0, rxjs_1.of)(outputArtifact);
    };
    TextHook.prototype.stringApply = function (input) {
        var _a;
        var data = input.object.data;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        // @ts-ignore
        if (data instanceof Array) {
            // @ts-ignore
            outputArtifact.object = (_a = String.prototype[input.object.config.name]).apply.apply(_a, __spreadArray([], __read(data), false));
        }
        else {
            // @ts-ignore
            outputArtifact.object = String.prototype[input.object.config.name].apply(data);
        }
        return (0, rxjs_1.of)(outputArtifact);
    };
    TextHook.prototype.objectToArray = function (input) {
        var data = input.object.data;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        // Check if data is an object and if is null
        if (typeof data === 'object' && data !== null) {
            // Apply the Object.entries() method to the object and map it
            outputArtifact.object = Object.entries(data).map(function (_a) {
                var _b = __read(_a, 2), key = _b[0], value = _b[1];
                return ({ key: key, value: value });
            });
        }
        else {
            // Exception
            throw new Error('Not an object');
        }
        return (0, rxjs_1.of)(outputArtifact);
    };
    TextHook.prototype.objectAssign = function (input) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = Object.assign.apply(Object, __spreadArray([{}], __read(input.object.data), false));
        return (0, rxjs_1.of)(outputArtifact);
    };
    TextHook.prototype.turnKeysAndValuesToObject = function (input) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = input.object.data;
        // Check if data is an array and if is null
        if (input.object.data !== null) {
            input.object.data.forEach(function (item) {
                if (item[input.object.config.attributesKey] instanceof Array) {
                    var transformedObject_1 = {};
                    item[input.object.config.attributesKey].forEach(function (pick) {
                        var fieldKey = input.object.config.fieldKey.split('.')
                            .reduce(function (o, i) { return (o ? o[i] : o); }, pick);
                        var fieldValue = input.object.config.fieldValue.split('.')
                            .reduce(function (o, i) { return (o ? o[i] : o); }, pick);
                        transformedObject_1[fieldKey] = fieldValue;
                    });
                    item[input.object.config.attributesKey] = transformedObject_1;
                }
            });
        }
        else {
            // Exception
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ERROR;
            outputArtifact.object = new Error('Not an Array');
            return (0, rxjs_1.of)(outputArtifact);
        }
        outputArtifact.object = input.object.data;
        return (0, rxjs_1.of)(outputArtifact);
    };
    TextHook.prototype.encode = function (input) {
        var data = input.object.data;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = encodeURI(data);
        return (0, rxjs_1.of)(outputArtifact);
    };
    TextHook.prototype.decode = function (input) {
        var data = input.object.data;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = decodeURI(data);
        return (0, rxjs_1.of)(outputArtifact);
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('75e7df1c-db91-4222-84ae-f9bd69c1d9e4')
    ], TextHook.prototype, "templateReplace", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('c614ef5f-cdcc-47a2-87ba-14fb0ef833bf')
    ], TextHook.prototype, "regexReplace", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('1485418e-2261-46f4-a965-046add3b41c0')
    ], TextHook.prototype, "split", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('3217b0f7-1453-46aa-bc58-d792055793c8')
    ], TextHook.prototype, "fromBase64", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('79212ba4-ab90-4492-b611-55e137b102f9')
    ], TextHook.prototype, "join", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('c762feb3-6691-45cf-97d0-86f44e1d3f46')
    ], TextHook.prototype, "formatMoney", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('76d47171-63a7-4836-8b0b-406fbd2d548f')
    ], TextHook.prototype, "validateRegex", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('bbcd6af1-271c-4602-869a-251ec26db068')
    ], TextHook.prototype, "parseByReference", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('532515f6-099a-4168-8c0d-b65538b2367f')
    ], TextHook.prototype, "stringToJson", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('a7f2424e-c3ed-4949-8327-62e642374094')
    ], TextHook.prototype, "stringApply", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('8abce1bb-d50b-47b2-aea0-711a8bf765e5')
    ], TextHook.prototype, "objectToArray", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('606108aa-2303-44f8-9e6d-3cb7f0d8c828')
    ], TextHook.prototype, "objectAssign", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('a2abffa3-4c70-4e71-b6cd-81f3a561493c')
    ], TextHook.prototype, "turnKeysAndValuesToObject", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('bf46fb5f-6bf7-45f1-a2d3-bf88e34e762c')
    ], TextHook.prototype, "encode", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('4f2d1081-fc0a-449c-b9ca-fc83383cffd9')
    ], TextHook.prototype, "decode", null);
    TextHook = __decorate([
        (0, nick_process_commons_1.HookClass)('text')
    ], TextHook);
    return TextHook;
}());
exports.TextHook = TextHook;
//# sourceMappingURL=text.hook.js.map