"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.e06b7def_ac84_44e1_b267_be760ba2a809_DateHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var moment_1 = __importDefault(require("moment"));
var rxjs_1 = require("rxjs");
var e06b7def_ac84_44e1_b267_be760ba2a809_DateHook = /** @class */ (function (_super) {
    __extends(e06b7def_ac84_44e1_b267_be760ba2a809_DateHook, _super);
    function e06b7def_ac84_44e1_b267_be760ba2a809_DateHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    e06b7def_ac84_44e1_b267_be760ba2a809_DateHook.prototype.generateAvailableSlots = function (inputArtifact) {
        var slotsAvailables = [];
        var slotsAt = (0, moment_1.default)(inputArtifact.object.config.generateSlotsAt).toDate();
        var slotsDay = slotsAt.getDay().toString();
        var weekDays = inputArtifact.object.data.weekDays;
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        outputArtifact.object = {
            config: {},
            data: slotsAvailables
        };
        // se o dia da semana da data que se deseja obter os slots não estiver dentro da lista de dias, nem executa a função
        if (!weekDays.includes(slotsDay)) {
            return (0, rxjs_1.of)(outputArtifact);
        }
        var slotAtInGetTime = new Date(slotsAt.getTime()).setUTCHours(12, 0, 0, 0);
        var worksheetStartAt = (0, moment_1.default)(inputArtifact.object.data.startAt).toDate();
        var worksheetEndAt = (0, moment_1.default)(inputArtifact.object.data.endAt).toDate();
        var zeroHour = worksheetStartAt.getUTCHours() + worksheetStartAt.getUTCMinutes() + worksheetStartAt.getUTCSeconds();
        if (zeroHour == 0) {
            slotAtInGetTime = slotAtInGetTime + 86400000;
        }
        var startAt = new Date(worksheetStartAt.getTime()).setUTCHours(0, 0, 0, 0);
        var endAt = new Date(worksheetEndAt.getTime()).setUTCHours(23, 59, 59, 0);
        // se a data que se deseja obter os slots não existir dentro do range de datas do worksheet, nem executa a função
        if (slotAtInGetTime < startAt || slotAtInGetTime > endAt) {
            return (0, rxjs_1.of)(outputArtifact);
        }
        // verifica automaticamente pela própria configuração da worksheet se controla conflitos ou não
        var myListExistsEvents = [];
        if (!inputArtifact.object.data.isFreeSchedule && inputArtifact.object.config.excludeSlotList && inputArtifact.object.config.excludeSlotList.length > 0) {
            myListExistsEvents = inputArtifact.object.config.excludeSlotList;
            myListExistsEvents.forEach(function (item) {
                if (typeof (item.day) == 'string')
                    item.day = (0, moment_1.default)(item.day).toDate();
                if (typeof (item.dayEnd) == 'string')
                    item.dayEnd = (0, moment_1.default)(item.dayEnd).toDate();
            });
        }
        // definir o range de horas para a data que se deseja obter os slots
        startAt = new Date(slotAtInGetTime).setUTCHours(worksheetStartAt.getUTCHours(), worksheetStartAt.getMinutes(), 0, 0);
        endAt = new Date(slotAtInGetTime).setUTCHours(worksheetEndAt.getUTCHours(), worksheetEndAt.getMinutes(), 0, 0);
        if ((endAt - startAt) < 0) {
            endAt = endAt + 86400000;
        }
        var intervalDefaultInMinutes = 1000 * 60;
        var interval = Number(inputArtifact.object.data.interval);
        var intervalIncrement = intervalDefaultInMinutes * interval;
        var dataHoraBase = startAt;
        // achar a difereça absoluta entre os horários de inicio e fim do turno dividido pela base de minutos do dia
        var diffHours = Math.abs(endAt - startAt) / intervalDefaultInMinutes;
        var totalSlotsNumber = Math.trunc(diffHours / interval);
        if (totalSlotsNumber) {
            var _loop_1 = function (i, len) {
                var newStartAt = new Date(dataHoraBase);
                var newEndAt = new Date(dataHoraBase + intervalIncrement);
                dataHoraBase = newEndAt.getTime();
                var verifyNewDatesInMyArray = myListExistsEvents.some(function (element) { return (newStartAt.getTime() >= element.day.getTime() && newStartAt.getTime() < element.dayEnd.getTime()) || (newEndAt.getTime() > element.day.getTime() && newEndAt.getTime() <= element.dayEnd.getTime()); });
                if (!verifyNewDatesInMyArray) {
                    var newSlot = {
                        day: newStartAt,
                        dayEnd: newEndAt
                    };
                    var verifyMyArrayInNewDates = myListExistsEvents.some(function (element) { return (element.day.getTime() >= newStartAt.getTime() && element.day.getTime() < newEndAt.getTime()) || (element.dayEnd.getTime() > newStartAt.getTime() && element.dayEnd.getTime() <= newEndAt.getTime()); });
                    if (!verifyMyArrayInNewDates)
                        slotsAvailables.push(newSlot);
                }
            };
            for (var i = 0, len = totalSlotsNumber; i < len; ++i) {
                _loop_1(i, len);
            }
        }
        outputArtifact.object.config = {
            excludeSlotList: myListExistsEvents,
            totalSlotsNumber: totalSlotsNumber,
            diffHours: diffHours,
            dataHoraBase: dataHoraBase,
            intervalIncrement: intervalIncrement,
            interval: interval,
            endAt: endAt,
            startAt: startAt,
            slotAtInGetTime: slotAtInGetTime,
            worksheetEndAt: worksheetEndAt,
            worksheetStartAt: worksheetStartAt,
            weekDays: weekDays,
            slotsAt: slotsAt,
            slotsDay: slotsDay,
            worksheet: inputArtifact.object.data
        };
        return (0, rxjs_1.of)(outputArtifact);
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('c224ccca-fedd-42ca-a292-34462a49e84f')
    ], e06b7def_ac84_44e1_b267_be760ba2a809_DateHook.prototype, "generateAvailableSlots", null);
    e06b7def_ac84_44e1_b267_be760ba2a809_DateHook = __decorate([
        (0, nick_process_commons_1.HookClass)('e06b7def-ac84-44e1-b267-be760ba2a809.date')
    ], e06b7def_ac84_44e1_b267_be760ba2a809_DateHook);
    return e06b7def_ac84_44e1_b267_be760ba2a809_DateHook;
}(nick_process_commons_1.BaseHook));
exports.e06b7def_ac84_44e1_b267_be760ba2a809_DateHook = e06b7def_ac84_44e1_b267_be760ba2a809_DateHook;
//# sourceMappingURL=date.hook.js.map