"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var operators_1 = require("rxjs/operators");
var UserHook = /** @class */ (function (_super) {
    __extends(UserHook, _super);
    function UserHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UserHook.prototype.getUserDetailByUserId = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.getUserDetailByUserId(inputArtifact.object.userId);
        }))
            .pipe((0, operators_1.map)(function (user) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = user;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    UserHook.prototype.getUserDetailByUserIdAndSystemId = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.getUserDetailByUserIdAndSystemId(inputArtifact.object.userId, inputArtifact.object.systemId);
        }))
            .pipe((0, operators_1.map)(function (user) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = user;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    UserHook.prototype.getUserDetailByUsername = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.getUserDetailByUsername(inputArtifact.object.username);
        }))
            .pipe((0, operators_1.map)(function (user) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = user;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    UserHook.prototype.updateUserInfo = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.updateUserInfo(inputArtifact.object.data);
        }))
            .pipe((0, operators_1.map)(function (user) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = user;
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            return artifact;
        }));
    };
    UserHook.prototype.disableUser = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.disableUser(inputArtifact.object.userId);
        }))
            .pipe((0, operators_1.map)(function (user) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = user;
            return artifact;
        }));
    };
    UserHook.prototype.enableUser = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.enableUser(inputArtifact.object.userId);
        }))
            .pipe((0, operators_1.map)(function (user) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = user;
            return artifact;
        }));
    };
    UserHook.prototype.deleteUser = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.deleteUser(inputArtifact.object.userId);
        }))
            .pipe((0, operators_1.map)(function (user) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = user;
            return artifact;
        }));
    };
    UserHook.prototype.loadRuleGroup = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.loadRuleGroup(inputArtifact.object.systemId, inputArtifact.object.page, inputArtifact.object.pageSize);
        }))
            .pipe((0, operators_1.map)(function (user) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = user;
            return artifact;
        }));
    };
    UserHook.prototype.changeUserRuleGroupId = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.changeUserRuleGroupId(inputArtifact.object.userId, inputArtifact.object.ruleGroupId);
        }))
            .pipe((0, operators_1.map)(function (user) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = user;
            return artifact;
        }));
    };
    UserHook.prototype.changeUserPassword = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.changeUserPassword(inputArtifact.object.userId, inputArtifact.object.password);
        }))
            .pipe((0, operators_1.map)(function (user) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = user;
            return artifact;
        }));
    };
    UserHook.prototype.createUpdateRuleGroup = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.createUpdateRuleGroup(inputArtifact.object.data);
        }))
            .pipe((0, operators_1.map)(function (user) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = user;
            return artifact;
        }));
    };
    UserHook.prototype.changeUserPasswordWithSystemId = function (inputArtifact) {
        return this.service('AuthSecurityService')
            .pipe((0, operators_1.concatMap)(function (service) {
            return service.changeUserPasswordWithSystemId(inputArtifact.object.userId, inputArtifact.object.password, inputArtifact.object.systemId);
        }))
            .pipe((0, operators_1.map)(function (user) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.object = user;
            return artifact;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('31e06812-95d8-4af7-ba13-06b6f5bd5de7')
    ], UserHook.prototype, "getUserDetailByUserId", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('ba3c079c-90f3-4f66-b365-72c1539632cc')
    ], UserHook.prototype, "getUserDetailByUserIdAndSystemId", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('b60bc085-21b5-4bf5-befa-e44b87c97edd')
    ], UserHook.prototype, "getUserDetailByUsername", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('0738c96c-c9f8-4eb8-b707-fc8686dd9640')
    ], UserHook.prototype, "updateUserInfo", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('f5f9159e-f5c7-48e1-ad4b-90256297428b')
    ], UserHook.prototype, "disableUser", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('a0b3a040-b383-4e48-a4c2-903c0057d818')
    ], UserHook.prototype, "enableUser", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('6aa089fd-6b63-4702-8c66-7721870f2b48')
    ], UserHook.prototype, "deleteUser", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('ec120769-bab4-4e67-a63f-7ef84bdae0f9')
    ], UserHook.prototype, "loadRuleGroup", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('d7a12fcd-a599-4629-818f-c0a41fb3089c')
    ], UserHook.prototype, "changeUserRuleGroupId", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('c0495ea9-32d4-4f8b-b937-61a3e708ea8a')
    ], UserHook.prototype, "changeUserPassword", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('c192aaa9-6704-4696-9338-2a0fa58c255b')
    ], UserHook.prototype, "createUpdateRuleGroup", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('b3104785-b23c-45c1-b3ae-3f8d63e928d3')
    ], UserHook.prototype, "changeUserPasswordWithSystemId", null);
    UserHook = __decorate([
        (0, nick_process_commons_1.HookClass)('user')
    ], UserHook);
    return UserHook;
}(nick_process_commons_1.BaseHook));
exports.UserHook = UserHook;
//# sourceMappingURL=user.hook.js.map