"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkflowHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var operators_1 = require("rxjs/operators");
var http_hook_1 = require("../http/http.hook");
var WorkflowHook = /** @class */ (function (_super) {
    __extends(WorkflowHook, _super);
    function WorkflowHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WorkflowHook.prototype.getTaskByStep = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://workflow.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://workflow.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/8130ea1f-85ac-4525-b232-7bd42c8b2305"),
                        params: {},
                        headers: {
                            'nick-system': '6e6ed079-7dab-4b7b-b1ad-05043f714596',
                            'authorization': _this.context.token
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    WorkflowHook.prototype.createSubTask = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://workflow.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://workflow.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/65cea449-fa10-4f4c-8225-196cefabbba1"),
                        params: {},
                        headers: {
                            'nick-system': '6e6ed079-7dab-4b7b-b1ad-05043f714596',
                            'authorization': _this.context.token
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    WorkflowHook.prototype.updateTask = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://workflow.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://workflow.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/628e2a06-1de6-4cab-baeb-861642456b0e"),
                        params: {},
                        headers: {
                            'nick-system': '6e6ed079-7dab-4b7b-b1ad-05043f714596',
                            'authorization': _this.context.token
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    WorkflowHook.prototype.completeTasks = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://workflow.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://workflow.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/a1299c37-d7d2-4ca9-ac76-79f712eb8db0"),
                        params: {},
                        headers: {
                            'nick-system': '6e6ed079-7dab-4b7b-b1ad-05043f714596',
                            'authorization': _this.context.token
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    WorkflowHook.prototype.moveTask = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://workflow.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://workflow.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/60b2892d-f9dc-4e4c-9da4-0b4ad0fc0dfc"),
                        params: {},
                        headers: {
                            'nick-system': '6e6ed079-7dab-4b7b-b1ad-05043f714596',
                            'authorization': _this.context.token
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    WorkflowHook.prototype.prepareRunWorkflow = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://workflow.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://workflow.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/8716b115-6113-42dd-8304-290a82922285"),
                        params: {},
                        headers: {
                            'nick-system': '6e6ed079-7dab-4b7b-b1ad-05043f714596',
                            'authorization': _this.context.token
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    WorkflowHook.prototype.getTaskByParentTaskId = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://workflow.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://workflow.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/8163e5a8-3128-48f9-ab3b-f7cb88b8cf59"),
                        params: {},
                        headers: {
                            'nick-system': '6e6ed079-7dab-4b7b-b1ad-05043f714596',
                            'authorization': _this.context.token
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    WorkflowHook.prototype.createAttachment = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://workflow.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://workflow.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/27820908-2a82-4839-b4d3-f039e32705fa"),
                        params: {},
                        headers: {
                            'nick-system': '6e6ed079-7dab-4b7b-b1ad-05043f714596',
                            'authorization': _this.context.token
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    WorkflowHook.prototype.getTasksByParentExecutionId = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://workflow.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://workflow.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/74d5835b-2ffa-460d-91b7-74fc457bf470"),
                        params: {},
                        headers: {
                            'nick-system': '6e6ed079-7dab-4b7b-b1ad-05043f714596',
                            'authorization': _this.context.token
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    WorkflowHook.prototype.createUpdateExecutionTags = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://workflow.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://workflow.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/edd1d7a7-bd44-48e9-ae48-de1beb07811d"),
                        params: {},
                        headers: {
                            'nick-system': '6e6ed079-7dab-4b7b-b1ad-05043f714596',
                            'authorization': _this.context.token
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    WorkflowHook.prototype.downloadAttachment = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://workflow.local.nickbuilder.com.br/api/process/start/new'
                    : 'https://workflow.fluna.io/api/process/start/new';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/803e7dc7-fc18-4aac-b2ce-9b45b8a0b3c5"),
                        params: {},
                        headers: {
                            'nick-system': '6e6ed079-7dab-4b7b-b1ad-05043f714596',
                            'authorization': _this.context.token
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('cb8f58b3-d47e-4e1d-b76f-05fdc378040a')
    ], WorkflowHook.prototype, "getTaskByStep", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('cac28743-8564-457c-9b1d-10413f734e64')
    ], WorkflowHook.prototype, "createSubTask", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('a60cf813-a773-4d1b-96c5-70afebb68d16')
    ], WorkflowHook.prototype, "updateTask", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('d66c11d2-fc17-4475-8914-dde5396fdbb5')
    ], WorkflowHook.prototype, "completeTasks", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('222278bd-ec85-43b6-8cee-0c58248d8e1f')
    ], WorkflowHook.prototype, "moveTask", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('2a15e9b6-9fdb-46c5-b098-70967829c071')
    ], WorkflowHook.prototype, "prepareRunWorkflow", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('7d8315f5-6fdd-4b25-b4df-8dfd7b0f276e')
    ], WorkflowHook.prototype, "getTaskByParentTaskId", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('824164df-5f09-417d-a7e9-b07010604ca6')
    ], WorkflowHook.prototype, "createAttachment", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('66e7d01a-deae-4eee-8750-c37dd6089f9a')
    ], WorkflowHook.prototype, "getTasksByParentExecutionId", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('34ee06a4-a5d2-4690-b40b-0bf587ec715f')
    ], WorkflowHook.prototype, "createUpdateExecutionTags", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('8292d81f-4291-45d5-9839-58872fe48c9b')
    ], WorkflowHook.prototype, "downloadAttachment", null);
    WorkflowHook = __decorate([
        (0, nick_process_commons_1.HookClass)('workflow')
    ], WorkflowHook);
    return WorkflowHook;
}(nick_process_commons_1.BaseHook));
exports.WorkflowHook = WorkflowHook;
//# sourceMappingURL=workflow.hook.js.map