"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.XmlHook = void 0;
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var rxjs_1 = require("rxjs");
var xml_js_1 = require("xml-js");
var operators_1 = require("rxjs/operators");
var XmlHook = /** @class */ (function (_super) {
    __extends(XmlHook, _super);
    function XmlHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    XmlHook.prototype.xml2Json = function (inputArtifact) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        return new rxjs_1.Observable(function (observer) {
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            try {
                var isBuffer = inputArtifact.object.xml instanceof Buffer;
                var chunks_1 = [];
                var resultString_1 = '';
                if (isBuffer) {
                    outputArtifact.object = JSON.parse((0, xml_js_1.xml2json)(inputArtifact.object.xml.toString(), inputArtifact.object.config));
                    observer.next(outputArtifact);
                    observer.complete();
                }
                else {
                    var reader = inputArtifact.object.xml;
                    reader.on('data', function (buf) { return chunks_1.push(buf); });
                    reader.on('end', function () {
                        resultString_1 = Buffer.concat(chunks_1).toString();
                        outputArtifact.object = JSON.parse((0, xml_js_1.xml2json)(resultString_1, inputArtifact.object.config));
                        observer.next(outputArtifact);
                        observer.complete();
                    });
                }
            }
            catch (e) {
                console.log('Error to parse xml.');
                // throw new Error('Error to parse xml.');
            }
            // return of(outputArtifact);
        });
    };
    XmlHook.prototype.json2Xml = function (inputArtifact) {
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.map)(function () {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            try {
                outputArtifact.object = (0, xml_js_1.json2xml)(inputArtifact.object.data, inputArtifact.object.config);
            }
            catch (e) {
                throw new Error('Error to parse xml.');
            }
            return outputArtifact;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('a4557a36-ebea-4a3d-8fe9-98538ebf8668')
    ], XmlHook.prototype, "xml2Json", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('c527afea-1e75-4d69-b031-c82995271e4c')
    ], XmlHook.prototype, "json2Xml", null);
    XmlHook = __decorate([
        (0, nick_process_commons_1.HookClass)('xml')
    ], XmlHook);
    return XmlHook;
}(nick_process_commons_1.BaseHook));
exports.XmlHook = XmlHook;
//# sourceMappingURL=xml.hook.js.map